/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"




/*
List of funtiocs here:

The funtion here draw things onto screen, it does not do any calculations. drawing is seperated from the code for clearity.

void draw_select_puzzle_box(short m,short n,short value,short mode)
void draw_unselect_puzzle_box(short m,short n)
void draw_select_pick_box(short pick_box_number)
void draw_highlight_pick_box(short pick_box_number)
void draw_original_pick_box (short pick_box_number)
void draw_line(short m,short n, short p,short q)
void draw_pencil_in(short m,short n,short mode)
void draw_score(short mode,short score)
void draw_empty_puzzle()
void draw_puzzle()



*/


//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88draw_select_puzzle_box8888888888888888888888888888888888888888888888888888888888888888888


void draw_select_puzzle_box(short m,short n,short value,short mode)
{

  short k;
  short x,y,size;
  short pencil_x,pencil_y,pencil_size;
  short total_width=0;
  short total_height=0;  
  short text_x,text_y;
  short pencil_in_xspacing=1;
  short pencil_in_yspacing=-1;
  int text_w;
  int text_h;
  char ch[2];
  
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;
  
  GdkRectangle update_rect; 
  
  // mode 0, draws everything
  // mode 1, draws the selected value without boundry       
  // mode 2, doesnt draws to the screen
  // mode 3, doesnt draws to the screen  

  x=puzzle_box[m][n].x+1;
  y=puzzle_box[m][n].y+1;
  size=puzzle_box_square_size-1;
  pencil_x=puzzle_box[m][n].x+3;
  pencil_y=puzzle_box[m][n].y+3;
  pencil_size=puzzle_box_square_size-5;
  
  update_rect.x = x;
  update_rect.y = y;
  update_rect.width = size;
  update_rect.height = size;
  
  if(value==-1 && mode==1)  //for erasing
  {
    
    gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
    gdk_draw_rectangle (pixmap,
                        gc,
                        TRUE,
                        x+2,y+2,
                        size-4,
                        size-4);      
  }
  
  
  if(value != -1)
  {
    if(puzzle_box[m][n].type!=1)
    {
      gdk_gc_set_foreground(gc,&color.puzzle_bg);
      gdk_draw_rectangle (pixmap,gc,TRUE,x,y,size,size);      
    }
    else
    {
      gdk_gc_set_foreground(gc,&color.num_fixed_box_bg);
      gdk_draw_rectangle (pixmap,gc,TRUE,x,y,size,size);      
    }
    
  }
  
  if(mode != 1 && mode != 2)
  {
    gdk_gc_set_foreground(gc,&color.puzzle_selected);
 
    gdk_draw_rectangle (pixmap,
                        gc,
                        FALSE,
                        x,y,
                        size-1,
                        size-1);      
 
    gdk_draw_rectangle (pixmap,
                        gc,
                        FALSE,
                        x+1,y+1,
                        size-3,
                        size-3);      
  }
  
  
  gdk_gc_set_foreground(gc,&color.pencil_in);
   
  for(k=0;k<number_of_picks/2;k++)
  {
     if(pencil_in[m][n][k]==-1)
       break;
   
     if(pencil_in[m][n][k]!=-1)
     {   
       
         convert_num_to_ascii(pencil_in[m][n][k],ch);

         layout = gtk_widget_create_pango_layout (drawing_area, ch);
         fontdesc = pango_font_description_from_string (pencil_in_font);
         pango_layout_set_font_description (layout, fontdesc); 
         pango_layout_get_pixel_size (layout, &text_w, &text_h);
     
         if(total_width+text_w+pencil_in_xspacing<pencil_size)
         {
           text_x=pencil_x+total_width+pencil_in_xspacing;
           text_y=pencil_y+pencil_in_yspacing;
         }
         else
         {
           total_width=0;
           pencil_in_yspacing=pencil_in_yspacing+text_h-2;
           text_x=pencil_x+total_width+pencil_in_xspacing;
           text_y=pencil_y+pencil_in_yspacing;
         }
     
       gdk_draw_layout (pixmap,gc,text_x,text_y,layout);
       total_width=text_w+pencil_in_xspacing+total_width;
     
       pango_font_description_free (fontdesc);
       g_object_unref (layout);

    }
   
  }
  
  

  if(value != -1)
  {
     
     text_y=text_y+text_h;
     convert_num_to_ascii(value,ch);
     
     if(puzzle_box[m][n].type!=1)
     {
       if(value<number_of_picks/2)
         gdk_gc_set_foreground(gc,&color.conf_text);
       else
         gdk_gc_set_foreground(gc,&color.doubt_text);
     }
     else  
       gdk_gc_set_foreground(gc,&color.num_fixed_text);
       
     layout = gtk_widget_create_pango_layout (drawing_area, ch);
     fontdesc = pango_font_description_from_string (puzzle_box_font);
     pango_layout_set_font_description (layout, fontdesc); 
     pango_layout_get_pixel_size (layout, &text_w, &text_h);
     text_w=puzzle_box[m][n].x+puzzle_box_square_size/2-text_w/2; 
     text_h=puzzle_box[m][n].y+puzzle_box_square_size/2-text_h/2; 
 
     //using text_ and text_h as text_x and text_y respectively
     
     if(text_h<text_y && pencil_in[m][n][0]!=-1)   //this text_y isto pencil_text_y 
       text_h=text_y-4;
 
     gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
     pango_font_description_free (fontdesc);
     g_object_unref (layout);
  }
   
  if(mode==1 || mode==0 ||mode==-1)
   gtk_widget_draw (drawing_area, &update_rect);

}

//88draw_select_puzzle_box8888888888888888888888888888888888888888888888888888888888888888888
//88draw_unselect_puzzle_box88888888888888888888888888888888888888888888888888888888888888888

void draw_unselect_puzzle_box(short m,short n)
{

   short x,y,size;
  
   GdkRectangle update_rect;        

   x=puzzle_box[m][n].x+1;
   y=puzzle_box[m][n].y+1;
   size=puzzle_box_square_size-1;
   update_rect.x = x;
   update_rect.y = y;
   update_rect.width = size;
   update_rect.height = size;

  
   if(m==key_row && n==key_column && global.two_player_solveF==TRUE)
     gdk_gc_set_foreground(gc,&color.key_box);
   else
     gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
        
   gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       x,y,
                       size-1,
                       size-1);      
 
   gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       x+1,y+1,
                       size-3,
                       size-3);      
   gtk_widget_draw (drawing_area, &update_rect);  
  
}

//88draw_unselect_puzzle_box88888888888888888888888888888888888888888888888888888888888888888
//88draw_select_pick_box888888888888888888888888888888888888888888888888888888888888888888888

void draw_select_pick_box(short pick_box_number,short mode)
{

   int text_w;
   int text_h;
   char ch[2];
   PangoLayout      *layout;
   PangoFontDescription *fontdesc;

   GdkRectangle update_rect;

   update_rect.x = pick[pick_box_number].x;
   update_rect.y = pick[pick_box_number].y;
   update_rect.width = pick_square_size;
   update_rect.height = pick_square_size;
  
   gdk_gc_set_foreground(gc,&color.pick_selected_bg);
   
   
   gdk_draw_rectangle (pixmap,
                       gc,                      
	               TRUE,
                       update_rect.x, update_rect.y,
                       update_rect.width, update_rect.height);
   gtk_widget_draw (drawing_area, &update_rect);

   gdk_gc_set_foreground(gc,&color.pick_selected);

 
   gdk_draw_rectangle (pixmap,
                       drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                       FALSE,
                       update_rect.x, update_rect.y,
                       update_rect.width-1, update_rect.height-1);
  
  
   gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       update_rect.x+1, update_rect.y+1,
                       update_rect.width-3, update_rect.height-3);
  
	               gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       update_rect.x+2, update_rect.y+2,
                       update_rect.width-5, update_rect.height-5);
  
 
   convert_num_to_ascii(pick_box_number,ch); 
   
   if(pick_box_number<number_of_picks/2)
     gdk_gc_set_foreground(gc,&color.conf_text);
   else
     gdk_gc_set_foreground(gc,&color.doubt_text);
 
   layout = gtk_widget_create_pango_layout (drawing_area, ch);
   fontdesc = pango_font_description_from_string (pick_box_font);
   pango_layout_set_font_description (layout, fontdesc); 
   pango_layout_get_pixel_size (layout, &text_w, &text_h);
   text_w=pick[pick_box_number].x+pick_square_size/2-text_w/2; 
   text_h=pick[pick_box_number].y+pick_square_size/2-text_h/2; 
 
   gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
   pango_font_description_free (fontdesc);
   g_object_unref (layout);

   if(mode==0)
     gtk_widget_draw (drawing_area, &update_rect);

}

//88draw_select_pick_box888888888888888888888888888888888888888888888888888888888888888888888
//88draw_highlight_pick_box888888888888888888888888888888888888888888888888888888888888888888

void draw_highlight_pick_box(short pick_box_number)
{

   int text_w;
   int text_h;
   char ch[2];
   PangoLayout *layout;
   PangoFontDescription *fontdesc;

   GdkRectangle update_rect;
  
   update_rect.x = pick[pick_box_number].x;
   update_rect.y = pick[pick_box_number].y;
   update_rect.width = pick_square_size;
   update_rect.height = pick_square_size;
  
  
   gdk_gc_set_foreground(gc,&color.hl_light);

   gdk_draw_rectangle (pixmap,
                       gc,
                       TRUE,
                       update_rect.x, update_rect.y,
                       update_rect.width, update_rect.height);
   gtk_widget_draw (drawing_area, &update_rect);
  
   gdk_gc_set_foreground(gc,&color.hl_dark);

 
   gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       update_rect.x, update_rect.y,
                       update_rect.width-1, update_rect.height-1);
  
  

   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+1,pick[pick_box_number].y+2,pick[pick_box_number].x+1,pick[pick_box_number].y+3);
   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+2,pick[pick_box_number].y+1,pick[pick_box_number].x+3,pick[pick_box_number].y+1);

   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+pick_square_size-4,pick[pick_box_number].y+1,pick[pick_box_number].x+pick_square_size-3,pick[pick_box_number].y+1);
   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+pick_square_size-2,pick[pick_box_number].y+2,pick[pick_box_number].x+pick_square_size-2,pick[pick_box_number].y+3);
  
   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+1,pick[pick_box_number].y+pick_square_size-4,pick[pick_box_number].x+1,pick[pick_box_number].y+pick_square_size-3);
   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+2,pick[pick_box_number].y+pick_square_size-2,pick[pick_box_number].x+3,pick[pick_box_number].y+pick_square_size-2);
 
   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+pick_square_size-2,pick[pick_box_number].y+pick_square_size-4,pick[pick_box_number].x+pick_square_size-2,pick[pick_box_number].y+pick_square_size-3);
   gdk_draw_line(pixmap,gc,pick[pick_box_number].x+pick_square_size-4,pick[pick_box_number].y+pick_square_size-2,pick[pick_box_number].x+pick_square_size-3,pick[pick_box_number].y+pick_square_size-2);

 
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x,pick[pick_box_number].y,pick[pick_box_number].x,pick[pick_box_number].y+3);
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x,pick[pick_box_number].y,pick[pick_box_number].x+3,pick[pick_box_number].y);
   gdk_draw_point(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+1,pick[pick_box_number].y+1);

  
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+pick_square_size-1,pick[pick_box_number].y,pick[pick_box_number].x+pick_square_size-1,pick[pick_box_number].y+3);
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+pick_square_size-4,pick[pick_box_number].y,pick[pick_box_number].x+pick_square_size-1,pick[pick_box_number].y);
   gdk_draw_point(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+pick_square_size-2,pick[pick_box_number].y+1);
 
 
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x,pick[pick_box_number].y+pick_square_size-4,pick[pick_box_number].x,pick[pick_box_number].y+pick_square_size-1);
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x,pick[pick_box_number].y+pick_square_size-1,pick[pick_box_number].x+3,pick[pick_box_number].y+pick_square_size-1);
   gdk_draw_point(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+1,pick[pick_box_number].y+pick_square_size-2);
 
 
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+pick_square_size-1,pick[pick_box_number].y+pick_square_size-4,pick[pick_box_number].x+pick_square_size-1,pick[pick_box_number].y+pick_square_size-1);
   gdk_draw_line(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+pick_square_size-4,pick[pick_box_number].y+pick_square_size-1,pick[pick_box_number].x+pick_square_size-1,pick[pick_box_number].y+pick_square_size-1);
   gdk_draw_point(pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],pick[pick_box_number].x+pick_square_size-2,pick[pick_box_number].y+pick_square_size-2);

   convert_num_to_ascii(pick_box_number,ch);
   
   if(pick_box_number<number_of_picks/2)
     gdk_gc_set_foreground(gc,&color.conf_text);
    else
     gdk_gc_set_foreground(gc,&color.doubt_text);
     
 
   layout = gtk_widget_create_pango_layout (drawing_area, ch); 
   fontdesc = pango_font_description_from_string (pick_box_font);
   pango_layout_set_font_description (layout, fontdesc); 
   pango_layout_get_pixel_size (layout, &text_w, &text_h);
   text_w=pick[pick_box_number].x+pick_square_size/2-text_w/2; 
   text_h=pick[pick_box_number].y+pick_square_size/2-text_h/2; 
   gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
   pango_font_description_free (fontdesc);
   g_object_unref (layout);

 
   gtk_widget_draw (drawing_area, &update_rect);


}

//88draw_highlight_pick_box888888888888888888888888888888888888888888888888888888888888888888
//88draw_original_pick_box8888888888888888888888888888888888888888888888888888888888888888888

void draw_original_pick_box (short pick_box_number)
{

  int text_w;
  int text_h;
  char ch[2];
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;

  
  GdkRectangle update_rect;
  update_rect.x = pick[pick_box_number].x;
  update_rect.y = pick[pick_box_number].y;
  update_rect.width = pick_square_size;
  update_rect.height = pick_square_size;

  gdk_draw_rectangle (pixmap,
                      drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                      TRUE,
                      update_rect.x, update_rect.y,
                      update_rect.width, update_rect.height);
  
   convert_num_to_ascii(pick_box_number,ch);
   if(pick_box_number<number_of_picks/2)
     gdk_gc_set_foreground(gc,&color.conf_text);
    else
     gdk_gc_set_foreground(gc,&color.doubt_text);
 
  layout = gtk_widget_create_pango_layout (drawing_area, ch);
  fontdesc = pango_font_description_from_string (pick_box_font);
  pango_layout_set_font_description (layout, fontdesc); 
  pango_layout_get_pixel_size (layout, &text_w, &text_h);
  text_w=pick[pick_box_number].x+pick_square_size/2-text_w/2; 
  text_h=pick[pick_box_number].y+pick_square_size/2-text_h/2; 
 
  gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
  pango_font_description_free (fontdesc);
  g_object_unref (layout);
 
 
  gtk_widget_draw (drawing_area, &update_rect);


}

//88draw_original_pick_box8888888888888888888888888888888888888888888888888888888888888888888
//88draw_line88888888888888888888888888888888888888888888888888888888888888888888888888888888

void draw_line(short m,short n, short p,short q)
{

  short x1,y1,x2,y2;

  global.is_there_conflictsF=TRUE;

  x1=puzzle_box[m][n].x+puzzle_box_square_size/2;
  y1=puzzle_box[m][n].y+puzzle_box_square_size/2;

  x2=puzzle_box[p][q].x+puzzle_box_square_size/2;
  y2=puzzle_box[p][q].y+puzzle_box_square_size/2;



  gdk_gc_set_foreground(gc,&color.conflict_lines);
 

  gdk_draw_line(pixmap,gc,x1,y1,x2,y2);

  if(m==p)
    gdk_draw_line(pixmap,gc,x1,y1+1,x2,y2+1);
  if(n==q)
    gdk_draw_line(pixmap,gc,x1+1,y1,x2+1,y2);
  if(m!=p && n!=q)
    gdk_draw_line(pixmap,gc,x1,y1+1,x2,y2+1);

}

//888draw_line8888888888888888888888888888888888888888888888888888888888888888888888888888888
//888draw_pencil_in88888888888888888888888888888888888888888888888888888888888888888888888888

void draw_pencil_in(short m,short n,short mode)
{

  //mode 0 without puzzle_box_value and doesnot draw out
  
  short i,j,k;
  short x,y,size;
  short total_width=0;
  short total_height=0;  
  short text_x=0,text_y=0;
  short pencil_in_xspacing=1;
  short pencil_in_yspacing=-1;
  int text_w=0;
  int text_h=0;
  char ch[2];
  
  
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;
  
  GdkRectangle update_rect; 

  x=puzzle_box[m][n].x+3;
  y=puzzle_box[m][n].y+3;
  size=puzzle_box_square_size-5;
  update_rect.x = x;
  update_rect.y = y;
  update_rect.width = size;
  update_rect.height = size;


  gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
  gdk_draw_rectangle (pixmap,
                      gc,
                      TRUE,
                      x,y,
                      size,
                      size);      
   
   
   gdk_gc_set_foreground(gc,&color.pencil_in);
   
   for(k=0;k<number_of_picks/2;k++)
   {
     if(pencil_in[m][n][k]==-1)
       break;
   
   
   if(pencil_in[m][n][k]!=-1)
   {   
     convert_num_to_ascii(pencil_in[m][n][k],ch);

     layout = gtk_widget_create_pango_layout (drawing_area, ch);
     fontdesc = pango_font_description_from_string (pencil_in_font);
     pango_layout_set_font_description (layout, fontdesc); 
     pango_layout_get_pixel_size (layout, &text_w, &text_h);
     
     if(total_width+text_w+pencil_in_xspacing<size)
     {
       text_x=x+total_width+pencil_in_xspacing;
       text_y=y+pencil_in_yspacing;
     }
     else
     {
       total_width=0;
       pencil_in_yspacing=pencil_in_yspacing+text_h-2;
       text_x=x+total_width+pencil_in_xspacing;
       text_y=y+pencil_in_yspacing;
     }
     
     gdk_draw_layout (pixmap,gc,text_x,text_y,layout);
     total_width=text_w+pencil_in_xspacing+total_width;
     
     pango_font_description_free (fontdesc);
     g_object_unref (layout);

   
   }
   
   }
   
   
   
   
   text_y=text_y+text_h;
   
  if(puzzle_box[m][n].value != -1)
  {
    convert_num_to_ascii(puzzle_box[m][n].value,ch);
    
    if(puzzle_box[m][n].value <number_of_picks/2)
      gdk_gc_set_foreground(gc,&color.conf_text);
    else
      gdk_gc_set_foreground(gc,&color.doubt_text);
  
    layout = gtk_widget_create_pango_layout (drawing_area, ch);
    fontdesc = pango_font_description_from_string (puzzle_box_font);
    pango_layout_set_font_description (layout, fontdesc); 
    pango_layout_get_pixel_size (layout, &text_w, &text_h);
    text_w=puzzle_box[m][n].x+puzzle_box_square_size/2-text_w/2; 
    text_h=puzzle_box[m][n].y+puzzle_box_square_size/2-text_h/2; 
 
    //using text_ and text_h as text_x and text_y respectively
    if(text_h<text_y)   //this text_y isto pencil_text_y 
      text_h=text_y-4;
    gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);
  }


   
  if(mode==1)
    gtk_widget_draw (drawing_area, &update_rect);
   
}

//88draw_pencil_in888888888888888888888888888888888888888888888888888888888888888888888888888
//88draw_score8888888888888888888888888888888888888888888888888888888888888888888888888888888

void draw_score(short mode,short score)
{
  int text_w;
  int text_h;
  short x,y,sizex,sizey;  
  char ch[2];
  char ch2[12];
  short count;
  short len=0;
  short tmp;
  PangoLayout *layout;
  PangoFontDescription *fontdesc;
  
  GdkRectangle update_rect; 

  ch2[0]=' ';
  ch2[1]=' ';
  ch2[2]='\0';
  
  if(mode==0)
    strcat(ch2,sec_copy.player1_ini);
  else
    strcat(ch2,sec_copy.player2_ini);
  count=strlen(ch2);
  ch2[count]=':';
  count=count+1;
  ch2[count]=' ';
  count=count+1;
  
  if(score<0)
  {
    ch2[count]='-';
    count=count+1;
    score=score*(-1);
  }
  
  
  if(score==0)
  {
    ch2[count]=48;
    ch2[count+1]='\0';
  }
  else
  {
    tmp=score;
    while(tmp>0)
    {
      tmp=tmp/10;
      len=len+1;
    }
  
    ch2[count+len]='\0';
  
    while(score>0)
    {
      tmp=score%10;
      ch2[count+len-1]=48+tmp;
      score=score/10;
      len=len-1;
    }
  
  }
  
  gdk_gc_set_foreground(gc,&color.score_text_color);
	 
  layout = gtk_widget_create_pango_layout (drawing_area, ch2);
  fontdesc = pango_font_description_from_string (score_text);
  pango_layout_set_font_description (layout, fontdesc); 
  pango_layout_get_pixel_size (layout, &text_w, &text_h);
        
  if(mode==1)
    update_rect.x = 0;
  else
    update_rect.x = drawing_area_w-text_w-2; 
  update_rect.y = puzzle_box_y-text_h-2;
  update_rect.width = text_w+4;
  update_rect.height = text_h;
	 
  gdk_draw_rectangle (pixmap,
                      drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                      TRUE,
                      update_rect.x, update_rect.y,
                      update_rect.width, update_rect.height);
  
  gdk_draw_layout (pixmap,gc,update_rect.x,update_rect.y,layout);
  pango_font_description_free (fontdesc);
  g_object_unref (layout);
  
  gtk_widget_draw (drawing_area, &update_rect);
  
  
}

//88draw_score8888888888888888888888888888888888888888888888888888888888888888888888888888888
//88draw_empty_puzzle888888888888888888888888888888888888888888888888888888888888888888888888

void draw_empty_puzzle()
{
  short i,j;
  int text_w;
  int text_h;
  
  char ch[2];
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;

  gdk_draw_rectangle (pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],TRUE,0,0,                     drawing_area_w,puzzle_box_y);

  for(i=0;i<number_of_picks;i++)
  {
    if(i<number_of_picks/2)
    {
      gdk_gc_set_foreground(gc,&color.conf_text);
      if(i>8)
       ch[0]=56+i;
      else
       ch[0]=49+i;
    }
    else
    {
      gdk_gc_set_foreground(gc,&color.doubt_text);
      if(i>24)
       ch[0]=40+i;
      else
       ch[0]=49+i-(number_of_picks/2);
    }
    
    ch[1]='\0'; 
    layout = gtk_widget_create_pango_layout (drawing_area, ch);
    fontdesc = pango_font_description_from_string (pick_box_font);
    pango_layout_set_font_description (layout, fontdesc); 
    pango_layout_get_pixel_size (layout, &text_w, &text_h);
    text_w=pick[i].x+pick_square_size/2-text_w/2; 
    text_h=pick[i].y+pick_square_size/2-text_h/2; 
 
    gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);
  }
  
  gdk_gc_set_foreground(gc,&color.puzzle_bg);
  gdk_draw_rectangle (pixmap, gc, TRUE, 0, puzzle_box_y, drawing_area_w,                     drawing_area_h-puzzle_box_y);
   
  gdk_gc_set_foreground(gc,&color.puzzle_lines);
  gdk_draw_rectangle (pixmap, gc, FALSE, 0, puzzle_box_y, drawing_area_w-1,                  drawing_area_h-1-puzzle_box_y );      

  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
  
     gdk_gc_set_foreground(gc,&color.puzzle_lines);
              
     gdk_draw_rectangle (pixmap,
                         gc,
                         FALSE,
                         puzzle_box[i][j].x,puzzle_box[i][j].y,
                         puzzle_box_square_size,
                         puzzle_box_square_size);      
      
  }
  }
   
   
   
   gdk_draw_pixmap(drawing_area->window,
                   drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                   pixmap,
                   0, 0,0,0,
                   drawing_area_w,drawing_area_h);

}

//88draw_empty_puzzle888888888888888888888888888888888888888888888888888888888888888888888888
//88draw_puzzle888888888888888888888888888888888888888888888888888888888888888888888888888888

void draw_puzzle()
{
  
  short i,j;
  int text_w;
  int text_h;
  
  char ch[2];
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;

  gdk_draw_rectangle (pixmap,drawing_area->style->bg_gc[GTK_STATE_NORMAL],TRUE,0,0,                     drawing_area_w,puzzle_box_y);

  for(i=0;i<number_of_picks;i++)
  {
    if(i<number_of_picks/2)
    {
      gdk_gc_set_foreground(gc,&color.conf_text);
      if(i>8)
       ch[0]=56+i;
      else
       ch[0]=49+i;
    }
    else
    {
      gdk_gc_set_foreground(gc,&color.doubt_text);
      if(i>24)
       ch[0]=40+i;
      else
       ch[0]=49+i-(number_of_picks/2);
    }
    
    ch[1]='\0'; 
    layout = gtk_widget_create_pango_layout (drawing_area, ch);
    fontdesc = pango_font_description_from_string (pick_box_font);
    pango_layout_set_font_description (layout, fontdesc); 
    pango_layout_get_pixel_size (layout, &text_w, &text_h);
    text_w=pick[i].x+pick_square_size/2-text_w/2; 
    text_h=pick[i].y+pick_square_size/2-text_h/2; 
 
    gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);
  }
  
  gdk_gc_set_foreground(gc,&color.puzzle_bg);
  gdk_draw_rectangle (pixmap, gc, TRUE, 0, puzzle_box_y, drawing_area_w,                     drawing_area_h-puzzle_box_y);
   
  gdk_gc_set_foreground(gc,&color.puzzle_lines);
  gdk_draw_rectangle (pixmap, gc, FALSE, 0, puzzle_box_y, drawing_area_w-1,                  drawing_area_h-1-puzzle_box_y );      

  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
  
     gdk_gc_set_foreground(gc,&color.puzzle_lines);
              
     gdk_draw_rectangle (pixmap,
                         gc,
                         FALSE,
                         puzzle_box[i][j].x,puzzle_box[i][j].y,
                         puzzle_box_square_size,
                         puzzle_box_square_size);      
      
//   if(puzzle_box[i][j].value!=-1)
     draw_select_puzzle_box(i,j,puzzle_box[i][j].value,2);
	
    
  }
  }
   
  if(p_m!=-1)
    draw_select_puzzle_box(p_m,p_n,puzzle_box[p_m][p_n].value,3);
  if(global.selected_pick_box!=-1)
    draw_select_pick_box(global.selected_pick_box,1);
   
  if(global.keyboard_presentF==TRUE)
  {
    gdk_gc_set_foreground(gc,&color.key_box);
    gdk_draw_rectangle (pixmap, gc, FALSE, puzzle_box[key_row][key_column].x+1,puzzle_box[key_row][key_column].y+1, puzzle_box_square_size-2, puzzle_box_square_size-2);      
    gdk_draw_rectangle (pixmap, gc, FALSE, puzzle_box[key_row][key_column].x+1+1,puzzle_box[key_row][key_column].y+1+1, puzzle_box_square_size-4, puzzle_box_square_size-4);      
  }  
  
  if(global.two_player_game==TRUE &&   global.edit_modeF==FALSE)
  {
    draw_score(0,global.p1_points);
    draw_score(1,global.p2_points);
  }
   
  gdk_draw_pixmap(drawing_area->window,
                  drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                  pixmap,
                  0, 0,0,0,
                  drawing_area_w,drawing_area_h);


}

//88draw_puzzle888888888888888888888888888888888888888888888888888888888888888888888888888888


//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
