/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"


short tmp_m;

// da_ineractive.c contains mathematics function behind writing in or out of drawing area




/*
list of functions:
void initialize_and_draw_empty_puzzle()
void calculate_pencil_in(short i,short j,short value)
void draw_and_select_key_box(int mode)
void draw_and_unselect_key_box()
gboolean key_presses(GtkWidget *widget, GdkEventKey *event)
void select_pick_box()
void unselect_pick_box()
void unselect_puzzle_box()
gboolean drawing_area_clicked(GtkWidget *widget, GdkEventButton *event )
void drawing_area_mclicked()
void drawing_area_rclicked()
void drawing_area_lclicked()
void highlight_pick_box()
void unhighlight_box ()
gboolean mouse_movement_event( GtkWidget *widget, GdkEventMotion *event )



Accessories:
void convert_num_to_ascii(int num,char *ch)

*/



//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88initialize_and_draw_empty_puzzle888888888888888888888888888888888888888888888888888888888

void initialize_and_draw_empty_puzzle()
{

  short i,j,k;
  
  p_m=-1;
  global.selected_pick_box=-1;
  global.keyboard_presentF=FALSE;

  
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    puzzle_box[i][j].value=-1;
    puzzle_box[i][j].type=0;
    for(k=0;k<number_of_picks/2+1;k++)
      pencil_in[i][j][k]=-1;
  }
  }
  
  global.number_of_free_boxes=board_size*board_size*board_size*board_size;
  update_status_bar_num_of_occupied_box();


  draw_puzzle();
  
}

//88initialize_and_draw_empty_puzzle888888888888888888888888888888888888888888888888888888888
//88calculate_pencil_in8888888888888888888888888888888888888888888888888888888888888888888888

void calculate_pencil_in(short i,short j,short value)
{
 short k,m;
 short temp;

 gboolean value_present_already=FALSE;
 gboolean put_break=FALSE;

 for(k=0;k<number_of_picks/2;k++)
 {
   if( pencil_in[i][j][k]==-1)
     break;
  
   if( pencil_in[i][j][k]==value)
   {
     value_present_already=TRUE;
     break;
   }
 }
 
 //g_print("present: %d\n",value_present_already);

 if(value_present_already==FALSE)
 {
 for(k=0;k<number_of_picks/2;k++)
 {
 if(value<pencil_in[i][j][k] || pencil_in[i][j][k]==-1 )
 {
    temp=pencil_in[i][j][k];
    pencil_in[i][j][k]=value;
    for(m=number_of_picks/2-1;m>=k+2;m--)
      pencil_in[i][j][m]=pencil_in[i][j][m-1];
    pencil_in[i][j][k+1]=temp;  
    break;
 }
 }
 }
 else
 {
 for(k=0;k<number_of_picks/2;k++)
 {
   if(pencil_in[i][j][k]==value)
   {
     put_break=TRUE;
     for(m=k;m<number_of_picks/2;m++)
     {
       pencil_in[i][j][m]=pencil_in[i][j][m+1];
       if(pencil_in[i][j][m]==-1)
         break;
     }    
   }
   
   if(put_break==TRUE)
     break;
   
 }
 }

 //for(k=0;k<number_of_picks/2;k++)
 //g_print("%d \n",pencil_in[i][j][k]);

 if(global.two_player_game==FALSE)  
   create_new_undo(); 
 draw_pencil_in(i,j,1);

}

//88calculate_pencil_in8888888888888888888888888888888888888888888888888888888888888888888888
//88draw_and_select_key_box888888888888888888888888888888888888888888888888888888888888888888

void draw_and_select_key_box(short mode)
{

  short x,y,size;
  int text_w;
  int text_h;
  char ch[2];
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;
  
  GdkRectangle update_rect;        
  //getchar();
  
  x=puzzle_box[key_row][key_column].x+1;
  y=puzzle_box[key_row][key_column].y+1;
  size=puzzle_box_square_size-1;
  update_rect.x = x;
  update_rect.y = y;
  update_rect.width = size;
  update_rect.height = size;
  
  
  if(mode == 1)
  {
    gdk_gc_set_foreground(gc,&color.puzzle_bg);
    gdk_draw_rectangle (pixmap,
                        gc,
                        TRUE,
                        x,y,
                        size,
                        size);      
  }
  
  gdk_gc_set_foreground(gc,&color.key_box);
   
  gdk_draw_rectangle (pixmap,
                      gc,
                      FALSE,
                      x,y,
                      size-1,
                      size-1);      
 
  gdk_draw_rectangle (pixmap,
                      gc,
                      FALSE,
                      x+1,y+1,
                      size-3,
                      size-3);      
  
  
  
  if(mode==1)
  {
    if(global.two_player_game==TRUE)
      puzzle_box[key_row][key_column].type=11;   
    
    puzzle_box[key_row][key_column].value=key_value;   
    //g_print("good\n");
    convert_num_to_ascii(key_value,ch);
   
    if(key_value<number_of_picks/2)
      gdk_gc_set_foreground(gc,&color.conf_text);
    else
      gdk_gc_set_foreground(gc,&color.doubt_text);
  
    layout = gtk_widget_create_pango_layout (drawing_area, ch);
    fontdesc = pango_font_description_from_string (puzzle_box_font);
    pango_layout_set_font_description (layout, fontdesc); 
    pango_layout_get_pixel_size (layout, &text_w, &text_h);
    text_w=puzzle_box[key_row][key_column].x+puzzle_box_square_size/2-text_w/2; 
    text_h=puzzle_box[key_row][key_column].y+puzzle_box_square_size/2-text_h/2; 
 
    //using text_ and text_h as text_x and text_y respectively
 
    gdk_draw_layout (pixmap,gc,text_w,text_h,layout);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);
  
    if(global.auto_pencil_in_remove==TRUE)
      check_and_remove_and_display_pencil_in(key_row,key_column,puzzle_box[key_row][key_column].value);
    
    if(global.two_player_game==FALSE)
      create_new_undo(); 
 
  }
 
  gtk_widget_draw (drawing_area, &update_rect);
 
  if( (global.check_for_conflictF==TRUE || global.two_player_game==TRUE) && mode==1)
  { 
     check_conflicts_for_selected_pbox(key_row,key_column);
     if(global.two_player_game==TRUE)
     {
     if(global.is_there_conflictsF==TRUE)
     {
         if(global.minus_points!=0)
	 {
	  if(global.minus_points!=20)
	  global.p2_points=global.p2_points-global.minus_points;
	  else
	  global.p2_points=global.p2_points-(puzzle_box[key_row][key_column].value+1);
	  draw_score(1,global.p2_points);
         }
      
         global.conflict_by_player1=FALSE;
         puzzle_box[key_row][key_column].value=-1;
         puzzle_box[key_row][key_column].type=0;
     }
     else
     {
         global.p2_points=global.p2_points+puzzle_box[key_row][key_column].value+1;
         draw_score(1,global.p2_points);
        
	 if( global.two_player_time_game_dupe==TRUE)
           timing.tp_2_time=1;
         else
         {
           global.disable_mouse=FALSE;
           global.disable_keyboard=TRUE;
           status_bar_update_tp_whoes_turn();
         } 
//       draw_and_unselect_key_box();
     }
     }
   
   }
   
}


//88draw_and_select_key_box888888888888888888888888888888888888888888888888888888888888888888
//88draw_and_unselect_key_box8888888888888888888888888888888888888888888888888888888888888888

void draw_and_unselect_key_box()
{

   short x,y,size;

   GdkRectangle update_rect;        

   x=puzzle_box[key_row][key_column].x+1;
   y=puzzle_box[key_row][key_column].y+1;
   size=puzzle_box_square_size-1;
   update_rect.x = x;
   update_rect.y = y;
   update_rect.width = size;
   update_rect.height = size;
        
   if(key_row==p_m && key_column==p_n)
     gdk_gc_set_foreground(gc,&color.puzzle_selected);
   else if(puzzle_box[key_row][key_column].type==1)
     gdk_gc_set_foreground(gc,&color.num_fixed_box_bg);
   else
     gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
   
   gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       x,y,
                       size-1,
                       size-1);      
 
   gdk_draw_rectangle (pixmap,
                       gc,
                       FALSE,
                       x+1,y+1,
                       size-3,
                       size-3);      
 
   gtk_widget_draw (drawing_area, &update_rect);

}


//88draw_and_unselect_key_box8888888888888888888888888888888888888888888888888888888888888888
//88key_presses888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean key_presses(GtkWidget *widget, GdkEventKey *event)
{
 
  int key_pressed;
  short event_state;
  short i,j;
  short m,n,tmp;
  gboolean put_break;
  
  
//  g_print("%d  %d  %s\n",event->keyval,event->state,event->string);
  key_pressed=event->keyval;
  event_state=event->state;
 
  
  if( ((key_pressed==120 || key_pressed==88) && (event_state==8 || event_state == 10)) ||
     ((key_pressed==113 || key_pressed==81) && (event_state==4 || event_state == 6))  )
  {
     exit_game();
   
  }
     


//1##########################################  
  if( (global.two_player_game==TRUE && global.disable_keyboard==FALSE) || global.two_player_game==FALSE)
  {

//2##########################################  
  if(global.is_there_conflictsF==TRUE)
  {
    global.is_there_conflictsF=FALSE;
    if(global.two_player_game==TRUE)
    {
      if(global.conflict_by_player1==TRUE)
      {
         gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
         gdk_draw_rectangle (pixmap_bckup,
                             gc,
                             TRUE,
                             puzzle_box[tmp_m][p_n].x+3,puzzle_box[tmp_m][p_n].y+3,
                             puzzle_box_square_size-5,
                             puzzle_box_square_size-5);      
    
    
      }
      else
      {
         gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
         gdk_draw_rectangle (pixmap_bckup,
                             gc,
                             TRUE,
                             puzzle_box[key_row][key_column].x+3,puzzle_box[key_row][key_column].y+3,
                             puzzle_box_square_size-5,
                             puzzle_box_square_size-5);      
       }
     
       global.number_of_free_boxes=global.number_of_free_boxes+1;
       update_status_bar_num_of_occupied_box();
   
    }
  
    gdk_draw_drawable (pixmap, drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)], pixmap_bckup, 0, puzzle_box_y, 0, puzzle_box_y, drawing_area_w, drawing_area_h-puzzle_box_y);
   
    gdk_draw_pixmap(drawing_area->window,
                    drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                    pixmap,
                    0, puzzle_box_y,0,puzzle_box_y,
                    drawing_area_w,drawing_area_h-puzzle_box_y);

  }
  else
  {

    if(p_m!=-1  && global.two_player_solveF==FALSE  && global.two_player_game==FALSE)
    {
   
        if(key_pressed>=65457 && key_pressed<=65465 && event_state==16)
        {
          key_value=key_pressed-65457;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65379 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65370;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65360 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65350;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65365 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65354;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65535 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65523;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65367 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65354;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65366 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65352;
          calculate_pencil_in(p_m,p_n,key_value);
        }
        if(key_pressed==65455 && board_size==4 && event_state==16)
        {
          key_value=key_pressed-65440;
          calculate_pencil_in(p_m,p_n,key_value);
        }

     }
   
   
//#############   
     if(global.keyboard_presentF==TRUE)
     {
       //1--------------- 
       if(puzzle_box[key_row][key_column].type!=1  && puzzle_box[key_row][key_column].type !=11  && global.two_player_game==FALSE)
       {
          if( (event_state==8 || event_state==16) && key_pressed>=49 && key_pressed<=57)
          {
             key_value=key_pressed-49;
             calculate_pencil_in(key_row,key_column,key_value);
          }

          if(board_size==4 && (event_state==8 || event_state==24) && key_pressed>=97 && key_pressed<=103)
          {
             key_value=key_pressed-88;
             calculate_pencil_in(key_row,key_column,key_value);
          }

          if(board_size==4 && (event_state==10 || event_state==26) && key_pressed>=65 && key_pressed<=71)
          {
             key_value=key_pressed-56;
             calculate_pencil_in(key_row,key_column,key_value);
          }

       }
       //1+++++++++++++++  
      
       //2--------------- 
       if(key_pressed==65362 || key_pressed==107 || key_pressed==75)  //up
       {
     
         if(global.key_movement_fixed_box_no_limit==TRUE)
         {
            i=key_row-1;
             
	    if(global.key_movement_restrictive==FALSE && i==-1)
              i=number_of_picks/2-1;
     
         }
         else
         {
           
	    for(i=key_row-1;i>=0;i--)
            {
               if(puzzle_box[i][key_column].type !=1 && puzzle_box[i][key_column].type !=11)
	         break;
      
            }
           
	    if(global.key_movement_restrictive==FALSE && i==-1)
            {
	      for(tmp=number_of_picks/2-1;tmp>key_row;tmp--)
              {
                if(puzzle_box[tmp][key_column].type !=1 && puzzle_box[tmp][key_column].type !=11)
	        {
	           i=tmp;  
	           break;
	        } 
	      }
	    }  

         } 
     
         
	 if(i !=-1)
         {
             draw_and_unselect_key_box();
             key_row=i; 
             draw_and_select_key_box(0);
          }
   
       }
       //2+++++++++++++++  
   
       //3--------------- 
       if(key_pressed==65364 || key_pressed==44)  //down
       {
         if(global.key_movement_fixed_box_no_limit==TRUE)
         {
           i=key_row+1;
           
	   if(global.key_movement_restrictive==FALSE && i==number_of_picks/2)
             i=0;
         }
         else
         {
           
	   for(i=key_row+1;i<number_of_picks/2;i++)
           {
             if(puzzle_box[i][key_column].type !=1 && puzzle_box[i][key_column].type !=11) 
	       break;
           }
           
	   if(global.key_movement_restrictive==FALSE && i==number_of_picks/2)
 	   { 
	   for(tmp=0;tmp<key_row;tmp++)
           {
             if(puzzle_box[tmp][key_column].type !=1 && puzzle_box[tmp][key_column].type !=11)
	     {
	       i=tmp;
	       break;
	     } 
	   }
	   }  
     
         } 
	  
         if(i!=number_of_picks/2)
         { 
            draw_and_unselect_key_box();
            key_row=i;
            draw_and_select_key_box(0);
         }
   
       }
       //3+++++++++++++++  

        
       //4--------------- 
       if(key_pressed==65361 || key_pressed==109 || key_pressed==77)  //left
       {
         
	 if(global.key_movement_fixed_box_no_limit==TRUE)
         {
           i=key_column-1;
           
	   if(global.key_movement_restrictive==FALSE && i==-1)
             i=number_of_picks/2-1;
          }
          else
          {
            
	    for(i=key_column-1;i>=0;i--)
            {
               if(puzzle_box[key_row][i].type !=1 && puzzle_box[i][key_column].type !=11)
	         break;
             }
        
	     if(global.key_movement_restrictive==FALSE && i==-1)
	     {
	     for(tmp=number_of_picks/2-1;tmp>key_column;tmp--)
             {
               if(puzzle_box[key_row][tmp].type !=1 && puzzle_box[key_row][tmp].type !=11)
	       {
	         i=tmp;
	         break;
	       }  
	     }
	     }  
     
           } 
     
           if(i !=-1)
           {
             draw_and_unselect_key_box();
             key_column=i;
             draw_and_select_key_box(0);
           }
   
        }
       //4+++++++++++++++  
 
       //5--------------- 
       if(key_pressed==65363 || key_pressed==46)  //right
       {
         
	 if(global.key_movement_fixed_box_no_limit==TRUE)
         {
           i=key_column+1;
           
	   if(global.key_movement_restrictive==FALSE && i==number_of_picks/2)
             i=0;
         }
         else
         {
       
           for(i=key_column+1;i<number_of_picks/2;i++)
           {
             
	     if(puzzle_box[key_row][i].type !=1 && puzzle_box[key_row][i].type !=11)
	       break;
           }
        
	   if(global.key_movement_restrictive==FALSE && i==number_of_picks/2)
	   {
	   for(tmp=0;tmp<key_column;tmp++)
           {
             if(puzzle_box[key_row][tmp].type !=1 && puzzle_box[key_row][tmp].type !=11)
	     {
	       i=tmp;
	       break;
	     } 
	   }
	   }  
      
         } 
	 
         if(i!=number_of_picks/2)
         { 
           draw_and_unselect_key_box();
           key_column=i;
           draw_and_select_key_box(0);
         }
   
       }
       //5+++++++++++++++  
 
 
       //6--------------- 
       if(key_pressed==93)         //right to next free box 
       {
          put_break=FALSE;
          m=key_row;
          n=key_column;
          tmp=key_column+1;
          for(i=key_row;i<number_of_picks/2;i++)
          {
          for(j=tmp;j<number_of_picks/2;j++)
          {
             if(puzzle_box[i][j].type!=1 && puzzle_box[i][j].type !=11)
             {
                draw_and_unselect_key_box();
                key_row=i;
	        key_column=j;
                put_break=TRUE;
	        break;
             }
          }
          tmp=0;
          if(put_break==TRUE)
          break;
          }
	  
          put_break=FALSE;    
          
	  if(key_row==m && key_column ==n)
          {
          for(i=0;i<number_of_picks/2;i++)
          {
          for(j=0;j<number_of_picks/2;j++)
          {
            if(puzzle_box[i][j].type!=1  && puzzle_box[i][j].type !=11 &&  i!=m  &&  j!=n)
            {
              draw_and_unselect_key_box();
              key_row=i;
	      key_column=j;
              put_break=TRUE;
	      break;
            }
       
          }
          if(put_break==TRUE)
            break;
          }
          }
          
	  if(key_row!=m || key_column !=n)
            draw_and_select_key_box(0);
        }
       //6+++++++++++++++  
   
       //7--------------- 
       if(key_pressed==91)         //left to next free box 
       {
          put_break=FALSE;
          m=key_row;
          n=key_column;
          tmp=key_column-1;
     
          for(i=key_row;i>=0;i--)
          {
          for(j=tmp;j>=0;j--)
          {
            if(puzzle_box[i][j].type!=1 && puzzle_box[i][j].type !=11)
            {
               draw_and_unselect_key_box();
               key_row=i;
	       key_column=j;
               put_break=TRUE;
	       break;
            }
       
          }
          tmp=number_of_picks/2-1;
          if(put_break==TRUE)
            break;
          }
     
     
          put_break=FALSE;     
          if(key_row==m && key_column ==n)
          {
//        g_print("it csnt be\n");
          for(i=number_of_picks/2-1;i>=0;i--)
          {
          for(j=number_of_picks/2-1;j>=0;j--)
          {
            if(puzzle_box[i][j].type!=1  && puzzle_box[i][j].type !=11 && (i!=m  &&  j!=n) )
            {
              draw_and_unselect_key_box();
              key_row=i;
	      key_column=j;
              put_break=TRUE;
	      break;
            }
          }
          if(put_break==TRUE)
            break;
          }
          }
     
          if(key_row!=m || key_column !=n)
            draw_and_select_key_box(0);

       }
       //7+++++++++++++++  
   
   
   
   
   
       //8------------------------------ 
       if(puzzle_box[key_row][key_column].type!=1 && puzzle_box[key_row][key_column].type !=11)
       {
      
          if(key_pressed>=65457 && key_pressed<=65465 && event_state==16)
          {
             
	     key_value=key_pressed-65457;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
             
	     draw_and_select_key_box(1);
          }
          
	  if(key_pressed==65379 && board_size==4 && event_state==16)
          {
            
	     key_value=key_pressed-65370;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
             draw_and_select_key_box(1);
          }
          
	  if(key_pressed==65360 && board_size==4 && event_state==16)
          {
             key_value=key_pressed-65350;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
            
	     draw_and_select_key_box(1);
          }
          
	  if(key_pressed==65365 && board_size==4 && event_state==16)
          {
             key_value=key_pressed-65354;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
             
	     draw_and_select_key_box(1);
          }
    
          if(key_pressed==65535 && board_size==4 && event_state==16)
          {
             
	     key_value=key_pressed-65523;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
             
	     draw_and_select_key_box(1);
          }
          
	  if(key_pressed==65367 && board_size==4 && event_state==16)
          {
             
	     key_value=key_pressed-65354;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
             
	     draw_and_select_key_box(1);
          }
          
	  if(key_pressed==65366 && board_size==4 && event_state==16)
          {     
             key_value=key_pressed-65352;
             if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
             {
                global.number_of_free_boxes=global.number_of_free_boxes-1;
                update_status_bar_num_of_occupied_box();
             }
             draw_and_select_key_box(1);
           }
           
	   if(key_pressed==65455 && board_size==4 && event_state==16)
           {
              key_value=key_pressed-65440;
              if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
              {
                 global.number_of_free_boxes=global.number_of_free_boxes-1;
                 update_status_bar_num_of_occupied_box();
              }
              
	      draw_and_select_key_box(1);
            }

 
 
 
 
            if(key_pressed==48  || key_pressed==65456)
            {
              if(convert_doubt_to_confirmed_text_if_necessery(puzzle_box[key_row][key_column].value)!=-1)
              {
                 global.number_of_free_boxes=global.number_of_free_boxes+1;
                 update_status_bar_num_of_occupied_box();
              } 
   
              puzzle_box[key_row][key_column].value=-1;
              draw_select_puzzle_box(key_row,key_column,-1,1);
            }
 
            //------------------
	    if( ((event_state!=8 && event_state!=16)||event_state==24) && key_pressed>=49 && key_pressed<=57)
            {
               key_value=key_pressed-49;
//             g_print("xxxxxxxxxx\n");
               if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
               {
//               g_print("great\n");
	         global.number_of_free_boxes=global.number_of_free_boxes-1;
                 update_status_bar_num_of_occupied_box();
//               g_print("hpw\n");
               }
               
	       draw_and_select_key_box(1);
 
             }
             else if(event_state!=8 && event_state!=10 && event_state!=24 && event_state!=26 && (key_pressed>=33 && key_pressed<=40) || key_pressed==42 || key_pressed==94|| key_pressed==64)
             {
 
                if(board_size==3)
                {   
                  if(key_pressed==33 ||(key_pressed>=35 && key_pressed<=37))
                    key_value=key_pressed-33+9;   
 
                  if(key_pressed==64)
                    key_value=10;
  
                  if(key_pressed==94)
                    key_value=14;   
   
                  if(key_pressed==38)
                    key_value=15; 
   
                  if(key_pressed==42)
                    key_value=16;   
   
                  if(key_pressed==40)
                    key_value=17; 
                }
                else
                {
                  
		  if(key_pressed==33 ||(key_pressed>=35 && key_pressed<=37))
                    key_value=key_pressed-33+16;   
 
                  if(key_pressed==64)
                    key_value=17;
  
                  if(key_pressed==94)
                    key_value=21;   
   
                  if(key_pressed==38)
                    key_value=22; 
   
                  if(key_pressed==42)
                    key_value=23;   
   
                  if(key_pressed==40)
                    key_value=24; 
                }
		 
		 
                if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
                {
                   global.number_of_free_boxes=global.number_of_free_boxes-1;
                   update_status_bar_num_of_occupied_box();
   
                }
		  
                draw_and_select_key_box(1); 
		  
            }
            //++++++++++++++++++ 
  
            
	    if(event_state!=8 && event_state!=10 && event_state!=24 && event_state!=26 && board_size==4 && (key_pressed>=65 && key_pressed<=71) || (key_pressed>=97 && key_pressed<=103))
            {
               
	       if(key_pressed<80)
                 key_value=key_pressed-65+25;
    
               if(key_pressed>90)
                 key_value=key_pressed-97+9;
               
	       if(puzzle_box[key_row][key_column].value==-1 && convert_doubt_to_confirmed_text_if_necessery(key_value)!=-1)
               {
                  global.number_of_free_boxes=global.number_of_free_boxes-1;
                  update_status_bar_num_of_occupied_box();
               }
               
	       draw_and_select_key_box(1); 
            }
 
       }
       //8------------------------------ 



     }
//#############   
 
     if(global.keyboard_presentF ==FALSE && (key_pressed==65362  || key_pressed==107 || key_pressed==75 || key_pressed==65364 || key_pressed==44 || key_pressed == 65361  || key_pressed==109 || key_pressed==77 || key_pressed == 65363 || key_pressed==46 || key_pressed==93 || key_pressed==91) )
     {
     if(puzzle_box[key_row][key_column].type==1 && puzzle_box[key_row][key_column].type !=11)
     {
          
	  gboolean put_break=FALSE;
          for(i=board_size;i<number_of_picks/2-board_size;i++)
          {
          for(j=board_size;j<number_of_picks/2-board_size;j++)
          {
             if(puzzle_box[i][j].type!=1 && puzzle_box[i][j].type !=11)
             {
               key_row=i;
               key_column=j;
               put_break=TRUE;
               break;
             }
          }
          if(put_break==TRUE)
            break;
          } 
    
          if(puzzle_box[key_row][key_column].type==1 && puzzle_box[key_row][key_column].type !=11)
          {
             
	     gboolean put_break=FALSE;
             for(i=0;i<number_of_picks/2;i++)
             {
             for(j=0;j<number_of_picks/2;j++)
             {
               if(puzzle_box[i][j].type!=1 && puzzle_box[i][j].type !=11)
               {
                  key_row=i;
                  key_column=j;
                  put_break=TRUE;
                  break;
               }
    
             }
             if(put_break==TRUE)
               break;
             } 
          }
  
  
     } 
     global.keyboard_presentF=TRUE;
     draw_and_select_key_box(0);
     }

 
  }
//2##########################################  
 
  }
//1##########################################  

  
  
  return FALSE;
  
  
}

//88key_presses888888888888888888888888888888888888888888888888888888888888888888888888888888
//88select_pick_box()888888888888888888888888888888888888888888888888888888888888888888888888
void select_pick_box()
{
  
  if(p_m==-1 || sticky_selection ==1)
  {
    global.selected_pick_box=global.highlighted_pick_box; 
    global.highlighted_pick_box=-1;    
    draw_select_pick_box(global.selected_pick_box,0);
  }
  
 
  if(p_m!=-1)
  {
   
    if(puzzle_box[p_m][p_n].type !=1  && puzzle_box[p_m][p_n].type !=11 && puzzle_box[p_m][p_n].value==-1 && convert_doubt_to_confirmed_text_if_necessery(global.selected_pick_box)!=-1)
    {
      global.number_of_free_boxes=global.number_of_free_boxes-1;
      update_status_bar_num_of_occupied_box();
    }
   
   
    if(sticky_selection !=1 && puzzle_box[p_m][p_n].type !=1 && puzzle_box[p_m][p_n].type !=11)
    {
      global.selected_pick_box=global.highlighted_pick_box;
      draw_original_pick_box (global.selected_pick_box);
      pick[global.selected_pick_box].mouse_over=0;
    }
     

    if(global.treat_doubt_as_pencil_in==TRUE  && global.selected_pick_box>=number_of_picks/2)
    { 
   
      if(global.two_player_game==FALSE)
      {
        
	calculate_pencil_in(p_m,p_n,global.selected_pick_box-(number_of_picks/2));
        
	if(sticky_selection==2)
          draw_unselect_puzzle_box(p_m,p_n);
       }
     }
     else
    //1##########
     {
       
       if(puzzle_box[p_m][p_n].type !=1 && puzzle_box[p_m][p_n].type !=11)
       {
         
	 if(global.two_player_game==TRUE)
           puzzle_box[p_m][p_n].type=11;   
         
	 puzzle_box[p_m][p_n].value=global.selected_pick_box;
   
	 //1----------
         if(sticky_selection==2)
         {
           draw_select_puzzle_box(p_m,p_n,global.selected_pick_box,1);
           
	   if(global.auto_pencil_in_remove==TRUE)
             check_and_remove_and_display_pencil_in(p_m,p_n,global.selected_pick_box);
           
	   if(global.check_for_conflictF==TRUE || global.two_player_game==TRUE)
           {
             
	     check_conflicts_for_selected_pbox(p_m,p_n);
             if(global.two_player_game==TRUE)
             {
             if(global.is_there_conflictsF==TRUE)
             {
               if(global.minus_points!=0)
	       {
	         if(global.minus_points!=20)
	           global.p1_points=global.p1_points-global.minus_points;
	         else
	           global.p1_points=global.p1_points-(puzzle_box[p_m][p_n].value+1);
	         
		 draw_score(0,global.p1_points);
                } 
                
		tmp_m=p_m;
                global.conflict_by_player1=TRUE;
                puzzle_box[p_m][p_n].value=-1;
                puzzle_box[p_m][p_n].type=0;
              }
              else
              {
                
		global.p1_points=global.p1_points+puzzle_box[p_m][p_n].value+1;
                draw_score(0,global.p1_points);
                if( global.two_player_time_game_dupe==TRUE)
                  timing.tp_1_time=1;
                else
                {
                  global.disable_mouse=TRUE;
                  global.disable_keyboard=FALSE;
	          status_bar_update_tp_whoes_turn();
                }
              }
              }
           } 
           p_m=-1; 
    
         }  
         //1++++++++++
	 
	 
         if(sticky_selection==3 || sticky_selection==1)
         { 
            
	    draw_select_puzzle_box(p_m,p_n,global.selected_pick_box,0);
            
	    if(global.auto_pencil_in_remove==TRUE)
              check_and_remove_and_display_pencil_in(p_m,p_n,global.selected_pick_box);
      
            if(global.check_for_conflictF==TRUE || global.two_player_game==TRUE)
            {
               
	       check_conflicts_for_selected_pbox(p_m,p_n);
               if(global.two_player_game==TRUE)
               {
               if(global.is_there_conflictsF==TRUE)
               {
                  if(global.minus_points!=0)
	          {
	             if(global.minus_points!=20)
	               global.p1_points=global.p1_points-global.minus_points;
	             else
	               global.p1_points=global.p1_points-(puzzle_box[p_m][p_n].value+1);
	             
		     draw_score(0,global.p1_points);
                   }
                   
		   tmp_m=p_m;
	           global.conflict_by_player1=TRUE;
                   puzzle_box[p_m][p_n].value=-1;
                   puzzle_box[p_m][p_n].type=0;
                }
                else
                {
                   global.p1_points=global.p1_points+puzzle_box[p_m][p_n].value+1;
                   draw_score(0,global.p1_points);
                   if( global.two_player_time_game_dupe==TRUE)
                     timing.tp_1_time=1;
                   else
                   {
                     global.disable_mouse=TRUE;
                     global.disable_keyboard=FALSE;
	             status_bar_update_tp_whoes_turn();
                   }
       
                 }
                 }
              
	      }
           
	   }
   
   
           global.highlighted_pick_box=-1;   
      
           if(sticky_selection!=1)
             global.selected_pick_box=-1;
   
        }
   
     }
    //1##########
      
     if(global.two_player_game==FALSE)
       create_new_undo(); 
  
  
  } 
 
   

}

//88select_pick_box()888888888888888888888888888888888888888888888888888888888888888888888888
//88unselect_pick_box888888888888888888888888888888888888888888888888888888888888888888888888

void unselect_pick_box()
{
  
  draw_original_pick_box (global.selected_pick_box);  
  pick[global.selected_pick_box].mouse_over=0;
  global.selected_pick_box=-1;

}

//88unselect_pick_box888888888888888888888888888888888888888888888888888888888888888888888888
//88select_puzzle_box888888888888888888888888888888888888888888888888888888888888888888888888
void select_puzzle_box()
{

  if(global.selected_pick_box == -1)
    draw_select_puzzle_box(p_m,p_n,-1,-1);

         
  if(global.selected_pick_box != -1)
  {
    
    if(global.treat_doubt_as_pencil_in==TRUE  && global.selected_pick_box>=number_of_picks/2)
    { 
      if(global.two_player_game==FALSE)
      {
        
	if(sticky_selection==2)
          unselect_pick_box();
        
	if(sticky_selection==1)
           draw_select_puzzle_box(p_m,p_n,-1,-1);
        
        calculate_pencil_in(p_m,p_n,global.selected_pick_box-(number_of_picks/2));
        
	if(sticky_selection!=1)
           p_m=-1;
     
       }
    
     }
     else
     {  
     
       if(puzzle_box[p_m][p_n].value==-1 && convert_doubt_to_confirmed_text_if_necessery(global.selected_pick_box)!=-1)
       {
         global.number_of_free_boxes=global.number_of_free_boxes-1;
         update_status_bar_num_of_occupied_box();
       }
    
       if(global.two_player_game==TRUE)
         puzzle_box[p_m][p_n].type=11;   
       
       puzzle_box[p_m][p_n].value=global.selected_pick_box;
       
       if(sticky_selection==2)
         unselect_pick_box();
    
       if(sticky_selection==1)
       {
          draw_select_puzzle_box(p_m,p_n,puzzle_box[p_m][p_n].value,0);
          
	  if(global.auto_pencil_in_remove==TRUE)
            check_and_remove_and_display_pencil_in(p_m,p_n,puzzle_box[p_m][p_n].value);
          
	  if(global.two_player_game==FALSE)
            create_new_undo();
        }
        else
        {
          draw_select_puzzle_box(p_m,p_n,puzzle_box[p_m][p_n].value,1);
          
	  if(global.auto_pencil_in_remove==TRUE)
            check_and_remove_and_display_pencil_in(p_m,p_n,puzzle_box[p_m][p_n].value);
          
	  if(global.check_for_conflictF==FALSE && global.two_player_game==FALSE)
            p_m=-1;
          
	  if(global.two_player_game==FALSE)
            create_new_undo();
         }  
    
         if(global.check_for_conflictF==TRUE || global.two_player_game==TRUE)
         {
            check_conflicts_for_selected_pbox(p_m,p_n);
            if(global.two_player_game==TRUE)
            {
            
	    if(global.is_there_conflictsF==TRUE)
            {
               if(global.minus_points!=0)
	       {
	          if(global.minus_points!=20)
	           global.p1_points=global.p1_points-global.minus_points;
	          else
	           global.p1_points=global.p1_points-(puzzle_box[p_m][p_n].value+1);
	          
		  draw_score(0,global.p1_points);
                }
	        
		tmp_m=p_m;
	        global.conflict_by_player1=TRUE;
                puzzle_box[p_m][p_n].value=-1;
                puzzle_box[p_m][p_n].type=0;
             }
             else
             {
                
		global.p1_points=global.p1_points+puzzle_box[p_m][p_n].value+1;
                draw_score(0,global.p1_points);
                
		if( global.two_player_time_game_dupe==TRUE)
                  timing.tp_1_time=1;
                else
                {
                   global.disable_mouse=TRUE;
                   global.disable_keyboard=FALSE;
	           status_bar_update_tp_whoes_turn();
                }
              }
              
	      }
      
              if(sticky_selection!=1)
                p_m=-1;  
    
         }
         
     }
     
  }
  
}

//88select_puzzle_box888888888888888888888888888888888888888888888888888888888888888888888888
//88unselect_puzzle_box8888888888888888888888888888888888888888888888888888888888888888888888

void unselect_puzzle_box()
{

  draw_unselect_puzzle_box(p_m,p_n);
  p_m=-1;

}

//88unselect_puzzle_box8888888888888888888888888888888888888888888888888888888888888888888888
//88drawing_area_clicked888888888888888888888888888888888888888888888888888888888888888888888

gboolean drawing_area_clicked(GtkWidget *widget, GdkEventButton *event )
{
  
  if((global.two_player_game==TRUE && global.disable_mouse==FALSE) || global.two_player_game==FALSE)
  {
  
  if(global.is_there_conflictsF==TRUE)
  {
    
     global.is_there_conflictsF=FALSE;
     if(global.two_player_game==TRUE)
     {
     if(global.conflict_by_player1==TRUE)
     {
        gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
        gdk_draw_rectangle (pixmap_bckup,
                            gc,
                            TRUE,
                            puzzle_box[tmp_m][p_n].x+3,puzzle_box[tmp_m][p_n].y+3,
                            puzzle_box_square_size-5,
                            puzzle_box_square_size-5);      
    

     }
     else
     {
        gdk_gc_set_foreground(gc,&color.puzzle_bg);
     
        gdk_draw_rectangle (pixmap_bckup,
                            gc,
                            TRUE,
                            puzzle_box[key_row][key_column].x+3,puzzle_box[key_row][key_column].y+3,
                            puzzle_box_square_size-5,
                            puzzle_box_square_size-5);      

     }
     
     global.number_of_free_boxes=global.number_of_free_boxes+1;
     update_status_bar_num_of_occupied_box();
     }
     
     
     gdk_draw_drawable (pixmap,drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)], pixmap_bckup, 0, puzzle_box_y, 0, puzzle_box_y, drawing_area_w, drawing_area_h-puzzle_box_y);
     
     gdk_draw_pixmap(drawing_area->window,
                     drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                     pixmap,
                     0, puzzle_box_y,0,puzzle_box_y,
                     drawing_area_w,drawing_area_h-puzzle_box_y);
  
  }
  else
  {
     if(event->button==1)
       drawing_area_lclicked();
     else if(event->button==2)
       drawing_area_mclicked();
     else 
       drawing_area_rclicked(); 
  }
     
  }
  
  return TRUE;

}


//88drawing_area_clicked888888888888888888888888888888888888888888888888888888888888888888888
//88drawing_area_mclicked88888888888888888888888888888888888888888888888888888888888888888888

void drawing_area_mclicked()
{

  short i,j;
  gboolean put_break=FALSE;
 
 
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
  
     if( puzzle_box[i][j].value !=-1 && puzzle_box[i][j].type !=1  && puzzle_box[i][j].type !=11 && mouse_x>puzzle_box[i][j].x && mouse_x<puzzle_box[i][j].x+puzzle_box_square_size &&  mouse_y>puzzle_box[i][j].y && mouse_y<puzzle_box[i][j].y+puzzle_box_square_size)
     {
      
        draw_select_puzzle_box(i,j,-1,1);
        if(convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][j].value)!=-1)
        {
          global.number_of_free_boxes=global.number_of_free_boxes+1;
          update_status_bar_num_of_occupied_box();
        }
      
        puzzle_box[i][j].value=-1;
        put_break=TRUE;
        break;
     }  
    
     if(put_break==TRUE)
       break;
   } 
   if(put_break==TRUE)
     break;
   }


}

//88drawing_area_mclicked88888888888888888888888888888888888888888888888888888888888888888888
//88drawing_area_rclicked88888888888888888888888888888888888888888888888888888888888888888888

void drawing_area_rclicked()
{

 if(p_m!=-1)
   unselect_puzzle_box(p_m,p_n);
     
 
 if(global.selected_pick_box !=-1)
   unselect_pick_box();

}


//88drawing_area_rclicked88888888888888888888888888888888888888888888888888888888888888888888
//88drawing_area_lclicked88888888888888888888888888888888888888888888888888888888888888888888

void drawing_area_lclicked()
{

  int text_w;
  int text_h;
  short i,j;
  short x,y,size;
  
  char ch[2];
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;

  GdkRectangle update_rect;

  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
  
     if( (p_m != i || p_n !=j) && puzzle_box[i][j].type !=1 && puzzle_box[i][j].type !=11 && mouse_x>puzzle_box[i][j].x && mouse_x<puzzle_box[i][j].x+puzzle_box_square_size &&  mouse_y>puzzle_box[i][j].y && mouse_y<puzzle_box[i][j].y+puzzle_box_square_size)
     {
       
       if(p_m!=-1)
         unselect_puzzle_box(p_m,p_n);
        
       p_m=i;
       p_n=j;
       select_puzzle_box();       
       break;
     }  

  } 
  }
  
  
  if(global.selected_pick_box>-1 && global.highlighted_pick_box>-1)
    unselect_pick_box();
   
  if(global.highlighted_pick_box>-1)
    select_pick_box();

}

//88drawing_area_lclicked88888888888888888888888888888888888888888888888888888888888888888888
//88highlight_pick_box88888888888888888888888888888888888888888888888888888888888888888888888

void highlight_pick_box()
{
    
   pick[global.highlighted_pick_box].mouse_over=1;
   draw_highlight_pick_box(global.highlighted_pick_box);
  
}
  
//888highlight_pick_box8888888888888888888888888888888888888888888888888888888888888888888888
//888unhighlight_box8888888888888888888888888888888888888888888888888888888888888888888888888

void unhighlight_box ()
{
  
   draw_original_pick_box(global.highlighted_pick_box);
   pick[global.highlighted_pick_box].mouse_over=0; 
   global.highlighted_pick_box=-1;  
   
}
  
//88unhighlight_box88888888888888888888888888888888888888888888888888888888888888888888888888
//88mouse_movement_event888888888888888888888888888888888888888888888888888888888888888888888
  
gboolean mouse_movement_event( GtkWidget *widget, GdkEventMotion *event )
{
  
  short i;
  GdkModifierType state;
  
  
  if(global.keyboard_presentF==TRUE && global.is_there_conflictsF==FALSE && global.two_player_solveF==FALSE && global.two_player_game==FALSE)
  {
    draw_and_unselect_key_box();
    global.keyboard_presentF=FALSE;
  } 

  
  if (event->is_hint)
    gdk_window_get_pointer (event->window, &mouse_x, &mouse_y, &state);
  else
  {
     mouse_x = event->x;
     mouse_y = event->y;
     state = event->state;
  }
  
  if(global.disable_mouse==FALSE)
  { 
  
  
  if(global.highlighted_pick_box>-1)
  {
  if( (mouse_x<pick[global.highlighted_pick_box].x || mouse_x>pick[global.highlighted_pick_box].x+pick_square_size) || (mouse_y<pick[global.highlighted_pick_box].y || mouse_y>pick[global.highlighted_pick_box].y+pick_square_size))
  {
     unhighlight_box ();
  }
  } 
  else
  {
    for(i=0;i<number_of_picks;i++)
    {
       if( pick[i].mouse_over==0 && mouse_x>pick[i].x && mouse_x<pick[i].x+pick_square_size && mouse_y>pick[i].y && mouse_y<pick[i].y+pick_square_size)
       {
         global.highlighted_pick_box=i;
         highlight_pick_box ();
         break;
       }  
     }
  }
  
  
  }
  
  
  return TRUE;
  
}    

//88mouse_movement_event888888888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888





//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////
//convert_num_to_ascii////////////////////////////////////////////////////////////////////////

void convert_num_to_ascii(int num,char *ch)
{
 
  if(num<number_of_picks/2)
  {
    if(num>8)
     ch[0]=56+num;
    else
     ch[0]=49+num;
  } 
  else
  {
    if(num>24)
     ch[0]=40+num;
    else
     ch[0]=49+num-(number_of_picks/2);
  }

  ch[1]='\0';


}


//convert_num_to_ascii////////////////////////////////////////////////////////////////////////
//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////

//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////
//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////
