/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"

 GtkWidget *generator_dialog;
 GtkWidget *solver_dialog;
 
 short guessed;
 long my_seed;

/*  
List of functions:
gboolean puzzle_generator_timer(gpointer data)
gboolean puzzle_solver_timer(gpointer data)
void popup_dialog_solver()
gpointer solver_thread(gpointer data)
void popup_dialog_generator()
gpointer generator_thread(gpointer data)
void generator(long puzzle_number,short guess_threshold,gboolean symmetric)
void solver(short mode)
gboolean check_if_fits(short puzzle_box_value[][number_of_picks/2],short i,short j,short k)
gboolean check_for_candidate_available_once_in_row_column_or_box(....) 
gboolean check_for_candidates_contained_in_row_or_column_of_a_box(....)
gboolean check_for_row_column_number_contain_in_single_box(...)
gboolean check_for_doublets_triplets_etc(short possibles[][number_of_picks/2][number_of_picks/2+1])
gboolean check_for_advanced_doublets_triplets_etc(short possibles[][number_of_picks/2][number_of_picks/2+1])
gboolean check_block_block_interaction(short possibles[][number_of_picks/2][number_of_picks/2+1])
gboolean check_xwing_and_swordfish(short possibles[][number_of_picks/2][number_of_picks/2+1],short mode)
gboolean check_and_remove_number_from_possibles(...)


  
  
  
Accessories:
void back_up_possibles_and_puzzles(...)
void restore_possibles_and_puzzles(...)
void print_possibles(short possibles[][number_of_picks/2][number_of_picks/2+1]) use for debugging
short convert_doubt_to_confirmed_text_if_necessery(short value)


*/  


//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88puzzle_generator_timer8888888888888888888888888888888888888888888888888888888888888888888

gboolean puzzle_generator_timer(gpointer data)
{

  //GtkWidget *label;
  char ch2[120];
  short count;
  short num;
  short i,offset,len;

  if(global.puzzle_generation_successfulF==TRUE || global.invalid_puzzleF==TRUE)
  {       
    g_source_remove(timer_tag_id);
    timer_tag_id=0;
  }

  strcpy(ch2,"Time taken: ");
  count=strlen(ch2);
  global.generator_time=global.generator_time+1;
  num=global.generator_time/3600;
  
  if(num!=0)
  {
    ch2[count]=48+num/10;
    count=count+1;
    ch2[count]=48+num%10;
    count=count+1;
    ch2[count]=':';
    count=count+1;
  }
  
  num=(global.generator_time%3600)/60;
  ch2[count]=48+num/10;
  count=count+1;
  ch2[count]=48+num%10;
  count=count+1;
  ch2[count]=':';
  count=count+1;
  
  num=(global.generator_time%3600)%60;
  ch2[count]=48+num/10;
  count=count+1;
  ch2[count]=48+num%10;
  count=count+1;
    
  ch2[count]='\0';

	
  strcat(ch2,"\nNumber of cell filled: ");
  offset=strlen(ch2);
  num=guessed;
  if(num==0)
  {
    ch2[offset]='0';
    len=1;
  }
  else
  {
    len=0;
    while(num>0)
    {
      num=num/10;
      len=len+1;
    }
  
    num=guessed;
    for(i=len+offset-1;i>=offset;i--)
    {
      ch2[i]=48+num%10;  
      num=num/10;
    }
  }
  ch2[len+offset]='\0';
	
	
  if(global.puzzle_generation_successfulF==TRUE)
  {
    
    //  gtk_widget_realize(generator_dialog);
    //  gdk_window_set_decorations(generator_dialog->window,(GdkWMDecoration)(GDK_DECOR_ALL|GDK_DECOR_BORDER| GDK_DECOR_RESIZEH|GDK_DECOR_TITLE|GDK_DECOR_MENU| GDK_DECOR_MINIMIZE| GDK_DECOR_MAXIMIZE));
    //  gdk_window_set_functions(generator_dialog->window,(GdkWMFunction)(GDK_FUNC_ALL| GDK_FUNC_MOVE	| GDK_FUNC_MINIMIZE| GDK_FUNC_MAXIMIZE));

    strcat(ch2,"\nPuzzle generated successfully");
    gtk_dialog_set_response_sensitive (GTK_DIALOG(generator_dialog),GTK_RESPONSE_CLOSE, TRUE);
  } 
  
  if(global.invalid_puzzleF==TRUE)
  {
    strcat(ch2,"\nInvalid Puzzle: Try reducing the minimum guesses to be made without validating.");
    gtk_dialog_set_response_sensitive (GTK_DIALOG(generator_dialog),GTK_RESPONSE_CLOSE, TRUE);
  } 

  gtk_label_set_text(GTK_LABEL(data),(const char*)ch2);

}

//88puzzle_generator_timer99888888888888888888888888888888888888888888888888888888888888888
//88puzzle_solver_timer8888888888888888888888888888888888888888888888888888888888888888888

gboolean puzzle_solver_timer(gpointer data)
{

  //GtkWidget *label;
  char ch2[400];
  short count;
  short num;
  int tmp_time;

  if(global.solver_finished==TRUE)
  {       
     g_source_remove(timer_tag_id);
     timer_tag_id=0;
  }  


  strcpy(ch2,"Time taken: ");
  count=strlen(ch2);
  global.solver_time=global.solver_time+1;
  tmp_time=global.solver_time/10;
  num=tmp_time/3600;
  if(num!=0)
  {
     ch2[count]=48+num/10;
     count=count+1;
     ch2[count]=48+num%10;
     count=count+1;
     ch2[count]=':';
     count=count+1;
  }
  
  num=(tmp_time%3600)/60;
  ch2[count]=48+num/10;
  count=count+1;
  ch2[count]=48+num%10;
  count=count+1;
  ch2[count]=':';
  count=count+1;
  
  num=(tmp_time%3600)%60;
  ch2[count]=48+num/10;
  count=count+1;
  ch2[count]=48+num%10;
  count=count+1;

  num= global.solver_time%10;   
  ch2[count]=':';
  count=count+1;
  ch2[count]=48+num;
  count=count+1;

  ch2[count]='\0';

  if(global.solver_finished==TRUE)
  {
    if(global.have_solution==TRUE && global.have_to_guess==FALSE)
      strcat(ch2,"\nPuzzle solved successfully");

    if(global.have_solution==FALSE)
      strcat(ch2,"\nPuzzle cannot be solved");

    strcat(ch2,"\ntotal guesses: ");
    num=strlen(ch2);
    if(global.guesses/10 !=0)
    {
      ch2[num]=48+global.guesses/10;
      ch2[num+1]=48+global.guesses%10;
      ch2[num+2]='\0';
    }
    else
    { 
      ch2[num]=48+global.guesses;
      ch2[num+1]='\0';
    }
    
    strcat(ch2,"\ntimes found hidden unique candidate: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_hidden_unique_candidate;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found block interaction with row and column: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_block_interaction_with_row_and_column;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found row and column interaction with block: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_row_and_column_interaction_with_block;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found visible doublets triplets etc: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_visible_doublets_triplets_etc;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found block block interaction: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_block_block_interaction;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found xwing: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_xwing;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found hidden doublets triplets etc: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_hidden_doublets_triplets_etc;
    ch2[num+1]='\0';
   
    strcat(ch2,"\ntimes found swordfish: ");
    num=strlen(ch2);
    ch2[num]=48+global.num_swordfish;
    ch2[num+1]='\0';
    gtk_dialog_set_response_sensitive (GTK_DIALOG(solver_dialog),GTK_RESPONSE_CLOSE, TRUE);

  }


  gtk_label_set_text(GTK_LABEL(data),(const char*)ch2);
  

}

//88puzzle_solver_timer99888888888888888888888888888888888888888888888888888888888888888
//88popup_dialog_solver8888888888888888888888888888888888888888888888888888888888888888888

void popup_dialog_solver()
{
  
  GtkWidget *label;  
  GtkWidget *tlabel;    
  GtkWidget *table;
  GError *thread_err=NULL;
  gint response;
  
  char ch[50];
    
  solver_dialog=gtk_dialog_new_with_buttons ("Puzzle solver",NULL,                                   GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_CLOSE, GTK_RESPONSE_CLOSE, GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL, NULL);
  gtk_window_set_default_size(GTK_WINDOW(solver_dialog),300,250);
  gtk_widget_realize(solver_dialog);
//  gdk_window_set_decorations(solver_dialog->window,(GdkWMDecoration)(GDK_DECOR_BORDER| GDK_DECOR_TITLE|       GDK_DECOR_MINIMIZE| GDK_DECOR_MAXIMIZE));
//  gdk_window_set_functions(solver_dialog->window,(GdkWMFunction)(0));
  global.abort_generator=FALSE;
  
  //gtk_widget_set_sensitive (GtkWidget *widget,      gboolean sensitive);
  gtk_dialog_set_response_sensitive (GTK_DIALOG(solver_dialog),  GTK_RESPONSE_CLOSE, FALSE);
  table = gtk_table_new (5, 2, FALSE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (solver_dialog)->vbox),table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),6);
  
//  gtk_table_set_row_spacings (GTK_TABLE (table),0);
  gtk_table_set_col_spacings (GTK_TABLE (table),12);

  strcpy(ch,"Hidden unique candidate: ");
  if(global.s_hidden_unique_candidate==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach(GTK_TABLE (table),label,0,1,0,1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
    
  strcpy(ch,"block interaction with row/column: ");
  if(global.s_block_interaction_with_row_and_column==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,1,2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"row/column interaction with block: ");
  if(global.s_row_and_column_interaction_with_block==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,2,3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
 
  strcpy(ch,"Visible doublets triplets etc: ");
  if(global.s_visible_doublets_triplets_etc==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,3,4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);

  
  strcpy(ch,"Block and block interaction: ");
  if(global.s_block_block_interaction==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,1,2,0,1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"XWing: ");
  if(global.s_xwing==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,1,2,1,2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"Hidden doublets triplets etc: ");
  if(global.s_hidden_doublets_triplets_etc==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,1,2,2,3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"Swordfish: ");
  if(global.s_swordfish==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,1,2,3,4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
 
  label=gtk_label_new( (const char*)"  " );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,4,5,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  gtk_widget_show (table);
  
  table = gtk_table_new (6, 1, FALSE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (solver_dialog)->vbox),table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),6);

 
 
  //gtk_table_set_row_spacing(GTK_TABLE(table),4,18);
  strcpy(ch,"Time taken: ");
  global.solver_time=0;
  tlabel=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(tlabel),0,0.5);
  gtk_table_attach (GTK_TABLE (table),tlabel,0,1,0,1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (tlabel);
 
  gtk_widget_show (table);
 
  global.solver_finished=FALSE;
  timer_tag_id=g_timeout_add(100,(GSourceFunc)puzzle_solver_timer,tlabel);
 
 if(global.show_figures_while_solving==TRUE)
  create_new_undo(); 
 
  if((thread=g_thread_create((GThreadFunc)solver_thread,NULL,TRUE,&thread_err))==NULL)
  {
    g_print("thread creation fail\n");
    g_error_free(thread_err);
  }
 
  response=gtk_dialog_run (GTK_DIALOG (solver_dialog));
 
  if(timer_tag_id!=0)
  {       
    g_source_remove(timer_tag_id);
    timer_tag_id=0;
  }  
  
  if(response==GTK_RESPONSE_CANCEL || response==GTK_RESPONSE_DELETE_EVENT)
  {
    global.abort_generator=TRUE;
  }
 

   gtk_widget_destroy (solver_dialog);

}

//88popup_dialog_solver888888888888888888888888888888888888888888888888888888888888888888888
//88solver_thread888888888888888888888888888888888888888888888888888888888888888888888888888

gpointer solver_thread(gpointer data)
{
  global.have_solution=TRUE;
  global.have_to_guess=FALSE;

  solver(0);
  return NULL;
  
}

//88solver_thread8888888888888888888888888888888888888888888888888888888888888888888888888888
//88popup_dialog_generator8888888888888888888888888888888888888888888888888888888888888888888

void popup_dialog_generator()
{
  
  GtkWidget *label;  
  GtkWidget *tlabel;    
  GtkWidget *table;
  GError *thread_err=NULL;
  gint response;
  
  char ch[50];
    
   gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku");  
   gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  ");

  
  generator_dialog=gtk_dialog_new_with_buttons ("Puzzle generator",NULL,                                      GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, "Play", GTK_RESPONSE_CLOSE, GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL, NULL);
  gtk_window_set_default_size(GTK_WINDOW(generator_dialog),300,250);
  gtk_widget_realize(generator_dialog);
//  gdk_window_set_decorations(generator_dialog->window,(GdkWMDecoration)(GDK_DECOR_BORDER| GDK_DECOR_TITLE|    GDK_DECOR_MINIMIZE| GDK_DECOR_MAXIMIZE));
//  gdk_window_set_functions(generator_dialog->window,(GdkWMFunction)(0));
  global.abort_generator=FALSE;
  
  //gtk_widget_set_sensitive (GtkWidget *widget,      gboolean sensitive);
  gtk_dialog_set_response_sensitive (GTK_DIALOG(generator_dialog),  GTK_RESPONSE_CLOSE, FALSE);
  table = gtk_table_new (12, 1, FALSE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (generator_dialog)->vbox),table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),6);
  
// gtk_table_set_row_spacings (GTK_TABLE (table),0);
// gtk_table_set_col_spacings (GTK_TABLE (table),8);

  strcpy(ch,"Hidden unique candidate: ");
  if(global.s_hidden_unique_candidate==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach(GTK_TABLE (table),label,0,1,0,1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
    
  strcpy(ch,"block interaction with row/column: ");
  if(global.s_block_interaction_with_row_and_column==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,1,2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"row/column interaction with block: ");
  if(global.s_row_and_column_interaction_with_block==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,2,3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
 
  strcpy(ch,"Visible doublets triplets etc: ");
  if(global.s_visible_doublets_triplets_etc==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,3,4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);

  
  strcpy(ch,"Block and block interaction: ");
  if(global.s_block_block_interaction==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,4,5,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"XWing: ");
  if(global.s_xwing==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,5,6,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"Hidden doublets triplets etc: ");
  if(global.s_hidden_doublets_triplets_etc==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,6,7,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
  strcpy(ch,"Swordfish: ");
  if(global.s_swordfish==TRUE)
    strcat(ch,"Yes"); 
  else 
    strcat(ch,"No");
  label=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table),label,0,1,7,8,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);
  
 
 
 
 
  gtk_table_set_row_spacing(GTK_TABLE(table),7,18);
  strcpy(ch,"Time taken: ");
  global.generator_time=0;
  tlabel=gtk_label_new( (const char*)ch );
  gtk_misc_set_alignment (GTK_MISC(tlabel),0,0.5);
  gtk_table_attach (GTK_TABLE (table),tlabel,0,1,8,9,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (tlabel);
 
  gtk_widget_show (table);
 
  global.invalid_puzzleF=FALSE;
  global.puzzle_generation_successfulF=FALSE;
  global.generator_finished=FALSE;
  timer_tag_id=g_timeout_add(1000,(GSourceFunc)puzzle_generator_timer,tlabel);
 
  if((thread=g_thread_create((GThreadFunc)generator_thread,NULL,TRUE,&thread_err))==NULL)
  {
    g_print("thread creation fail\n");
    g_error_free(thread_err);
  }
 
  response=gtk_dialog_run (GTK_DIALOG (generator_dialog));
  if(timer_tag_id!=0)
  {       
    g_source_remove(timer_tag_id);
    timer_tag_id=0;
  }  
 
  if(response==GTK_RESPONSE_CANCEL || response==GTK_RESPONSE_DELETE_EVENT)
  {
    global.abort_generator=TRUE;
    if(global.generator_finished==TRUE)   
    { 
      initialize_and_draw_empty_puzzle();
      create_new_undo();
      gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  Editor mode");
      global.edit_modeF=TRUE;
      
    }   
  }
  
  if(global.invalid_puzzleF==TRUE &&  response!=GTK_RESPONSE_CANCEL)
    initialize_and_draw_empty_puzzle();
   
   
  gtk_widget_destroy (generator_dialog);


}

//88popup_dialog_generator8888888888888888888888888888888888888888888888888888888888888888888
//88generator_thread8888888888888888888888888888888888888888888888888888888888888888888888888

gpointer generator_thread(gpointer data)
{
//  gdk_threads_enter();
  generator(global.puzzle_number,global.guess_threshold,global.symmetric_puzzleF);
//  gdk_flush();
//  gdk_threads_leave();
  if(global.abort_generator==TRUE)
  {
    gdk_threads_enter();
    initialize_and_draw_empty_puzzle();
    gdk_flush();
    gdk_threads_leave();
    
    create_new_undo();
    gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  Editor mode");
    
    global.edit_modeF=TRUE;

  }  

  return NULL;
  
}

//88generator_thread8888888888888888888888888888888888888888888888888888888888888888888888888
//88generator88888888888888888888888888888888888888888888888888888888888888888888888888888888
  
void generator(guint32 puzzle_number,short guess_threshold,gboolean symmetric)
{

  short i,j,k,x,y,k_value;
  short possibles[number_of_picks/2][number_of_picks/2][number_of_picks/2+1];
  short possibles_bck_up[number_of_picks/2][number_of_picks/2][number_of_picks/2+1];
  short puzzle_box_bck_up[number_of_picks/2][number_of_picks/2];
  short puzzle_box_type_bck_up[number_of_picks/2][number_of_picks/2];
  //short tmp_guessed;
  short guess_below_this_number;
  short tmp_value;

  gboolean placed_success;
  gboolean check;
  gboolean need_a_break;
 
  gdk_threads_enter();
  initialize_and_draw_empty_puzzle();
  gdk_flush();
  gdk_threads_leave();
  guessed=0;
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    for(k=0;k<number_of_picks/2;k++)
      possibles[i][j][k]=k;
    possibles[i][j][number_of_picks/2]=-1;
  }
  }

  grand=g_rand_new_with_seed(puzzle_number);
  
  if(global.show_console_messegesF==TRUE)
     g_print("guess_threshold: %d",guess_threshold);

  
  
  while(1)
  {
//     tmp_guessed=guessed;
     x=g_rand_int(grand)%(number_of_picks/2);
     y=g_rand_int(grand)%(number_of_picks/2);
     placed_success=FALSE;
  
     if(global.abort_generator==TRUE)
       break;
  
     if(puzzle_box[x][y].value==-1  && possibles[x][y][0]!=-1 && possibles[x][y][1]!=-1)
     {
         guess_below_this_number=0;
         for(i=0;i<number_of_picks/2;i++)
         {
           if(possibles[x][y][i]==-1)
           break;
           guess_below_this_number=guess_below_this_number+1; 
         }
  
         k_value=g_rand_int(grand)%guess_below_this_number;
    
         back_up_possibles_and_puzzles(possibles,possibles_bck_up,puzzle_box_bck_up,puzzle_box_type_bck_up);

         puzzle_box[x][y].value=possibles[x][y][k_value]; 
         check_and_remove_number_from_possibles(possibles,x,y,possibles[x][y][k_value]);
      
         for(i=0;i<number_of_picks/2;i++)
         {
           if(possibles[x][y][i]!=-1)
             possibles[x][y][i]=-1;
           else
             break;
         }
     
         puzzle_box[x][y].type=1;
         guessed=guessed+1;
   
         while(1)
         {
           check=FALSE;
    	   for(i=0;i<number_of_picks/2;i++)
           {
           for(j=0;j<number_of_picks/2;j++)
           {
             if(possibles[i][j][0]!=-1 && possibles[i][j][1]==-1)
	         {
                tmp_value=possibles[i][j][0];
                check=check_and_remove_number_from_possibles(possibles,i,j,tmp_value);
                possibles[i][j][0]=tmp_value;
             }
           }
           }

 	   if(check==TRUE)
	      continue;
	   if(global.g_hidden_unique_candidate==TRUE)
           {
             check=check_for_candidate_available_once_in_row_column_or_box(possibles);
             if(check==TRUE)
               continue;
           }
           if(global.g_block_interaction_with_row_and_column==TRUE)
           {
             check=check_for_candidates_contained_in_row_or_column_of_a_box(possibles);
             if(check==TRUE)
               continue;
           }
           if(global.g_row_and_column_interaction_with_block==TRUE)
           {
             check=check_for_row_column_number_contain_in_single_box(possibles);
             if(check==TRUE)
               continue;
           }
           if(global.g_visible_doublets_triplets_etc==TRUE)
           {
             check=check_for_doublets_triplets_etc(possibles);
             if(check==TRUE)
               continue;
           }
           if(global.g_block_block_interaction==TRUE)
           {
             check=check_block_block_interaction(possibles);
             if(check==TRUE)
               continue;
           }
           if(global.g_hidden_doublets_triplets_etc==TRUE)
           {
             check=check_for_advanced_doublets_triplets_etc(possibles);
             if(check==TRUE)
               continue;
           }
           if(global.g_xwing==TRUE || global.g_swordfish==TRUE)
           {
             check=check_xwing_and_swordfish(possibles,2);
             if(check==TRUE)
               continue;
           }
      
           break; 
     
         }
     
    
         if(guessed<=guess_threshold)
            placed_success=TRUE;
  
         if(guessed>guess_threshold)
         {
            global.have_solution=TRUE;
            global.have_to_guess=FALSE;
            solver(0);

            if(global.have_solution==TRUE && global.have_to_guess==TRUE)
            {
               placed_success=TRUE;
            }  
       
            if(global.have_solution==TRUE && global.have_to_guess==FALSE)
            {
              global.puzzle_generation_successfulF=TRUE;
  	      if(global.show_console_messegesF==TRUE)
              {
	       g_print("puzzle_number: %lu\n",puzzle_number);
               g_print("found a puzzle\n");
              }
	      break;
            }

            if(global.have_solution==FALSE)
            {
              if(guessed==guess_threshold+1)
	      {
	         global.invalid_puzzleF=TRUE;
                 if(global.show_console_messegesF==TRUE)
	         {
		  g_print("try reducing the guess threshold\n");
                  g_print("puzzle_number: %lu\n",puzzle_number);
	         }
		 break;
              }
//              g_print("wrong_puzzle puzzle\n");
//	        getchar();
              guessed=guessed-1;
              restore_possibles_and_puzzles(possibles,possibles_bck_up,puzzle_box_bck_up,puzzle_box_type_bck_up);
            }
	      
         }
      
     }
  
     if(symmetric==TRUE && placed_success==TRUE  && !(board_size==3 &&  x==4  &&  y==4))
     {
  
        x=(number_of_picks/2-1)-x;
        y=(number_of_picks/2-1)-y;
  
        if(puzzle_box[x][y].value==-1 && possibles[x][y][0]!=-1 )
        {
            guess_below_this_number=0;
            for(i=0;i<number_of_picks/2;i++)
            { 
              if(possibles[x][y][i]==-1)
                break;
	      guess_below_this_number=guess_below_this_number+1; 
            }
            k_value=g_rand_int(grand)%guess_below_this_number;
  
            puzzle_box[x][y].value=possibles[x][y][k_value]; 
            check_and_remove_number_from_possibles(possibles,x,y,possibles[x][y][k_value]);
          
	    for(i=0;i<number_of_picks/2;i++)
            {
              if(possibles[x][y][i]!=-1)
                possibles[x][y][i]=-1;
              else
                break;
            }
   
            while(1)
            {
              
	      check=FALSE;
	      for(i=0;i<number_of_picks/2;i++)
              {
              for(j=0;j<number_of_picks/2;j++)
              {
                 if(possibles[i][j][0]!=-1 && possibles[i][j][1]==-1)
	         {
                    tmp_value=possibles[i][j][0];
                    check=check_and_remove_number_from_possibles(possibles,i,j,tmp_value);
	            possibles[i][j][0]=tmp_value;
                 }
              } 
	      }
	   
	      if(check==TRUE)
	        continue;
              
	      if(global.g_hidden_unique_candidate==TRUE)
              {
                check=check_for_candidate_available_once_in_row_column_or_box(possibles);
                if(check==TRUE)
                 continue;
              }
              if(global.g_block_interaction_with_row_and_column==TRUE)
              {
                check=check_for_candidates_contained_in_row_or_column_of_a_box(possibles);
                if(check==TRUE)
                  continue;
              }
              if(global.g_row_and_column_interaction_with_block==TRUE)
              {
                 check=check_for_row_column_number_contain_in_single_box(possibles);
                 if(check==TRUE)
                   continue;
              }
              if(global.g_visible_doublets_triplets_etc==TRUE)
              {
                 check=check_for_doublets_triplets_etc(possibles);
                 if(check==TRUE)
                   continue;
              }
              if(global.g_block_block_interaction==TRUE)
              {
                 check=check_block_block_interaction(possibles);
                 if(check==TRUE)
                   continue;
              }
              if(global.g_hidden_doublets_triplets_etc==TRUE)
              {
                 check=check_for_advanced_doublets_triplets_etc(possibles);
                 if(check==TRUE)
                   continue;
              }
              if(global.g_xwing==TRUE || global.g_swordfish==TRUE)
              {
                 check=check_xwing_and_swordfish(possibles,2);
                 if(check==TRUE)
                   continue;
              }
               
              break; 
     
           }
   
   
           puzzle_box[x][y].type=1;
           guessed=guessed+1;
           if(guessed>guess_threshold)
           {
              global.have_solution=TRUE;
              global.have_to_guess=FALSE;
	      solver(0);
//	      if(have_solution==TRUE && have_to_guess==TRUE)
//	      {
//	        g_print("canto do without guess2\n");
//	      }  
	
	      if(global.have_solution==TRUE && global.have_to_guess==FALSE)
	      {
                 global.puzzle_generation_successfulF=TRUE;
                 if(global.show_console_messegesF==TRUE)
                 {
		  g_print("puzzle_number: %lu\n",puzzle_number);
  	          g_print("found a puzzle\n");
	         }
		 break;
              }
	
              if(global.have_solution==FALSE)
	      {
	        if(guessed==guess_threshold+1)
	        {
                   global.invalid_puzzleF=TRUE;
                   if(global.show_console_messegesF==TRUE)
		   {
		    g_print("puzzle_number: %lu\n",puzzle_number);
	            g_print("try reducing the guess threshold\n");
	           }
		   break;
	        }  
//	        g_print("wrong_puzzle puzzle\n");
                guessed=guessed-2;

                restore_possibles_and_puzzles(possibles,possibles_bck_up,puzzle_box_bck_up,puzzle_box_type_bck_up);
              }
	      
           }
      
  
       }
       else
       {
         guessed=guessed-2;
         restore_possibles_and_puzzles(possibles,possibles_bck_up,puzzle_box_bck_up,puzzle_box_type_bck_up);
       }
  
     }

     if(guessed<=guess_threshold)
     {  
       need_a_break=TRUE;
       for(i=0;i<number_of_picks/2;i++)
       {
       for(j=0;j<number_of_picks/2;j++)
       {
         if(puzzle_box[i][j].value==-1  && possibles[i][j][0]!=-1 && possibles[i][j][1]!=-1)
           need_a_break=FALSE;
       }  
       }
       
       if(need_a_break==TRUE)
       {
          global.invalid_puzzleF=TRUE;
          if(global.show_console_messegesF==TRUE)
          {
	   g_print("puzzle_number: %lu\n",puzzle_number);
           g_print("try reducing the guess threshold\n");
          }
	  break;
       }  
       }


  }
  
  global.generator_finished=TRUE;
  if(global.show_console_messegesF==TRUE)
    g_print("occupied boxes %d",guessed);

}   


//88generator88888888888888888888888888888888888888888888888888888888888888888888888888888888
//88solver88888888888888888888888888888888888888888888888888888888888888888888888888888888888

void solver(short mode)
{
/*
mode 0: dont write puzzle value
mode 1: write puzzle_value
*/

struct node
{
short possibles[number_of_picks/2][number_of_picks/2][number_of_picks/2+1];
short puzzle_box_value[number_of_picks/2][number_of_picks/2];
short method_count[8];
short i;
short j;
short k;
short store_value_count;
short number_of_free_boxes;
struct node *prev;
};

struct store_value
{
short i;
short j;
short value;
}store_value[number_of_picks*number_of_picks/4];

short type[number_of_picks/2][number_of_picks/2];
short i,j,k,m;
short number_of_free_boxes=0;
short nofb;
//short guess_number=0;
short store_value_count=0;

gboolean put_break;
gboolean is_it_possible;
gboolean force_break_the_loop=FALSE;
gboolean take_advanced_guess_return;

struct node *p;
struct node *temp;
struct node *q;


p=g_malloc(sizeof(struct node));
p->i=0;
p->j=0;
p->k=0;
p->prev=NULL;
temp=p;

global.guesses=0;
for(i=0;i<8;i++)
 temp->method_count[i]=0;

for(i=0;i<number_of_picks/2;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
   temp->puzzle_box_value[i][j]=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][j].value);
   
   type[i][j]=puzzle_box[i][j].type;
      
   for(k=0;k<number_of_picks/2+1;k++)
   {
      temp->possibles[i][j][k]=-1;
    
   }
}
}

for(i=0;i<number_of_picks/2;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
     
   if(temp->puzzle_box_value[i][j]==-1)
   {

        number_of_free_boxes=number_of_free_boxes+1;
     
   for(k=0;k<number_of_picks/2;k++)
   {
      
       if(check_if_fits(temp->puzzle_box_value,i,j,k)==TRUE)
        {
	  for(m=0;m<number_of_picks/2;m++)
	  {
	    
	    
	    if(temp->possibles[i][j][m]==-1)
	    {
	      temp->possibles[i][j][m]=k;
	      break;
	    
	    }  
	  }
        }
   
   
   }
   }
   
   
}
}

global.number_of_free_boxes=number_of_free_boxes; 

while(number_of_free_boxes>0)
{

  if(global.abort_generator==TRUE)
    break;
  
  if(force_break_the_loop==TRUE)
    break;
  
  nofb=number_of_free_boxes;
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {

      if(temp->possibles[i][j][0]!=-1 && temp->possibles[i][j][1] ==-1)
      {
         if(mode==0 && global.show_figures_while_solving==TRUE)
	  {
	   gdk_threads_enter();
	   draw_select_puzzle_box(i,j,temp->possibles[i][j][0],1);
	   gdk_flush();
	   gdk_threads_leave();
	  }

	 //if(temp->prev==NULL)
	 //draw_select_puzzle_box(i,j,temp->possibles[i][j][0],1);
	 //else
	 //{
	 //  store_value[store_value_count].i=i;
	 //  store_value[store_value_count].j=j;
	 //  store_value[store_value_count].value=temp->possibles[i][j][0];
	 //  store_value_count=store_value_count+1;
	 //}
	 //g_print("gen| x  y  possible: %d  %d  %d\n",i,j,temp->possibles[i][j][0]);
	 
	 temp->puzzle_box_value[i][j]=temp->possibles[i][j][0];
         number_of_free_boxes=number_of_free_boxes-1;
	 check_and_remove_number_from_possibles(temp->possibles,i,j,temp->possibles[i][j][0]);
      
      }
      
      if(number_of_free_boxes==0 )
//      {
       global.have_solution=TRUE;
        //  for(k=0;k<store_value_count;k++)
    	//   draw_select_puzzle_box(store_value[k].i,store_value[k].j,store_value[k].value,1);
//         force_break_the_loop=TRUE;
//       }

 }
 }   
   
//   if(force_break_the_loop==TRUE)
//    break;

 if(nofb==number_of_free_boxes)
 {
 

   take_advanced_guess_return=FALSE;

   if(take_advanced_guess_return==FALSE && global.s_hidden_unique_candidate==TRUE)
   {
     take_advanced_guess_return=check_for_candidate_available_once_in_row_column_or_box(temp->possibles);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[0]=temp->method_count[0]+1;
   }
   
   if(take_advanced_guess_return==FALSE && global.s_block_interaction_with_row_and_column==TRUE)
   {
     take_advanced_guess_return=check_for_candidates_contained_in_row_or_column_of_a_box(temp->possibles);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[1]=temp->method_count[1]+1;

   }
   
   if(take_advanced_guess_return==FALSE && global.s_row_and_column_interaction_with_block==TRUE)
   {
     take_advanced_guess_return=check_for_row_column_number_contain_in_single_box(temp->possibles);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[2]=temp->method_count[2]+1;

   }
    
   if(take_advanced_guess_return==FALSE && global.s_visible_doublets_triplets_etc==TRUE)
   {
       take_advanced_guess_return=check_for_doublets_triplets_etc(temp->possibles);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[3]=temp->method_count[3]+1;
   }
   
    
   if(take_advanced_guess_return==FALSE && global.s_block_block_interaction==TRUE)
   {
      take_advanced_guess_return=check_block_block_interaction(temp->possibles);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[4]=temp->method_count[4]+1;
   }
   
   if(take_advanced_guess_return==FALSE && global.s_xwing==TRUE)
   {
     take_advanced_guess_return=check_xwing_and_swordfish(temp->possibles,0);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[5]=temp->method_count[5]+1;
   }
   
   if(take_advanced_guess_return==FALSE && global.s_hidden_doublets_triplets_etc==TRUE)
   {
      take_advanced_guess_return=check_for_advanced_doublets_triplets_etc(temp->possibles);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[6]=temp->method_count[6]+1;
   }
   
   if(take_advanced_guess_return==FALSE && global.s_swordfish==TRUE)
   {
     take_advanced_guess_return=check_xwing_and_swordfish(temp->possibles,1);
     if(take_advanced_guess_return==TRUE)
     temp->method_count[7]=temp->method_count[7]+1;
   }
   
      
   if(take_advanced_guess_return==FALSE)
   {
      global.have_to_guess=TRUE;
      is_it_possible=TRUE;
      put_break=FALSE;
      for(i=0;i<number_of_picks/2;i++)
      {
      for(j=0;j<number_of_picks/2;j++)
      {
        if(temp->puzzle_box_value[i][j]==-1 && temp->possibles[i][j][0]==-1)
	  {
	    is_it_possible=FALSE;
	    put_break=TRUE;
            break;
          }
      
      }
      if(put_break==TRUE)
      break;
      }
    
    
    
    q=g_malloc(sizeof(struct node));
    global.guesses=global.guesses+1;
    temp->store_value_count=store_value_count;
    temp->number_of_free_boxes=number_of_free_boxes;
    *q=*temp;
    q->prev=temp;

    if(is_it_possible==TRUE)
    {
        put_break=FALSE;  
        for(i=temp->i;i<number_of_picks/2;i++)
        {
        for(j=temp->j;j<number_of_picks/2;j++)
        {
	  
        for(k=temp->k;k<number_of_picks/2;k++)
        {
	       if(temp->possibles[i][j][k]!=-1)
               { 
                 temp->i=i;
                 temp->j=j;
                 temp->k=k+1;
                 put_break=TRUE;
                 break;
               }
         }
 	  if(k==number_of_picks/2 && temp->possibles[i][j][0]!=-1)
	    {
              put_break=TRUE;
	      is_it_possible=FALSE;
	      break;
	    }
	  if(k==number_of_picks/2)
              temp->k=0;     
          if(put_break==TRUE)
            break;
         }
	  if(j==number_of_picks/2)
              temp->j=0;     
         
	 if(put_break==TRUE)
           break;
         }
       
      if(is_it_possible==TRUE)
      {
  //      for(k=0;k<number_of_picks/2;k++)
  //      {
//	for(m=0;m<number_of_picks/2;m++)
  //        g_print("%d    ",temp->possibles[k][m][0]);
  //         g_print("\n");       
//	}
//         g_print("force_guessed  %d\n",temp->possibles[i][j][k]);
//         getchar();
	 
        if(i!=number_of_picks/2 && j != number_of_picks/2 && k != number_of_picks/2)
        {
          q->puzzle_box_value[i][j]=temp->possibles[i][j][k];
          number_of_free_boxes=number_of_free_boxes-1;
          q->number_of_free_boxes=number_of_free_boxes;
     
          if(mode==0 && global.show_figures_while_solving==TRUE)
	  {
	   gdk_threads_enter();
           draw_select_puzzle_box(i,j,temp->possibles[i][j][k],1);
	   gdk_flush();
	   gdk_threads_leave();
	  }

          for(m=0;m<number_of_picks/2;m++)
          {
            if(q->possibles[i][j][m]!=-1)
              q->possibles[i][j][m]=-1;
	    else
	      break; 
          }
     
          q->possibles[i][j][0]=temp->possibles[i][j][k]; 
          check_and_remove_number_from_possibles(q->possibles,i,j,q->possibles[i][j][0]);
          temp=q;
	  
       }
       else
       {
          if(temp->prev!=NULL)
            is_it_possible=FALSE;
	  else
          {
//            g_print("puzzle cannot be solved\n");
            break;
          }
       }
   
     }
   
   
   }

   
   if(is_it_possible==FALSE)
   {
        
	if(temp->prev!=NULL)
	{
	g_free(q);
        q=temp->prev;
        g_free(temp);
        global.guesses=global.guesses-2;
        store_value_count=q->store_value_count;
        number_of_free_boxes=q->number_of_free_boxes;
        temp=q;
//        g_print("reversing\n");
	}
	else
	{
//	 g_print("this_puzzle_cannot_be_solved\n");
//	 getchar();
	 force_break_the_loop=TRUE;
	 global.have_solution=FALSE;
	
	}
   }
   
 }
 }
}

   global.num_hidden_unique_candidate=temp->method_count[0];
   global.num_block_interaction_with_row_and_column=temp->method_count[1];
   global.num_row_and_column_interaction_with_block=temp->method_count[2];
   global.num_visible_doublets_triplets_etc=temp->method_count[3];
   global.num_block_interaction_with_row_and_column=temp->method_count[4];
   global.num_xwing=temp->method_count[5];
   global.num_hidden_doublets_triplets_etc=temp->method_count[6];
   global.num_swordfish=temp->method_count[7];

if(temp->prev!=NULL)
{
q=temp->prev;
g_free(temp);
temp=q;
}

g_free(p);
   

global.solver_finished=TRUE;

}

//88solver88888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88check_if_fits8888888888888888888888888888888888888888888888888888888888888888888888888888
gboolean check_if_fits(short puzzle_box_value[][number_of_picks/2],short i,short j,short k)
{
short x,y;
short tmp1,tmp2;

for(x=0;x<number_of_picks/2;x++)
{

    if(i != x && puzzle_box_value[x][j]==k)
        return FALSE;
}

for(x=0;x<number_of_picks/2;x++)
{
   if(j != x && puzzle_box_value[i][x]==k)
       return FALSE;

}

tmp1=board_size*(i/board_size);
tmp2=board_size*(j/board_size);

for(x=tmp1;x<tmp1+board_size;x++)
{
  for(y=tmp2;y<tmp2+board_size;y++)
  {
    if( (i!= x || j !=y) && puzzle_box_value[x][y]==k)
       return FALSE;
  }
}

return TRUE;
}

//88check_if_fits8888888888888888888888888888888888888888888888888888888888888888888888888888
//88check_for_candidate_available_once_in_row_column_or_box8888888888888888888888888888888888

gboolean check_for_candidate_available_once_in_row_column_or_box(short possibles[][number_of_picks/2][number_of_picks/2+1])
{

short i,j,k;
short x,y,z;
short tmp1,tmp2;
gboolean present;
gboolean put_break;
//gboolean xbreak,ybreak;
gboolean xpresent,ypresent,xypresent;
gboolean removed_some_possibles=FALSE;

for(x=0;x<number_of_picks/2;x++)
{
for(y=0;y<number_of_picks/2;y++)
{

 if( possibles[x][y][0]==-1 || possibles[x][y][1]==-1)  //this is for generator
   continue;

for(z=0;z<number_of_picks/2;z++)
{

 if( possibles[x][y][z]==-1)
   break;
   
 xpresent=FALSE;
 ypresent=FALSE;
 xypresent=FALSE;
 for(i=0;i<number_of_picks/2;i++)
 {
   for(j=0;j<number_of_picks/2;j++)
   {
      if(i!=x && possibles[i][y][j]==possibles[x][y][z])
        ypresent=TRUE;

      if(i!=y && possibles[x][i][j]==possibles[x][y][z])
        xpresent=TRUE;
     
      if( (xpresent==TRUE  && ypresent==TRUE) ||  (possibles[i][y][j]==-1 && possibles[x][i][j]==-1) )
        break;
   }    
   if(xpresent==TRUE  && ypresent==TRUE)
     break;
 }
                                
 
tmp1=board_size*(x/board_size);
tmp2=board_size*(y/board_size);
put_break=FALSE;
for(i=tmp1;i<tmp1+board_size;i++)
{
for(j=tmp2;j<tmp2+board_size;j++)
{
for(k=0;k<number_of_picks/2;k++)
{
 if(possibles[i][j][k]==-1)
   break;
 
 if(i!= x || j !=y)
 {
 
   if(possibles[i][j][k]==possibles[x][y][z])
    {
      xypresent=TRUE;
      put_break=TRUE;
      break;
    
    }
 
 }   
}
if( put_break==TRUE)
  break;

}
if( put_break==TRUE)
  break;
}
 
 
 if(xpresent==FALSE || ypresent==FALSE || xypresent==FALSE)
 {
     //g_print("x   y   xy: %d   %d    %d\n",xpresent,ypresent,xypresent);
    // g_print("x   y   possible: %d   %d    %d\n",x,y,possibles[x][y][z]);

    removed_some_possibles=TRUE;
    possibles[x][y][0]=possibles[x][y][z];
       
    for(j=1;j<number_of_picks/2;j++)
    {
      if(possibles[x][y][j]!=-1)
       possibles[x][y][j]=-1;
      else 
       break;
    
    }
     
 
 }
 
 

}
}
}

 
 if(global.show_console_messegesF==TRUE)
 {
  if(removed_some_possibles==TRUE)
   g_print("++found lonely candidate\n");
  else
   g_print("**fail: finding lonly candidate\n");
 }
 
 if(removed_some_possibles==TRUE)
  return TRUE;
  else 
  return FALSE;

}

//88check_for_candidate_available_once_in_row_column_or_box8888888888888888888888888888888888
//88check_for_candidates_contained_in_row_or_column_of_a_box888888888888888888888888888888888

gboolean check_for_candidates_contained_in_row_or_column_of_a_box(short possibles[][number_of_picks/2][number_of_picks/2+1])
{
short i,j,k;
short x,y,z;
short m,n,o;
short tmp1,tmp2;
gboolean guessed=FALSE;
gboolean value_repeated;
gboolean put_break;
//gboolean do_loop;
//g_print("advance guessing\n");

for(x=0;x<number_of_picks/2;x++)
{
  for(y=0;y<number_of_picks/2;y++)
  {
    tmp1=board_size*(x/board_size);
    tmp2=board_size*(y/board_size);

          
      
      for(z=0;z<number_of_picks/2;z++)
      {
        //-----
	if(possibles[x][y][z]==-1)
	  break;
          value_repeated=FALSE;
         
	  for(i=tmp1;i<tmp1+board_size;i++)
          {
             for(j=tmp2;j<tmp2+board_size;j++)
             {
                
		if(i!=x)
		{
		for(k=0;k<number_of_picks/2;k++)
                {
               	  if(possibles[i][j][k]==-1)
	           break;
 
              	   if(possibles[i][j][k]==possibles[x][y][z])
		    {
		      value_repeated =TRUE; 
		      break;  
		    }
                
		
		
		}
		}  
      
             }
	  }   
	  //||||
         if(value_repeated==FALSE)
	 {
	     for(n=0;n<number_of_picks/2;n++)
	     {
	       put_break=FALSE;
	       for(o=0;o<board_size;o++)
	       {
	         if(n==tmp2+o)
		 {
		   put_break=TRUE;
		   break; 
		 
		 } 
	     
	       }
	       if(put_break==TRUE)
	         continue;
	       put_break=FALSE;	
		for(o=0;o<number_of_picks/2;o++)
                {
               	  if(possibles[x][n][o]==-1)
	           break;
 
              	   if(possibles[x][n][o]==possibles[x][y][z])
		    {
		      put_break=TRUE;
		      guessed=TRUE;
		       for(k=o;k<number_of_picks/2;k++)
		        {   
			   possibles[x][n][k]=possibles[x][n][k+1]; 
		         if(possibles[x][n][k]==-1)
			  break;  
		        }
		    }
	          if(put_break==TRUE)
	           break;
                 }
	     
	     
	     
	     }
	   
	   
 
	 
	 }
	 //||||
	 
          value_repeated=FALSE;
          for(i=tmp1;i<tmp1+board_size;i++)
          {
             for(j=tmp2;j<tmp2+board_size;j++)
             {
                
		if(j!=y)
		{
		for(k=0;k<number_of_picks/2;k++)
                {
               	  if(possibles[i][j][k]==-1)
	           break;
 
              	   if(possibles[i][j][k]==possibles[x][y][z])
		    {
		      value_repeated =TRUE; 
		      break;  
		    }
                
		
		
		}
		}  
      
             }
	  } 
	   
//	   g_print("%d   %d   %d   %d   %d\n",value_repeated,x,y,z,possibles[x][y][z]);
         if(value_repeated==FALSE)
	 {
	   for(m=0;m<number_of_picks/2;m++)
	   {
	       put_break=FALSE;
	       for(o=0;o<board_size;o++)
	       {
	         if(m==tmp1+o)
		 {
		   put_break=TRUE;
		   break; 
		 
		 } 
	     
	       }
	       if(put_break==TRUE)
	         continue;
	       put_break=FALSE;	
		for(o=0;o<number_of_picks/2;o++)
                {
               	  if(possibles[m][y][o]==-1)
	           break;
 
              	   if(possibles[m][y][o]==possibles[x][y][z])
		    {
                      put_break=TRUE;
		      guessed=TRUE;
		       for(k=o;k<number_of_picks/2;k++)
		      {
		       possibles[m][y][k]=possibles[m][y][k+1]; 
		       if(possibles[m][y][k]==-1)
			 break;  
		      }   
		    
		    }
	          if(put_break==TRUE)
	           break;
                 }
	     
   
	   
	   }
	   
 
	 }
        //------	 
	 
	 
      }
  
  
  }

}


 if(global.show_console_messegesF==TRUE)
 {
  if(guessed==TRUE)
  {
   g_print("++found candidate contained in a box\n");
   //getchar();
  }
  else
   g_print("**fail: no candidate contained in box\n");
 }


 if(guessed==TRUE)
  return TRUE;
 else 
  return FALSE;

}

//88check_for_candidates_contained_in_row_or_column_of_a_box888888888888888888888888888888888
//88check_for_row_column_number_contain_in_single_box9998888888888888888888888888888888888888

gboolean check_for_row_column_number_contain_in_single_box(short possibles[][number_of_picks/2][number_of_picks/2+1])
{

short o;
short i,j,k;
short x,y,z;
short tmp1,tmp2;
gboolean put_break;
gboolean xvalid,yvalid;
gboolean cleared_some_impossibles=FALSE;

for(x=0;x<number_of_picks/2;x++)
{
for(y=0;y<number_of_picks/2;y++)
{
for(z=0;z<number_of_picks/2;z++)
{

 if( possibles[x][y][z]==-1)
   break;
   
 xvalid=TRUE;
 yvalid=TRUE;
 
 for(i=0;i<number_of_picks/2;i++)
 {
   for(j=0;j<number_of_picks/2;j++)
   {
      if(possibles[i][y][j]==possibles[x][y][z]  &&  i/board_size!=x/board_size)
        yvalid=FALSE;

      if(possibles[x][i][j]==possibles[x][y][z] &&  i/board_size!=y/board_size)
        xvalid=FALSE;
     
      if( (xvalid==FALSE  && yvalid==FALSE) ||  (possibles[i][y][j]==-1 && possibles[x][i][j]==-1) )
        break;
   }    
   if(xvalid==FALSE  && yvalid==FALSE)
     break;
 }

//g_print("xvalid   yvalid      %d   %d\n",xvalid,yvalid);

 if(xvalid==TRUE || yvalid==TRUE)
 {
  //g_print("xvalid   yvalid      %d   %d\n",xvalid,yvalid);
   tmp1=board_size*(x/board_size);
   tmp2=board_size*(y/board_size);


   for(i=tmp1;i<tmp1+board_size;i++)
   {
   for(j=tmp2;j<tmp2+board_size;j++)
   {
 
     if(yvalid==TRUE && j!= y)
     {
     for(k=0;k<number_of_picks/2;k++)
     {
         if(possibles[i][j][k]==-1)
           break;
 
         if(possibles[i][j][k]==possibles[x][y][z])
         {
           cleared_some_impossibles=TRUE;
	   put_break=FALSE;
	   for(o=k;o<number_of_picks/2;o++)
	   {
             possibles[i][j][o]=possibles[i][j][o+1];
	     if(possibles[i][j][o]==-1)
	     {
	       put_break=TRUE;
	       break;
	     }  
            }
            if( put_break==TRUE)
              break;
          }
      } 
      }   
   
     
      if(xvalid==TRUE && i!= x)
      {
      for(k=0;k<number_of_picks/2;k++)
      {
         if(possibles[i][j][k]==-1)
           break;

         if(possibles[i][j][k]==possibles[x][y][z])
         {
           cleared_some_impossibles=TRUE;
           put_break=FALSE;
	   for(o=k;o<number_of_picks/2;o++)
           {
             possibles[i][j][o]=possibles[i][j][o+1];
	     if(possibles[i][j][o]==-1)
	     {
	       put_break=TRUE;
	       break;
	     }  
           }
           if( put_break==TRUE)
             break;
          }

       }   
       }
   
   
   
   }
   }
 }
 
 
 
 
}
}
}



 if(global.show_console_messegesF==TRUE)
 {
  if(cleared_some_impossibles==TRUE)
   g_print("++found candidate contained in a row/column\n");
  else
   g_print("**fail: no candidate contained in row/column\n");
 }


 if(cleared_some_impossibles==TRUE)
  return TRUE;
 else 
  return FALSE;

}

//88check_for_row_column_number_contain_in_single_box8888888888888888888888888888888888888888
//88check_for_doublets_triplets_etc8888888888888888888888888888888888888888888888888888888888

gboolean check_for_doublets_triplets_etc(short possibles[][number_of_picks/2][number_of_picks/2+1])
{

short r,s;
short a,b,c;
short i,j,k;
short x,y,z;
short m,n,o;
short tmp1,tmp2;
short group_count;
short marked_count;
short number_of_candidates;
short count_match_in_group;
short matched_count;

short matched_in_groupx[number_of_picks/2],matched_in_groupy[number_of_picks/2];
short group_markedx[number_of_picks/2],group_markedy[number_of_picks/2];
short number_of_candidates_per_square[number_of_picks/2][number_of_picks/2];
short groupx[number_of_picks/2],groupy[number_of_picks/2];

gboolean put_break;
gboolean found_doublets_triplets_etc=FALSE;
gboolean candidates_match;

//g_print("in doublets triplets\n");

for(i=0;i<number_of_picks/2;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
for(k=0;k<number_of_picks/2;k++)
{
  if(possibles[i][j][k]==-1)
    break;
}

number_of_candidates_per_square[i][j]=k;

}
}







for(x=0;x<number_of_picks/2;x++)
{
marked_count=0;
for(y=0;y<number_of_picks/2;y++)
{
 group_count=0;
 number_of_candidates=number_of_candidates_per_square[x][y];
 
 if(number_of_candidates<2)
   continue;
 put_break=FALSE;
 

 for(i=0;i<marked_count;i++)
 {
  if(group_markedx[i]==y)
  {
   put_break=TRUE;
   break;
  }
 }
 if(put_break==TRUE)
   continue;

 for(i=0;i<number_of_picks/2;i++)
 {
   if(number_of_candidates_per_square[x][i]==number_of_candidates)
   {
    groupx[group_count]=i;
    group_count=group_count+1;
   }
   
 } 

 for(i=0;i<group_count;i++)
  {
   group_markedx[marked_count]=groupx[i];
   marked_count=marked_count+1;
  } 
 
 
 if(group_count<number_of_candidates)
   continue;

 for(m=0;m<group_count-1;m++)
 {
  count_match_in_group=1;
  matched_count=1;
  for(n=m+1;n<group_count;n++)
  {
    
     candidates_match=TRUE;
     for(i=0;i<number_of_candidates;i++)
      {
        if(possibles[x][groupx[m]][i]!=possibles[x][groupx[n]][i])
        {
	 candidates_match=FALSE;
	 break;
	} 	  
      }
      if(candidates_match==TRUE)
      {
       matched_in_groupx[matched_count]=groupx[n];
       matched_count=matched_count+1;
       count_match_in_group=count_match_in_group+1;
      }
  }
  if(count_match_in_group==number_of_candidates && count_match_in_group!=1)
  {
//    g_print("yeppy\n");
//     g_print("\n");
       matched_in_groupx[0]=groupx[m];
//            g_print("x:%d  y:%d\n",x,y);
//    for(i=0;i<number_of_candidates;i++)
//     g_print("%d   ",matched_in_groupx[i]);
//         g_print("\n");
       for(i=0;i<number_of_candidates;i++)
       {
         for(j=0;j<number_of_picks/2;j++)
         {
             put_break=FALSE;
	     for(k=0;k<number_of_candidates;k++)
             {
               if(j==matched_in_groupx[k])
	       {
 //                g_print("j  %d\n",j); 
		 put_break =TRUE;
	         break;
               }
             }
           
	     if(put_break==TRUE)
	       continue;
//                   g_print("from part 1, i came here  %d  %d\n",j,number_of_candidates_per_square[x][j]); 
//		   getchar();   
             for(k=0;k<number_of_candidates_per_square[x][j];k++)
             {
               if(possibles[x][j][k]==possibles[x][matched_in_groupx[0]][i])
               {
//                  g_print("from part 1\n");
		 found_doublets_triplets_etc=TRUE;
 	         for(o=k;o<=number_of_candidates_per_square[x][j];o++)
	           possibles[x][j][o]=possibles[x][j][o+1];
	         break; 
	       }
	     }
    
         }
        }
  

  }
 
 
 }
   

}
}







for(x=0;x<number_of_picks/2;x++)
{
marked_count=0;
for(y=0;y<number_of_picks/2;y++)
{
 group_count=0;
 number_of_candidates=number_of_candidates_per_square[y][x];
 
 if(number_of_candidates<2)
   continue;
 put_break=FALSE;
 for(i=0;i<marked_count;i++)
 {
  if(group_markedy[i]==y)
  {
   put_break=TRUE;
   break;
  }
 }
 if(put_break==TRUE)
   continue;

  
 for(i=0;i<number_of_picks/2;i++)
 {
   if(number_of_candidates_per_square[i][x]==number_of_candidates)
   {
    groupy[group_count]=i;
    group_count=group_count+1;
   }
   
 } 

 for(i=0;i<group_count;i++)
  {
   group_markedy[marked_count]=groupy[i];
   marked_count=marked_count+1;
  } 
 
 
 if(group_count<number_of_candidates)
   continue;


 for(m=0;m<group_count-1;m++)
 {
  count_match_in_group=1;
  matched_count=1;
  for(n=m+1;n<group_count;n++)
  {
    
     candidates_match=TRUE;
     for(i=0;i<number_of_candidates;i++)
      {
        if(possibles[groupy[m]][x][i]!=possibles[groupy[n]][x][i])
        {
	 candidates_match=FALSE;
	 break;
	} 	  
      }
      if(candidates_match==TRUE)
      {
       matched_in_groupy[matched_count]=groupy[n];
       matched_count=matched_count+1;
       count_match_in_group=count_match_in_group+1;
      }
  }
  if(count_match_in_group==number_of_candidates && count_match_in_group!=1)
  {
//    g_print("yeppy\n");
//    for(i=0;i<number_of_candidates;i++)
//     g_print("%d   ",possibles[groupy[0]][x][i]);
//     g_print("\n");
       matched_in_groupy[0]=groupy[m];
       for(i=0;i<number_of_candidates;i++)
       {
         for(j=0;j<number_of_picks/2;j++)
         {
             put_break=FALSE;
	     for(k=0;k<number_of_candidates;k++)
             {
               if(j==matched_in_groupy[k])
	       {
	         put_break =TRUE;
	         break;
               }
             }
           
	     if(put_break==TRUE)
	       continue;
     
             for(k=0;k<number_of_candidates_per_square[j][x];k++)
             {
               if(possibles[j][x][k]==possibles[matched_in_groupy[0]][x][i])
               {
//	       g_print("from part 2\n");
                 found_doublets_triplets_etc=TRUE;
 	         for(o=k;o<=number_of_candidates_per_square[j][x];o++)
	           possibles[j][x][o]=possibles[j][x][o+1];
	         break; 
	       }
	     }
    
         }
        }

  }
 
 }
  

}
}




for(x=0;x<number_of_picks/2;x=x+board_size)
{
for(y=0;y<number_of_picks/2;y=y+board_size)
{
marked_count=0;
for(r=x;r<x+board_size;r++)
{
for(s=y;s<y+board_size;s++)
{
 
 

 group_count=0;
 number_of_candidates=number_of_candidates_per_square[r][s];
//  g_print("r:%d  s:%d candi:%d\n",r,s,number_of_candidates);
   
   
 if(number_of_candidates<2)
   continue;
 put_break=FALSE;
 for(i=0;i<marked_count;i++)
 {
  if(group_markedx[i]==r && group_markedy[i]==s)
  {
   put_break=TRUE;
   break;
  }
 }
 if(put_break==TRUE)
   continue;


 
 for(i=x;i<x+board_size;i++)
 {
 for(j=y;j<y+board_size;j++)
 {
   if(number_of_candidates_per_square[i][j]==number_of_candidates)
   {
    groupx[group_count]=i;
    groupy[group_count]=j;
    group_count=group_count+1;
   }
   
 } 
 }
//g_print("group_count: %d\n",group_count);
//getchar();
 
 for(i=0;i<group_count;i++)
  {
   group_markedx[marked_count]=groupx[i];
   group_markedy[marked_count]=groupy[i];
   marked_count=marked_count+1;
  } 

 
 if(group_count<number_of_candidates)
   continue;

//g_print("r:%d  s:%d candi:%d   g_count:%d\n",r,s,number_of_candidates,group_count);

 for(m=0;m<group_count-1;m++)
 {
  count_match_in_group=1;
  matched_count=1;
  for(n=m+1;n<group_count;n++)
  {
    
     candidates_match=TRUE;
     for(i=0;i<number_of_candidates;i++)
      {
        if(possibles[groupx[m]][groupy[m]][i]!=possibles[groupx[n]][groupy[n]][i])
        {
 	 candidates_match=FALSE;
	 break;
	} 	  
      }
      if(candidates_match==TRUE)
      {
  //            g_print("i_came_heooooore\n");
       matched_in_groupx[matched_count]=groupx[n];
       matched_in_groupy[matched_count]=groupy[n];       
       matched_count=matched_count+1;
       count_match_in_group=count_match_in_group+1;
      }
  }
  if(count_match_in_group==number_of_candidates  && count_match_in_group!=1)
  {
  //                 g_print("atleast_i_came_here\n"); 
       matched_in_groupx[0]=groupx[m];
       matched_in_groupy[0]=groupy[m];
       for(i=0;i<number_of_candidates;i++)
       {
         for(a=x;a<x+board_size;a++)
         {
         for(b=y;b<y+board_size;b++)
         {
             put_break=FALSE;
             for(k=0;k<number_of_candidates;k++)
             {
               if(a==matched_in_groupx[k] && b==matched_in_groupy[k])
	       {
	         put_break =TRUE;
	         break;
               }
             }
           
	     if(put_break==TRUE)
	       continue;
//             g_print("i dare to cross this line\n");
             for(k=0;k<number_of_candidates_per_square[a][b];k++)
             {
               if(possibles[a][b][k]==possibles[matched_in_groupx[0]][matched_in_groupy[0]][i])
               {
//	       g_print("from part 3\n");
 //            g_print("i even came here  %d  %d\n",a,b);
                 found_doublets_triplets_etc=TRUE;
 	         for(o=k;o<=number_of_candidates_per_square[a][b];o++)
	           possibles[a][b][o]=possibles[a][b][o+1];
	         break; 
	       }
	     }
    
         }
	 }
        }
  

  }
 
 
 }
   
 
} 
} 

}
}




 if(global.show_console_messegesF==TRUE)
 {
  if(found_doublets_triplets_etc==TRUE)
   g_print("++removed doublets or triplets\n");
  else
   g_print("**fail to remove d or t\n");
 }
 
if(found_doublets_triplets_etc==TRUE)
  return TRUE;
  else 
  return FALSE;
 
}

//88check_for_doublets_triplets_etc8888888888888888888888888888888888888888888888888888888888
//88check_for_advanced_doublets_triplets_etc8888888888888888888888888888888888888888888888888888888888
gboolean check_for_advanced_doublets_triplets_etc(short possibles[][number_of_picks/2][number_of_picks/2+1])
{

short x,y,z;
short a,b,c;
short m,n,o;
short i,j,k;
short p,r,s;


short position_of_group_formation[number_of_picks/2];

short size_of_the_group;
short initial_size_of_the_group;

short number_of_group;
short search;
short group[number_of_picks/2];
short group_y_location[number_of_picks/2];
short group_x_location[number_of_picks/2];

short number_of_candidates_per_square[number_of_picks/2][number_of_picks/2];

gboolean found_doublets_triplets_etc=FALSE;
gboolean group_already_checked;
gboolean put_break;
gboolean invalid_group;
gboolean quit_everything;

struct node
{
 short number_of_candidates;
 short group[number_of_picks/2];
 struct node *next;
};

struct node *log;
struct node *temp;
struct node *temp2;
struct node *temp3;


log=g_malloc(sizeof(struct node));
log->number_of_candidates=0;
log->next=NULL;
//temp=log;

for(i=0;i<number_of_picks/2;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
for(k=0;k<number_of_picks/2;k++)
{
  if(possibles[i][j][k]==-1)
    break;
}

number_of_candidates_per_square[i][j]=k;

}
}


quit_everything=FALSE;
for(x=0;x<number_of_picks/2;x++)
{
for(y=0;y<number_of_picks/2;y++)
{

if(possibles[x][y][0]==-1)
  break; 


size_of_the_group=1;
while(size_of_the_group+1<=number_of_candidates_per_square[x][y])
{
//position_of_group_formation[]=0;
 size_of_the_group=size_of_the_group+1;
 for(m=0;m<size_of_the_group;m++)
   position_of_group_formation[m]=m;
while(position_of_group_formation[0]<number_of_candidates_per_square[x][y]-size_of_the_group)
{ 

  if(global.abort_generator==TRUE)
  {
    quit_everything=TRUE;
    break;
  }
 for(m=0;m<size_of_the_group;m++)
  group[m]=possibles[x][y][position_of_group_formation[m]];
 
 temp=log;
 group_already_checked=FALSE;
 while(1)
 {
   if(temp->number_of_candidates==size_of_the_group)
   {
     for(m=0;m<size_of_the_group;m++)
     {  
       if(temp->group[m]!=group[m])
         break;
     }
     if(m==size_of_the_group)
     {
       group_already_checked=TRUE;
       break;
     
     } 
   }
   
   if(temp->next!=NULL)
    temp=temp->next;
   else
    break;
 }

  
 if(group_already_checked==FALSE)
 {
    if(temp->number_of_candidates==0)
    {
     temp->number_of_candidates=size_of_the_group;
     for(m=0;m<size_of_the_group;m++)
      temp->group[m]=group[m];
    }
    else
    {
     temp2=g_malloc(sizeof(struct node));
     temp2->number_of_candidates=size_of_the_group;
     for(m=0;m<size_of_the_group;m++)
      temp2->group[m]=group[m];
     temp2->next=NULL;
     temp->next=temp2;
    }
   
 }
 else
 break;
 
 group_y_location[0]=y;
 number_of_group=1;
  
 for(i=0;i<number_of_picks/2;i++)
 {
 search=0;
 for(j=0;j<number_of_picks/2;j++)
 {
  if(possibles[x][i][j]==-1 || i==y)
    break;
  
  
  if(possibles[x][i][j]==group[search])
  {

   if(search+1==size_of_the_group)
   {
    //found a group
 //   g_print("found_group  %d  %d\n",x,y);
    group_y_location[number_of_group]=i;
    number_of_group=number_of_group+1;
    break;
    
   }
  
  
   search=search+1;
  }
 
 
 }
 }
 
 if(number_of_group==size_of_the_group)
 {
       
       //validate group
       invalid_group=FALSE;
       for(i=0;i<size_of_the_group;i++)
       {
       for(j=0;j<number_of_picks/2;j++)
       {
         put_break=FALSE;
         for(k=0;k<size_of_the_group;k++)
         {
            if(j==group_y_location[k])
	    {
	       put_break =TRUE;
	       break;
            }
         }
	     
	 if(put_break==TRUE)
	   continue;
           
      
         for(k=0;k<number_of_candidates_per_square[x][j];k++)
         {
            if(possibles[x][j][k]==group[i])
            {
              //invalid group
              invalid_group=TRUE;
	      break; 
	    }
          }
 	  
	  if(invalid_group==TRUE)
	     break;
      
       }
       if(invalid_group==TRUE)
	 break;
       }
  
      
       
/*       for(i=0;i<number_of_picks/2;i++)
       {
       for(j=0;j<number_of_picks/2;j++)
       {
       for(k=0;k<number_of_picks/2;k++)
       {
         g_print("%d    ",possibles[j][k][i]);
       
       }
       g_print("\n");
       }
       g_print("\n-------\n");
       }
       g_print("sizeeeeeeeeee    %d\n",size_of_the_group);
       getchar();*/
       if(invalid_group==FALSE)
       {
       for(j=0;j<number_of_picks/2;j++)
       {
             put_break=TRUE;
	     for(k=0;k<size_of_the_group;k++)
             {
               if(j==group_y_location[k])
	       {
	         put_break=FALSE;
	         break;
               }
               
	       if(put_break==FALSE)
	        break;
             }
           
	     if(put_break==TRUE)
	       continue;
   
             
	     number_of_group=0;
	     for(k=0;k<number_of_candidates_per_square[x][j];k++)
             {
//             for(m=0;m<size_of_the_group;m++)
//             {
//       g_print("atleast i came here\n");
               
	       if(possibles[x][j][k]==group[number_of_group])
               {
 		 possibles[x][j][number_of_group]=group[number_of_group];
		 number_of_group=number_of_group+1;
	       }
//	     }
	     }
	     for(o=number_of_group;o<number_of_candidates_per_square[x][j];o++)
	      {
                found_doublets_triplets_etc=TRUE;
    	        possibles[x][j][o]=-1;
              }
	     
    
        }
        }
 
 
 
 
 }
 //  g_print("size_of_the_group: %d\n",size_of_the_group);
 // for(i=0;i<size_of_the_group;i++)
 //  g_print("position_of_group_formation[%d]  %d\n",i,position_of_group_formation[i]);
//  getchar();
//  g_print("number of candidates  %d\n",number_of_candidates_per_square[x][y]);
 position_of_group_formation[size_of_the_group-1]=position_of_group_formation[size_of_the_group-1]+1;
//   g_print("checkin  %d\n",position_of_group_formation[size_of_the_group-1]);

  put_break=FALSE;
  while(position_of_group_formation[size_of_the_group-1]+1>number_of_candidates_per_square[x][y])
  { 
 // g_print("impossible\n");
  for(m=size_of_the_group-1;m>=0;m--)
  {
   if(position_of_group_formation[0]>=number_of_candidates_per_square[x][y])
    {
     put_break=TRUE;
     break;
    }
   if(position_of_group_formation[m]+1>number_of_candidates_per_square[x][y])
    { 
     position_of_group_formation[m]=position_of_group_formation[m-1]+2;
     position_of_group_formation[m-1]=position_of_group_formation[m-1]+1;
     for(n=m+1;n<number_of_candidates_per_square[x][y];n++)
       position_of_group_formation[n]=position_of_group_formation[n-1]+1;
     
     
    }
   
  }
  if(put_break==TRUE)
    break;
  }
  

 //  g_print("size_of_the_group: %d\n",size_of_the_group);
//  for(i=0;i<size_of_the_group;i++)
//   g_print("position_of_group_formation[%d]  %d\n",i,position_of_group_formation[i]);
//  getchar();
}
  if(quit_everything==TRUE)
    break;

}
  if(quit_everything==TRUE)
    break;



}

// struct node *temp3;

// temp3=g_malloc(sizeof(struct node));

 if(log->next!=NULL)
 {
   temp=log->next;
   while(1)
   {
     if(temp->next!=NULL)
      temp3=temp->next;
     else
     {
      g_free(temp);
      break;
     }
   
     g_free(temp);
     temp=temp3;
   }
 }
 log->number_of_candidates=0;
 log->next=NULL;
 if(quit_everything==TRUE)
   break;

}



  
  












for(y=0;y<number_of_picks/2;y++)
{
for(x=0;x<number_of_picks/2;x++)
{

if(possibles[x][y][0]==-1)
  break; 


size_of_the_group=1;
while(size_of_the_group+1<=number_of_candidates_per_square[x][y])
{
//position_of_group_formation[]=0;
 size_of_the_group=size_of_the_group+1;
 for(m=0;m<size_of_the_group;m++)
   position_of_group_formation[m]=m;

while(position_of_group_formation[0]<number_of_candidates_per_square[x][y]-size_of_the_group)
{ 

  if(global.abort_generator==TRUE)
  {
    quit_everything=TRUE;
    break;
  }
 
 for(m=0;m<size_of_the_group;m++)
  group[m]=possibles[x][y][position_of_group_formation[m]];
 
 temp=log;
 group_already_checked=FALSE;
 while(1)
 {
   if(temp->number_of_candidates==size_of_the_group)
   {
     for(m=0;m<size_of_the_group;m++)
     {  
       if(temp->group[m]!=group[m])
         break;
     }
     if(m==size_of_the_group)
     {
       group_already_checked=TRUE;
       break;
     
     } 
   }
   
   if(temp->next!=NULL)
    temp=temp->next;
   else
    break;
 }

  
 if(group_already_checked==FALSE)
 {
    if(temp->number_of_candidates==0)
    {
     temp->number_of_candidates=size_of_the_group;
     for(m=0;m<size_of_the_group;m++)
      temp->group[m]=group[m];
    }
    else
    {
     temp2=g_malloc(sizeof(struct node));
     temp2->number_of_candidates=size_of_the_group;
     for(m=0;m<size_of_the_group;m++)
      temp2->group[m]=group[m];
     temp2->next=NULL;
     temp->next=temp2;
    }
   
 }
 else
 break;
 
 group_x_location[0]=x;
 number_of_group=1;
  
 for(i=0;i<number_of_picks/2;i++)
 {
 search=0;
 for(j=0;j<number_of_picks/2;j++)
 {
  if(possibles[i][y][j]==-1 || i==x)
    break;
  
  
  if(possibles[i][y][j]==group[search])
  {

   if(search+1==size_of_the_group)
   {
    //found a group
 //   g_print("found_group  %d  %d\n",x,y);
    group_x_location[number_of_group]=i;
    number_of_group=number_of_group+1;
    break;
    
   }
  
  
   search=search+1;
  }
 
 
 }
 }
 
 if(number_of_group==size_of_the_group)
 {
       
       //validate group
       invalid_group=FALSE;
       for(i=0;i<size_of_the_group;i++)
       {
       for(j=0;j<number_of_picks/2;j++)
       {
         put_break=FALSE;
         for(k=0;k<size_of_the_group;k++)
         {
            if(j==group_x_location[k])
	    {
	       put_break =TRUE;
	       break;
            }
         }
	     
	 if(put_break==TRUE)
	   continue;
           
      
         for(k=0;k<number_of_candidates_per_square[j][y];k++)
         {
            if(possibles[j][y][k]==group[i])
            {
              //invalid group
              invalid_group=TRUE;
	      break; 
	    }
          }
 	  
	  if(invalid_group==TRUE)
	     break;
      
       }
       if(invalid_group==TRUE)
	 break;
       }
  
      
       
       if(invalid_group==FALSE)
       {
       for(j=0;j<number_of_picks/2;j++)
       {
             put_break=TRUE;
	     for(k=0;k<size_of_the_group;k++)
             {
               if(j==group_x_location[k])
	       {
	         put_break=FALSE;
	         break;
               }
               
	       if(put_break==FALSE)
	        break;
             }
           
	     if(put_break==TRUE)
	       continue;
   
             
	     number_of_group=0;
	     for(k=0;k<number_of_candidates_per_square[j][y];k++)
             {
//             for(m=0;m<size_of_the_group;m++)
//             {
//       g_print("atleast i came here\n");
               
	       if(possibles[j][y][k]==group[number_of_group])
               {
 		 possibles[j][y][number_of_group]=group[number_of_group];
		 number_of_group=number_of_group+1;
	       }
//	     }
	     }
	     for(o=number_of_group;o<number_of_candidates_per_square[j][y];o++)
	      {
//	        g_print("part2\n");
//		getchar();
                found_doublets_triplets_etc=TRUE;
    	        possibles[j][y][o]=-1;
              }
	     
    
        }
        }
 
 
 
 
 }
 //  g_print("size_of_the_group: %d\n",size_of_the_group);
 // for(i=0;i<size_of_the_group;i++)
 //  g_print("position_of_group_formation[%d]  %d\n",i,position_of_group_formation[i]);
//  getchar();
//  g_print("number of candidates  %d\n",number_of_candidates_per_square[x][y]);
 position_of_group_formation[size_of_the_group-1]=position_of_group_formation[size_of_the_group-1]+1;
//   g_print("checkin  %d\n",position_of_group_formation[size_of_the_group-1]);

  put_break=FALSE;
  while(position_of_group_formation[size_of_the_group-1]+1>number_of_candidates_per_square[x][y])
  { 
 // g_print("impossible\n");
  for(m=size_of_the_group-1;m>=0;m--)
  {
   if(position_of_group_formation[0]>=number_of_candidates_per_square[x][y])
    {
     put_break=TRUE;
     break;
    }
   if(position_of_group_formation[m]+1>number_of_candidates_per_square[x][y])
    { 
     position_of_group_formation[m]=position_of_group_formation[m-1]+2;
     position_of_group_formation[m-1]=position_of_group_formation[m-1]+1;
     for(n=m+1;n<number_of_candidates_per_square[x][y];n++)
       position_of_group_formation[n]=position_of_group_formation[n-1]+1;
     
     
    }
   
  }
  if(put_break==TRUE)
    break;
  }
  

 //  g_print("size_of_the_group: %d\n",size_of_the_group);
//  for(i=0;i<size_of_the_group;i++)
//   g_print("position_of_group_formation[%d]  %d\n",i,position_of_group_formation[i]);
//  getchar();
}
  if(quit_everything==TRUE)
    break;

}
  if(quit_everything==TRUE)
    break;



}

 if(log->next!=NULL)
 {
   temp=log->next;
   while(1)
   {
     if(temp->next!=NULL)
      temp3=temp->next;
     else
     {
      g_free(temp);
      break;
     }
   
     g_free(temp);
     temp=temp3;
   }
 }
 log->number_of_candidates=0;
 log->next=NULL;
  if(quit_everything==TRUE)
    break;

}





























for(x=0;x<number_of_picks/2;x=x+board_size)
{
for(y=0;y<number_of_picks/2;y=y+board_size)
{

for(r=x;r<x+board_size;r++)
{
for(s=y;s<y+board_size;s++)
{

if(possibles[r][s][0]==-1)
  break; 


size_of_the_group=1;
while(size_of_the_group+1<=number_of_candidates_per_square[r][s])
{
//position_of_group_formation[]=0;
 size_of_the_group=size_of_the_group+1;
 for(m=0;m<size_of_the_group;m++)
   position_of_group_formation[m]=m;

while(position_of_group_formation[0]<number_of_candidates_per_square[r][s]-size_of_the_group)
{ 

  if(global.abort_generator==TRUE)
  {
    quit_everything=TRUE;
    break;
  }
 
 for(m=0;m<size_of_the_group;m++)
  group[m]=possibles[r][s][position_of_group_formation[m]];
 
 temp=log;
 group_already_checked=FALSE;
 while(1)
 {
   if(temp->number_of_candidates==size_of_the_group)
   {
     for(m=0;m<size_of_the_group;m++)
     {  
       if(temp->group[m]!=group[m])
         break;
     }
     if(m==size_of_the_group)
     {
       group_already_checked=TRUE;
       break;
     
     } 
   }
   
   if(temp->next!=NULL)
    temp=temp->next;
   else
    break;
 }

  
 if(group_already_checked==FALSE)
 {
    if(temp->number_of_candidates==0)
    {
     temp->number_of_candidates=size_of_the_group;
     for(m=0;m<size_of_the_group;m++)
      temp->group[m]=group[m];
    }
    else
    {
     temp2=g_malloc(sizeof(struct node));
     temp2->number_of_candidates=size_of_the_group;
     for(m=0;m<size_of_the_group;m++)
      temp2->group[m]=group[m];
     temp2->next=NULL;
     temp->next=temp2;
    }
   
 }
 else
 break;
 
 group_x_location[0]=r;
 group_y_location[0]=s; 
 number_of_group=1;
  
 for(a=x;a<x+board_size;a++)
 {
 for(b=y;b<y+board_size;b++)
 {
 search=0;
 for(j=0;j<number_of_picks/2;j++)
 {
  if(possibles[a][b][j]==-1 || (a==r && b==s) )
    break;
  
  
  if(possibles[a][b][j]==group[search])
  {

   if(search+1==size_of_the_group)
   {
    //found a group
 //   g_print("found_group  %d  %d\n",x,y);
    group_x_location[number_of_group]=a;
    group_y_location[number_of_group]=b;    
    number_of_group=number_of_group+1;
    break;
    
   }
  
  
   search=search+1;
  }
 
 
 }
 }
 }
 
 if(number_of_group==size_of_the_group)
 {
       
       //validate group
       invalid_group=FALSE;
       for(i=0;i<size_of_the_group;i++)
       {
       for(a=x;a<x+board_size;a++)
       {
       for(b=y;b<y+board_size;b++)
       {
         put_break=FALSE;
         for(k=0;k<size_of_the_group;k++)
         {
            if(a==group_x_location[k] && b==group_y_location[k])
	    {
	       put_break =TRUE;
	       break;
            }
         }
	     
	 if(put_break==TRUE)
	   continue;
           
      
         for(k=0;k<number_of_candidates_per_square[a][b];k++)
         {
            if(possibles[a][b][k]==group[i])
            {
              //invalid group
              invalid_group=TRUE;
	      break; 
	    }
          }
 	  
       if(invalid_group==TRUE)
	 break;
       }
       if(invalid_group==TRUE)
	 break;
       }
       if(invalid_group==TRUE)
	 break;
       }
       
       if(invalid_group==FALSE)
       {
       for(a=x;a<x+board_size;a++)
       {
       for(b=y;b<y+board_size;b++)
       {
             put_break=TRUE;
	     for(k=0;k<size_of_the_group;k++)
             {
               if(a==group_x_location[k] && b==group_y_location[k])
	       {
	         put_break=FALSE;
	         break;
               }
               
	       if(put_break==FALSE)
	        break;
             }
           
	     if(put_break==TRUE)
	       continue;
   
             
	     number_of_group=0;
	     for(k=0;k<number_of_candidates_per_square[a][b];k++)
             {
//             for(m=0;m<size_of_the_group;m++)
//             {
//       g_print("atleast i came here\n");
               
	       if(possibles[a][b][k]==group[number_of_group])
               {
 		 possibles[a][b][number_of_group]=group[number_of_group];
		 number_of_group=number_of_group+1;
	       }
//	     }
	     }
	     for(o=number_of_group;o<number_of_candidates_per_square[a][b];o++)
	      {
//	        g_print("part3\n");
//		getchar();
                found_doublets_triplets_etc=TRUE;
    	        possibles[a][b][o]=-1;
              }
	     
    
        }
        }
        }
 
 
 
 }
 //  g_print("size_of_the_group: %d\n",size_of_the_group);
 // for(i=0;i<size_of_the_group;i++)
 //  g_print("position_of_group_formation[%d]  %d\n",i,position_of_group_formation[i]);
//  getchar();
//  g_print("number of candidates  %d\n",number_of_candidates_per_square[x][y]);
 position_of_group_formation[size_of_the_group-1]=position_of_group_formation[size_of_the_group-1]+1;
//   g_print("checkin  %d\n",position_of_group_formation[size_of_the_group-1]);

  put_break=FALSE;
  while(position_of_group_formation[size_of_the_group-1]+1>number_of_candidates_per_square[r][s])
  { 
 // g_print("impossible\n");
  for(m=size_of_the_group-1;m>=0;m--)
  {
   if(position_of_group_formation[0]>=number_of_candidates_per_square[r][s])
    {
     put_break=TRUE;
     break;
    }
   if(position_of_group_formation[m]+1>number_of_candidates_per_square[r][s])
    { 
     position_of_group_formation[m]=position_of_group_formation[m-1]+2;
     position_of_group_formation[m-1]=position_of_group_formation[m-1]+1;
     for(n=m+1;n<number_of_candidates_per_square[r][s];n++)
       position_of_group_formation[n]=position_of_group_formation[n-1]+1;
     
     
    }
   
  }
  if(put_break==TRUE)
    break;
  }
  

 //  g_print("size_of_the_group: %d\n",size_of_the_group);
//  for(i=0;i<size_of_the_group;i++)
//   g_print("position_of_group_formation[%d]  %d\n",i,position_of_group_formation[i]);
//  getchar();
}
}
  if(quit_everything==TRUE)
    break;



}
  if(quit_everything==TRUE)
    break;

}
}

 if(log->next!=NULL)
 {
   temp=log->next;
   while(1)
   {
     if(temp->next!=NULL)
      temp3=temp->next;
     else
     {
      g_free(temp);
      break;
     }
   
     g_free(temp);
     temp=temp3;
   }
 }
 log->number_of_candidates=0;
 log->next=NULL;
 if(quit_everything==TRUE)
   break;

}
























  g_free(log);

 if(global.show_console_messegesF==TRUE)
 {
  if(found_doublets_triplets_etc==TRUE)
  {
   g_print("++removed -advanced- doublets or triplets\n");
 //  getchar();
  }
  else
   g_print("**fail to remove advanced d or t\n");
 }
 
if(found_doublets_triplets_etc==TRUE)
  return TRUE;
  else 
  return FALSE;
 


}

//88check_for_advanced_doublets_triplets_etc8888888888888888888888888888888888888888888888888888888888
//88check_block_block_interaction888888888888888888888888888888888888888888888888888888888888888888888

gboolean check_block_block_interaction(short possibles[][number_of_picks/2][number_of_picks/2+1])
{
 struct block
 { 
   short num;
   short row[2];
   short column[2];
 
 }block[number_of_picks/2][number_of_picks/2];
 
 short i,j,k;
 short x,y,z;
 short p,r,s;
 short m,n,o;
 short a,b,c;
 short number_of_candidates_per_square[number_of_picks/2][number_of_picks/2];
 short values_entered;
 short count;
 short row[2];
 short column[2];
 
 gboolean put_break;
 gboolean found_block_block_interaction=FALSE;
 
for(i=0;i<number_of_picks/2;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
for(k=0;k<number_of_picks/2;k++)
{
  if(possibles[i][j][k]==-1)
    break;
}

number_of_candidates_per_square[i][j]=k;

}
}
 
 
  

 for(i=0;i<number_of_picks/2;i++)
 {
  for(j=0;j<number_of_picks/2;j++)
    block[i][j].num=-1;
 }

 
 
for(x=0;x<number_of_picks/2;x=x+board_size)
{
for(y=0;y<number_of_picks/2;y=y+board_size)
{
values_entered=0;
for(i=0;i<number_of_picks/2;i++)
{
count=0;
put_break=FALSE;
for(r=x;r<x+board_size;r++)
{
for(s=y;s<y+board_size;s++)
{
 
  for(j=0;j<number_of_candidates_per_square[r][s];j++)
  {
    if(possibles[r][s][j]==i)
    {
     count=count+1;
     if(count<3)
     {
     row[count-1]=r;
     column[count-1]=s;  
     }
     break;
    
    }
  
  }
  if(count==3)
  {
    put_break=TRUE; 
    break;
  }
  

}
if(put_break==TRUE)
 break;
}
  if(count==2)
  {
    
   block[x+y/board_size][values_entered].num=i;
   block[x+y/board_size][values_entered].row[0]=row[0];
   block[x+y/board_size][values_entered].column[0]=column[0];
   block[x+y/board_size][values_entered].row[1]=row[1];
   block[x+y/board_size][values_entered].column[1]=column[1];
   
   values_entered=values_entered+1;
  }
  
  
}




}
}
 
 

for(i=0;i<number_of_picks/2-board_size;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
  if(block[i][j].num==-1)
   break;
 
  if(block[i][j].row[0]==block[i][j].row[1])
  {
  for(x=i+board_size;x<number_of_picks/2;x=x+board_size)
  {
  for(m=0;m<number_of_picks/2;m++)
  {
       if(block[x][m].num==-1)
        break;
	
       if(block[i][j].num==block[x][m].num && 
       ((block[i][j].column[0]==block[x][m].column[0] && block[i][j].column[1]==block[x][m].column[1])
       || (block[i][j].column[0]==block[x][m].column[1] && block[i][j].column[1]==block[x][m].column[0])))
       {
       for(n=i%board_size;n<number_of_picks/2;n=n+3)
       {
              if(n!=i && n!=x)
	      {
	        for(a=(n/board_size)*board_size;a<(n/board_size)*board_size+board_size;a++)
		{
	        for(b=0;b<number_of_picks/2;b++)
		{
		 
		  if(possibles[a][block[i][j].column[0]][b] == -1 && possibles[a][block[i][j].column[1]][b] == -1)
		   break;
		  if(block[i][j].num==possibles[a][block[i][j].column[0]][b])
		  {
//   g_print("111111111\n");
		    found_block_block_interaction=TRUE;
		    for(o=b;o<number_of_candidates_per_square[a][block[i][j].column[0]];o++)
		     possibles[a][block[i][j].column[0]][o]=possibles[a][block[i][j].column[0]][o+1];
		  
		  }
	          if(block[i][j].num==possibles[a][block[i][j].column[1]][b])
		  {
//   g_print("1111111\n");
		    found_block_block_interaction=TRUE;
		    for(o=b;o<number_of_candidates_per_square[a][block[i][j].column[1]];o++)
		     possibles[a][block[i][j].column[1]][o]=possibles[a][block[i][j].column[1]][o+1];
		  
		  }
		  
	        
		}
		}
		
	      }
       
       }
       }
     
   }
   }
   }
   
 if(block[i][j].column[0]==block[i][j].column[1])
 {
 for(x=i+1;x<(i/board_size)*board_size+board_size;x++)
 {
 for(m=0;m<number_of_picks/2;m++)
 {
       if(block[x][m].num==-1)
        break;
	
       if(block[i][j].num==block[x][m].num && 
       ((block[i][j].row[0]==block[x][m].row[0] && block[i][j].row[1]==block[x][m].row[1])
       || (block[i][j].row[0]==block[x][m].row[1] && block[i][j].row[1]==block[x][m].row[0])))
       {
       for(n=(i/board_size)*board_size;n<(i/board_size)*board_size+board_size;n++)
       {
              if(n!=i && n!=x)
	      {
	        for(a=(n%board_size)*board_size;a<(n%board_size)*board_size+board_size;a++)
		{
	        for(b=0;b<number_of_picks/2;b++)
		{
		  
		  if(possibles[block[i][j].row[0]][a][b] == -1 && possibles[block[i][j].row[1]][a][b] == -1)
		   break;
		  
		  if(block[i][j].num==possibles[block[i][j].row[0]][a][b])
		  {
//   g_print("22222\n");
		    found_block_block_interaction=TRUE;
		    for(o=b;o<number_of_candidates_per_square[block[i][j].row[0]][a];o++)
		     possibles[block[i][j].row[0]][a][o]=possibles[block[i][j].row[0]][a][o+1];
		  
		  }
	          if(block[i][j].num==possibles[block[i][j].row[1]][a][b])
		  {
//   g_print("222222\n");
		    found_block_block_interaction=TRUE;
		    for(o=b;o<number_of_candidates_per_square[block[i][j].row[1]][a];o++)
		     possibles[block[i][j].row[1]][a][o]=possibles[block[i][j].row[1]][a][o+1];
		  
		  }
	        
		}
		}
		
	      }
       
       }
       }
     
  }
  }
  }

 
 
  
} 
} 

 if(global.show_console_messegesF==TRUE)
 {
  if(found_block_block_interaction==TRUE)
  {
   g_print("++found block block interaction\n");
//   getchar();
  }
  else
   g_print("**fail no block block interaction\n");
 }
 
if(found_block_block_interaction==TRUE)
  return TRUE;
  else 
  return FALSE;
 


}

//88check_block_block_interaction888888888888888888888888888888888888888888888888888888888888
//88check_xwing_and_swordfish8888888888888888888888888888888888888888888888888888888888888888


gboolean check_xwing_and_swordfish(short possibles[][number_of_picks/2][number_of_picks/2+1],short mode)
{

 
 struct row_check
 { 
   short num;
   short column[2];
 
 }row_check[number_of_picks/2][number_of_picks/2];
 
 struct column_check
 { 
   short num;
   short row[2];
 
 }column_check[number_of_picks/2][number_of_picks/2];
 
 
 short x,y,z;
 short i,j,k;
 short m,n,o;
 short p,r,s;
 short a,b,c;
 short row[2];
 short column[2];
 short count;
 short tmp;
 
 short number_of_candidates_per_square[number_of_picks/2][number_of_picks/2];
 short values_entered;
 
 struct sf_columns
 {
  short column;
  short row[2];
 }sf_columns[3];
 
 struct sf_rows
 {
  short column[2];
  short row;
 }sf_rows[3];
 
 
 gboolean put_break;
 gboolean found_xwing=FALSE;
 gboolean found_swordfish=FALSE;
 
 
 
for(i=0;i<number_of_picks/2;i++)
{
for(j=0;j<number_of_picks/2;j++)
{
for(k=0;k<number_of_picks/2;k++)
{
  if(possibles[i][j][k]==-1)
    break;
}

number_of_candidates_per_square[i][j]=k;

}
}

 
//--- 
 
 for(i=0;i<number_of_picks/2;i++)
 {
  for(j=0;j<number_of_picks/2;j++)
  {
    row_check[i][j].num=-1;
    column_check[i][j].num=-1;
  }
 }
//---  
 
for(x=0;x<number_of_picks/2;x++)
{
values_entered=0;
for(i=0;i<number_of_picks/2;i++)
{
count=0;
for(y=0;y<number_of_picks/2;y++)
{
 
  for(j=0;j<number_of_candidates_per_square[x][y];j++)
  {
    if(possibles[x][y][j]==i)
    {
     count=count+1;
     if(count<3)
      column[count-1]=y;  
     break;
    
    }
  
  }
  if(count==3)
    break;
  

}

  if(count==2)
  {
    
   row_check[x][values_entered].num=i;
   row_check[x][values_entered].column[0]=column[0];
   row_check[x][values_entered].column[1]=column[1];
   
   values_entered=values_entered+1;
  }
}  
  
}
//--- 

for(y=0;y<number_of_picks/2;y++)
{
values_entered=0;
for(i=0;i<number_of_picks/2;i++)
{
count=0;
for(x=0;x<number_of_picks/2;x++)
{
 
  for(j=0;j<number_of_candidates_per_square[x][y];j++)
  {
    if(possibles[x][y][j]==i)
    {
     count=count+1;
     if(count<3)
      row[count-1]=x;  
     break;
    
    }
  
  }
  if(count==3)
    break;
  

}

  if(count==2)
  {
    
   column_check[y][values_entered].num=i;
   column_check[y][values_entered].row[0]=row[0];
   column_check[y][values_entered].row[1]=row[1];
   
   values_entered=values_entered+1;
  }
  
}  
}
//--- 
if(mode==0 || mode==2)
{
//====================
// X-Wing

for(x=0;x<number_of_picks/2;x++)
{
for(j=0;j<number_of_picks/2;j++)
{
 if(row_check[x][j].num==-1)
  break;
 
 for(m=x+1;m<number_of_picks/2;m++)
 {
 for(k=0;k<number_of_picks/2;k++)
 {
  if(row_check[m][k].num==-1)
   break;
 
  if(row_check[m][k].num==row_check[x][j].num && row_check[m][k].column[0]==row_check[x][j].column[0] && row_check[m][k].column[1]==row_check[x][j].column[1])  
  {
    
    for(a=0;a<number_of_picks/2;a++)
    {
      if(a!=x && a!=m)
      {
      tmp=row_check[x][j].column[0];
//      g_print("aaa: %d  %d\n",a,number_of_candidates_per_square[a][tmp]);
      for(b=0;b<number_of_candidates_per_square[a][tmp];b++)
      {
//     g_print("111\n");
      if(row_check[x][j].num==possibles[a][row_check[x][j].column[0]][b])
       { 
         found_xwing=TRUE;
         for(o=b;o<number_of_candidates_per_square[a][tmp];o++)
           possibles[a][tmp][o]=possibles[a][tmp][o+1];
    
       }    
      }
      tmp=row_check[x][j].column[1];
      
      for(b=0;b<number_of_candidates_per_square[a][tmp];b++)
      {
//       g_print("222\n");
       if(row_check[x][j].num==possibles[a][tmp][b])
       { 
         found_xwing=TRUE;
         for(o=b;o<number_of_candidates_per_square[a][tmp];o++)
           possibles[a][tmp][o]=possibles[a][tmp][o+1];
    
       }    
      }
      }
    }
//    g_print("came here, how nice\n");
//    getchar();
 
 
  }
 
 } 
 } 


}
}
//===================== 
//====================
// Y-Wing

for(x=0;x<number_of_picks/2;x++)
{
for(j=0;j<number_of_picks/2;j++)
{
 if(column_check[x][j].num==-1)
  break;
 
 for(m=x+1;m<number_of_picks/2;m++)
 {
 for(k=0;k<number_of_picks/2;k++)
 {
  if(row_check[m][k].num==-1)
   break;
 
  if(column_check[m][k].num==column_check[x][j].num && column_check[m][k].row[0]==column_check[x][j].row[0] && column_check[m][k].row[1]==column_check[x][j].row[1])  
  {
    
    for(a=0;a<number_of_picks/2;a++)
    {
      if(a!=x && a!=m)
      {
      tmp=column_check[x][j].row[0];
//      g_print("2_aaa: %d  %d\n",a,number_of_candidates_per_square[tmp][a]);
      for(b=0;b<number_of_candidates_per_square[tmp][a];b++)
      {
//     g_print("2_111\n");
      if(column_check[x][j].num==possibles[tmp][a][b])
       { 
         found_xwing=TRUE;
         for(o=b;o<number_of_candidates_per_square[tmp][a];o++)
           possibles[tmp][a][o]=possibles[tmp][a][o+1];
    
       }    
      }
      tmp=column_check[x][j].row[1];
      for(b=0;b<number_of_candidates_per_square[tmp][a];b++)
      {
//       g_print("2_222\n");
       if(column_check[x][j].num==possibles[tmp][a][b])
       { 
         found_xwing=TRUE;
         for(o=b;o<number_of_candidates_per_square[tmp][a];o++)
           possibles[tmp][a][o]=possibles[tmp][a][o+1];
    
       }    
      }
      }
    }
//    g_print("2_came here, how nice\n");
//    getchar();
 
 
  }
 
 } 
 } 


}
}

//===================== 
 if(global.show_console_messegesF==TRUE)
 {
  if(found_xwing==TRUE)
  {
   g_print("++found xwing or ywing\n");
  // getchar();
  }
  else
   g_print("**fail xwing or ywing\n");
 }
}

if(mode==1 || mode==2)
{
//swordfish
for(x=0;x<number_of_picks/2;x++)
{
for(j=0;j<number_of_picks/2;j++)
{
 if(row_check[x][j].num==-1)
  break;
 
 for(y=x+1;y<number_of_picks/2;y++)
 {
 for(k=0;k<number_of_picks/2;k++)
 {
  if(row_check[y][k].num==-1)
   break;
 
  if(row_check[y][k].num==row_check[x][j].num && (
  row_check[y][k].column[0]==row_check[x][j].column[0] || row_check[y][k].column[1]==row_check[x][j].column[1] || row_check[y][k].column[0]==row_check[x][j].column[1] || row_check[y][k].column[1]==row_check[x][j].column[0])&& !(
  row_check[y][k].column[0]==row_check[x][j].column[0] && row_check[y][k].column[1]==row_check[x][j].column[1] ) )  
  {
 
  for(z=y+1;z<number_of_picks/2;z++)
  {
  for(i=0;i<number_of_picks/2;i++)
  {
   if(row_check[z][i].num==-1)
    break;
  if(row_check[z][i].num==row_check[y][k].num && ((
  row_check[z][i].column[0]==row_check[y][k].column[0] || row_check[z][i].column[1]==row_check[y][k].column[1] || row_check[z][i].column[0]==row_check[y][k].column[1] || row_check[z][i].column[1]==row_check[y][k].column[0])&& !(
  row_check[z][i].column[0]==row_check[y][k].column[0] && row_check[z][i].column[1]==row_check[y][k].column[1] ) )&&(( 
  
  row_check[z][i].column[0]==row_check[x][j].column[0] || 
  row_check[z][i].column[1]==row_check[x][j].column[1] || 
  row_check[z][i].column[1]==row_check[x][j].column[0] || 
  row_check[z][i].column[0]==row_check[x][j].column[1] )&& !(
  row_check[z][i].column[0]==row_check[x][j].column[0] && row_check[z][i].column[1]==row_check[x][j].column[1] ) ) )  
  {
    
    if( ((row_check[y][k].column[0]==row_check[z][i].column[0] ||
       row_check[y][k].column[0]==row_check[z][i].column[1]) && (
       row_check[y][k].column[0]==row_check[x][j].column[0] ||
       row_check[y][k].column[0]==row_check[x][j].column[1])) || ((
       
       row_check[y][k].column[1]==row_check[z][i].column[0] ||
       row_check[y][k].column[1]==row_check[z][i].column[1]) && (
       row_check[y][k].column[1]==row_check[x][j].column[0] ||
       row_check[y][k].column[1]==row_check[x][j].column[1])) )
        break;
       
//    g_print("good11111111111\n");
//    getchar();

    sf_columns[0].column=row_check[z][i].column[0];
    sf_columns[0].row[0]=z;
     
     if(row_check[x][j].column[0]==sf_columns[0].column || row_check[x][j].column[1]==sf_columns[0].column)
      sf_columns[0].row[1]=x;
     else
      sf_columns[0].row[1]=y;

          
    sf_columns[1].column=row_check[z][i].column[1];
    sf_columns[1].row[0]=z;
     
     if(row_check[x][j].column[0]==sf_columns[1].column || row_check[x][j].column[1]==sf_columns[1].column)
      sf_columns[1].row[1]=x;
     else
      sf_columns[1].row[1]=y;
    
    if(row_check[y][k].column[0]!=sf_columns[0].column && row_check[y][k].column[0]!=sf_columns[1].column)
     sf_columns[2].column=row_check[y][k].column[0];

    if(row_check[y][k].column[1]!=sf_columns[0].column && row_check[y][k].column[1]!=sf_columns[1].column)
     sf_columns[2].column=row_check[y][k].column[1];
    
    sf_columns[2].row[0]=y;
    sf_columns[2].row[1]=x;
    
    
//    for(m=0;m<3;m++)
//     g_print("column: %d   row: %d,  %d\n",sf_columns[m].column,sf_columns[m].row[0],sf_columns[m].row[1]);

//     getchar();
    for(m=0;m<3;m++)
    {
    for(a=0;a<number_of_picks/2;a++)
    {
     if(a==sf_columns[m].row[0] || a==sf_columns[m].row[1])
       break;
     for(b=0;b<number_of_picks/2;b++)
     {
       if(possibles[a][sf_columns[m].column][b]==-1)
         break;
       if(possibles[a][sf_columns[m].column][b]==row_check[x][j].num)
       {
         found_swordfish=TRUE;
         for(o=b;o<number_of_candidates_per_square[a][sf_columns[m].column];o++)
           possibles[a][sf_columns[m].column][o]=possibles[a][sf_columns[m].column][o+1];
       }
    
    }    
    } 
    } 
     
            
  }
  }
  }
  }
 } 
 } 


}
}











for(x=0;x<number_of_picks/2;x++)
{
for(j=0;j<number_of_picks/2;j++)
{
 if(column_check[x][j].num==-1)
  break;
 
 for(y=x+1;y<number_of_picks/2;y++)
 {
 for(k=0;k<number_of_picks/2;k++)
 {
  if(column_check[y][k].num==-1)
   break;
 
  if(column_check[y][k].num==column_check[x][j].num && (
  column_check[y][k].row[0]==column_check[x][j].row[0] || column_check[y][k].row[1]==column_check[x][j].row[1] || column_check[y][k].row[0]==column_check[x][j].row[1] || column_check[y][k].row[1]==column_check[x][j].row[0])&& !(
  column_check[y][k].row[0]==column_check[x][j].row[0] && column_check[y][k].row[1]==column_check[x][j].row[1] ) )  
  {
 
  for(z=y+1;z<number_of_picks/2;z++)
  {
  for(i=0;i<number_of_picks/2;i++)
  {
   if(column_check[z][i].num==-1)
    break;
  if(column_check[z][i].num==column_check[y][k].num && ((
  column_check[z][i].row[0]==column_check[y][k].row[0] || column_check[z][i].row[1]==column_check[y][k].row[1] || column_check[z][i].row[0]==column_check[y][k].row[1] || column_check[z][i].row[1]==column_check[y][k].row[0])&& !(
  column_check[z][i].row[0]==column_check[y][k].row[0] && column_check[z][i].row[1]==column_check[y][k].row[1] ) )&&(( 
  
  column_check[z][i].row[0]==column_check[x][j].row[0] || 
  column_check[z][i].row[1]==column_check[x][j].row[1] || 
  column_check[z][i].row[1]==column_check[x][j].row[0] || 
  column_check[z][i].row[0]==column_check[x][j].row[1] )&& !(
  column_check[z][i].row[0]==column_check[x][j].row[0] && column_check[z][i].row[1]==column_check[x][j].row[1] ) ) )  
  {
    if( ((column_check[y][k].row[0]==column_check[z][i].row[0] ||
       column_check[y][k].row[0]==column_check[z][i].row[1]) && (
       column_check[y][k].row[0]==column_check[x][j].row[0] ||
       column_check[y][k].row[0]==column_check[x][j].row[1])) || ((
       
       column_check[y][k].row[1]==column_check[z][i].row[0] ||
       column_check[y][k].row[1]==column_check[z][i].row[1]) && (
       column_check[y][k].row[1]==column_check[x][j].row[0] ||
       column_check[y][k].row[1]==column_check[x][j].row[1])) )
        break;
//    g_print("good22222222\n");
 //   getchar();

  
    sf_rows[0].row=column_check[z][i].row[0];
    sf_rows[0].column[0]=z;
     
     if(column_check[x][j].row[0]==sf_rows[0].row || column_check[x][j].row[1]==sf_rows[0].row)
      sf_rows[0].column[1]=x;
     else
      sf_rows[0].column[1]=y;

          
    sf_rows[1].row=column_check[z][i].row[1];
    sf_rows[1].column[0]=z;
     
     if(column_check[x][j].row[0]==sf_rows[1].row || column_check[x][j].row[1]==sf_rows[1].row)
      sf_rows[1].column[1]=x;
     else
      sf_rows[1].column[1]=y;
    
    if(column_check[y][k].row[0]!=sf_rows[0].row && column_check[y][k].row[0]!=sf_rows[1].row)
     sf_rows[2].row=column_check[y][k].row[0];

    if(column_check[y][k].row[1]!=sf_rows[0].row && column_check[y][k].row[1]!=sf_rows[1].row)
     sf_rows[2].row=column_check[y][k].row[1];
    
    sf_rows[2].column[0]=y;
    sf_rows[2].column[1]=x;
    
    
//    for(m=0;m<3;m++)
//     g_print("column: %d   row: %d,  %d\n",sf_rows[m].row,sf_rows[m].column[0],sf_rows[m].column[1]);

//     getchar();
    for(m=0;m<3;m++)
    {
    for(a=0;a<number_of_picks/2;a++)
    {
     if(a==sf_rows[m].column[0] || a==sf_rows[m].column[1])
       break;
     for(b=0;b<number_of_picks/2;b++)
     {
       if(possibles[sf_rows[m].row][a][b]==-1)
         break;
       if(possibles[sf_rows[m].row][a][b]==column_check[x][j].num)
       {
         found_swordfish=TRUE;
         for(o=b;o<number_of_candidates_per_square[sf_rows[m].row][a];o++)
           possibles[sf_rows[m].row][a][o]=possibles[sf_rows[m].row][a][o+1];
       }
    
    }    
    } 
    } 
  
  
  
  
  
  
  
  }
  }
  }
  }
 } 
 } 


}
}
 
 if(global.show_console_messegesF==TRUE)
 {
  if(found_swordfish==TRUE)
  {
   g_print("++found swordfish\n");
  // getchar();
  }
  else
   g_print("**fail swordfish\n");
 
 }

}
//======================= 
  
 
if(found_xwing==TRUE || found_swordfish==TRUE)
  return TRUE;
  else 
  return FALSE;
 
}

//88check_xwing_and_swordfish8888888888888888888888888888888888888888888888888888888888888888
//88check_and_remove_number_from_possibles888888888888888888888888888888888888888888888888888

gboolean check_and_remove_number_from_possibles(short possibles[][number_of_picks/2][number_of_picks/2+1],short  i,short j,short value)
{

short x,y,z,w;
short tmp1,tmp2;
gboolean put_break;
gboolean removed_any_possisbles=FALSE;

for(x=0;x<number_of_picks/2;x++)
{
    put_break=FALSE;
    for(z=0;z<number_of_picks/2;z++)
    {
    
       if(possibles[x][j][z]==-1)
         break;
    
       if(possibles[x][j][z]==value)
       {
         put_break=TRUE;
	 for(w=z;w<number_of_picks/2;w++)
	 {
	   possibles[x][j][w]=possibles[x][j][w+1];
           if(possibles[x][j][w]==-1)
	      break;
	   removed_any_possisbles=TRUE;
	 } 	        
       }
      if(put_break==TRUE)
         break;
    
    }
    
    
}

for(x=0;x<number_of_picks/2;x++)
{
        put_break=FALSE;

    for(z=0;z<number_of_picks/2;z++)
    {
    
        if(possibles[i][x][z]==-1)
         break;
    
       if(possibles[i][x][z]==value)
       {
         put_break=TRUE;         
	 for(w=z;w<number_of_picks/2;w++)
	 {
	   possibles[i][x][w]=possibles[i][x][w+1];
           if(possibles[i][x][w]==-1)
	     break;
	   removed_any_possisbles=TRUE;	  
	  } 	        
       }
       if(put_break==TRUE)
         break;
    
    }
 
}

tmp1=board_size*(i/board_size);
tmp2=board_size*(j/board_size);

for(x=tmp1;x<tmp1+board_size;x++)
{
  for(y=tmp2;y<tmp2+board_size;y++)
  {
        put_break=FALSE;

    for(z=0;z<number_of_picks/2;z++)
    {
    
       if(possibles[x][y][z]==-1)
         break;
    
       if(possibles[x][y][z]==value)
       {
           put_break=TRUE;	         
	 for(w=z;w<number_of_picks/2;w++)
	 {
           possibles[x][y][w]=possibles[x][y][w+1];
           if(possibles[x][y][w]==-1)
	     break;
	   removed_any_possisbles=TRUE;	  
	  } 	        
       }
       if(put_break==TRUE)
         break;
    
     }
   
  }

}

if(removed_any_possisbles==TRUE)
return TRUE;
else
return FALSE;

}

//88check_and_remove_number_from_possibles888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888

//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888









//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////
//back_up_possibles_and_puzzles///////////////////////////////////////////////////////////////

void back_up_possibles_and_puzzles(
short possibles[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short possibles_bck_up[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short puzzle_box_bck_up[number_of_picks/2][number_of_picks/2],
short puzzle_box_type_bck_up[number_of_picks/2][number_of_picks/2])
{

  short i,j,k;

  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    puzzle_box_bck_up[i][j]=puzzle_box[i][j].value;
    puzzle_box_type_bck_up[i][j]=puzzle_box[i][j].type;
    for(k=0;k<number_of_picks/2;k++)
      possibles_bck_up[i][j][k]=possibles[i][j][k];
  }
  }


}

//back_up_possibles_and_puzzles/////////////////////////////////////////////////////////////////
//restore_possibles_and_puzzles/////////////////////////////////////////////////////////////////

void restore_possibles_and_puzzles(
short possibles[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short possibles_bck_up[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short puzzle_box_bck_up[number_of_picks/2][number_of_picks/2],
short puzzle_box_type_bck_up[number_of_picks/2][number_of_picks/2])
{

  short i,j,k;

  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    puzzle_box[i][j].value=puzzle_box_bck_up[i][j];
    puzzle_box[i][j].type=puzzle_box_type_bck_up[i][j];
    for(k=0;k<number_of_picks/2;k++)
      possibles[i][j][k]=possibles_bck_up[i][j][k];
  }
  }

}

//restore_possibles_and_puzzles///////////////////////////////////////////////////////////////
//print_possibles/////////////////////////////////////////////////////////////////////////////

void print_possibles(short possibles[][number_of_picks/2][number_of_picks/2+1])
{
  
  short i,j;
  
  g_print("\n\n+++possibles+++\n\n");	  
  
  for(i=0;i<number_of_picks/2;i++)
  {
    
    for(j=0;j<number_of_picks/2;j++)
      g_print("%d    ",possibles[i][j][0]);
    
    g_print("\n");
  
  }       
  
  g_print("\n\n+++++++++\n\n");
  getchar();


}

//print_possibles/////////////////////////////////////////////////////////////////////////////
//convert_doubt_to_confirmed_text_if_necessery////////////////////////////////////////////////

short convert_doubt_to_confirmed_text_if_necessery(short value)
{

  if(value<number_of_picks/2)
    return value;  
  else if(value>=number_of_picks/2 && global.consider_doubt_text_as_confirm_textF == TRUE)
    return value-number_of_picks/2;
  else
    return -1; 

}

//convert_doubt_to_confirmed_text_if_necessery////////////////////////////////////////////////
//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////


//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////
//ACCESSORIES/////////////////////////////////////////////////////////////////////////////////
