/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"
#include <stdio.h>
#ifdef WIN
#include <windows.h>
#endif
/*  
List of functions:
void get_executable_path(char* buffer,size_t len)
void shrink_unwanted_char(gchar ch[255])
int main(int argc,char *argv[])
*/




//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88get_executable_path8888888888888999888888888888888888888888888888888888888888888888888888

#ifdef LINUX
void get_executable_path(char* buffer,size_t len)
{
  char* path_end;
  
  readlink("/proc/self/exe",buffer,len);
  path_end=strrchr(buffer,'/');
  ++path_end;
  *path_end='\0';
}
#endif

//88get_executable_path8888888888888999888888888888888888888888888888888888888888888888888888
//88change_slash88888888888888888888888888888888888888888888888888888888888888888888888888888

#ifdef WIN
void change_slash()
{
   short i,len;  
   len=strlen(path);
   for(i=0;i<len;i++)
   {
      if(path[i]=='\\')
        path[i]='/';                  
                     
    
   }                  
     
}     
#endif

//88change_slash88888888888888888888888888888888888888888888888888888888888888888888888888888
//88shrink_unwanted_char888888888888888888888888888888888888888888888888888888888888888888888

void shrink_unwanted_char(gchar ch[255])
{
  char *str_ptr;
  short blen,i;
  
  str_ptr=strrchr(ch,'\n');
  *str_ptr='\0';
  i=0;
  while(ch[i]==' ')
   i=i+1;  
  
  blen=i;
  i=0;
  while(ch[blen+i]!='\0')
  {
   ch[i]=ch[blen+i];
   i=i+1;
  }
  ch[i]='\0';
//  g_print("%s\n",ch);

}

//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88main8888888888888888888888888888888888888888888888888888888888888888888888888888888888888


int main(int argc,char *argv[])
{

  FILE *fp;
  gint response;
  
  int value;
  short i,j,k;
  char ch[255];
  char ch2[255];
  char c;

    //GtkWidget *message_dialog;
    
  GtkWidget *main_vbox;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GtkWidget *vseperator;
  GtkWidget *splash_screen;
  GtkWidget *tips_and_tricks;
  GtkWidget *image;
  GtkWidget *label;
  
  GError *error=NULL;
  GdkPixbuf *icon;
  GList *icon_list=NULL;

    
  g_thread_init(NULL);
  gdk_threads_init();
  gtk_init(&argc,&argv);
   // getchar();
  //getcwd(path);  
  //g_print("argv:  %s",argv[1]);
  //g_print("path:  %s",path);
  //chdir(path);
  
 /*            message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_OK,(const char*)argv[1]);

           gtk_dialog_run (GTK_DIALOG (message_dialog));
           gtk_widget_destroy (message_dialog);
  */
  #ifdef LINUX
  get_executable_path(path,sizeof(path));
  chdir(path);
  icon=gdk_pixbuf_new_from_file("icons/icon16_2.png",&error);
  icon_list=g_list_append(icon_list,(gpointer)icon);
  icon=gdk_pixbuf_new_from_file("icons/icon32.png",&error);
  icon_list=g_list_append(icon_list,(gpointer)icon);
  icon=gdk_pixbuf_new_from_file("icons/icon48.png",&error);
  icon_list=g_list_append(icon_list,(gpointer)icon);
  icon=gdk_pixbuf_new_from_file("icons/icon64.png",&error);
  icon_list=g_list_append(icon_list,(gpointer)icon);
  icon=gdk_pixbuf_new_from_file("icons/icon128.png",&error);
  icon_list=g_list_append(icon_list,(gpointer)icon);
  #endif
 
  #ifdef WIN
    char szFileName[MAX_PATH];
    char* path_end;
    HINSTANCE hInstance;
    
    hInstance=GetModuleHandle(NULL);
    GetModuleFileName(hInstance,szFileName,MAX_PATH);
    
    strcpy(path,szFileName);
    change_slash();
    path_end=strrchr(path,'/');
    ++path_end;
    *path_end='\0';
     chdir(path);
  #endif
  
   
   
   gtk_window_set_default_icon_list(icon_list);

   fp=fopen("settings","r");

//   if(fp==NULL || 1)
   if(fp==NULL)
   {
     fp=fopen("settings","w");
   
     strcpy(ch,"Note: Take a backup before you edit\n\n");
     fprintf(fp,"%s\n",ch);

     strcpy(ch,"[game]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"board_size");
     value=3;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"time_race");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"two_player_solve");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"total_time");
     value=1500;
     fprintf(fp,"%s:  %d\n",ch,value);
     global.two_player_gameF=value;
     strcpy(ch,"two_player_game");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"Player1_name");
     strcpy(ch2,"Player1");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"player1_initial");
     strcpy(ch2,"PL1");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"player2_name");
     strcpy(ch2,"Player2");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"player2_initial");
     strcpy(ch2,"PL2");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"time_game");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"minus_point");
     value=5;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"player1_time");
     value=60;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"player2_time");
     value=60;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"wait_time");
     value=10;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"total_time");
     value=2250;
     fprintf(fp,"%s:  %d\n",ch,value);
     fprintf(fp,"\n\n");

  
     strcpy(ch,"[font]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"pick_box_font");
     strcpy(ch2,"Cursor 16");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"puzzle_box_font");
     strcpy(ch2,"Cursor 16");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"pencil_in_font");
     strcpy(ch2,"Cursor 8");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"status_text");
     strcpy(ch2,"Cursor 12");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     strcpy(ch,"score_text");
     strcpy(ch2,"Cursor 10");
     fprintf(fp,"%s:  %s\n",ch,ch2);
     fprintf(fp,"\n\n");
   
     strcpy(ch,"[size]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"pick_square_size");
     value=32;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_box_square_size");
     value=42;
     fprintf(fp,"%s:  %d\n",ch,value);
     fprintf(fp,"\n\n");
   
   
     strcpy(ch,"[color]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"highlight_border_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"highlight_border_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"highlight_border_blue");
     value=192*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"highlight_bg_red");
     value=192*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"highlight_bg_green");
     value=192*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"highlight_bg_blue");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pick_selected_bg_red");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pick_selected_bg_green");
     value=192*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pick_selected_bg_blue");
     value=203*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pick_selected_border_red");
     value=165*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pick_selected_border_green");
     value=42*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pick_selected_border_blue");
     value=42*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"confirm_text_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"confirm_text_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"confirm_text_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"doubt_text_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"doubt_text_green");
     value=10*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"doubt_text_blue");
     value=255*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_lines_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_lines_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_lines_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_bg_red");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_bg_green");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"puzzle_bg_blue");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"mouse_box_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"mouse_box_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"mouse_box_blue");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"key_box_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"key_box_green");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"key_box_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"num_fixed_box_bg_red");
     value=229*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"num_fixed_box_bg_green");
     value=229*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"num_fixed_box_bg_blue");
     value=229*65535/255;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"num_fixed_text_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"num_fixed_box_bg_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"num_fixed_box_bg_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"conflict_lines_red");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"conflict_lines_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"conflict_lines_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pencil_in_red");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pencil_in_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"pencil_in_blue");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"status_text_color_red");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"status_text_color_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"status_text_color_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"score_text_color_red");
     value=65535;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"score_text_color_green");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"score_text_color_blue");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     fprintf(fp,"\n\n");

        
     strcpy(ch,"[generator]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"guess_threshold");
     fprintf(fp,"%s:  %d\n",ch,16);
     strcpy(ch,"generate_symmetric_puzzle");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"hidden_unique_candidate");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"block_interaction_with_row_and_column");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"row_and_column_interaction_with_block");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"visible_doublets_triplets_etc");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"block_block_interaction");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"hidden_doublets_triplets_etc");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"xwing");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"swordfish");
     fprintf(fp,"%s:  %d\n",ch,value);
     fprintf(fp,"\n\n");

     
     strcpy(ch,"[solver]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"hidden_unique_candidate");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"block_interaction_with_row_and_column");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"row_and_column_interaction_with_block");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"visible_doublets_triplets_etc");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"block_block_interaction");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"xwing");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"hidden_doublets_triplets_etc");
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"swordfish");
     fprintf(fp,"%s:  %d\n",ch,value);
     fprintf(fp,"\n\n");

     
     strcpy(ch,"[preference]");
     fprintf(fp,"%s\n",ch);
     strcpy(ch,"toolbar_mode");
     value=3;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"show_status_bar");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"show_splash_screen");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"show_tips_and_tricks");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"sticky_selection_method");
     value=3;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"keyboard_cursor_move_over_fixed_box");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"keyboard_cursor_border_restriction");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"draw_figures_while_computer_solving");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"show_console_messeges");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"check_puzzle_validity_for_created_puzzle");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"automatic_remove_pencil_in");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"show_conflicts_while_keying");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"assume_doubt_text_as_confirmed_text");
     value=0;
     fprintf(fp,"%s:  %d\n",ch,value);
     strcpy(ch,"use_doubt_text_for_pencil_in");
     value=1;
     fprintf(fp,"%s:  %d\n",ch,value);
     fprintf(fp,"\n\n");
   
   
     fclose(fp);
     fp=fopen("settings","r");
   }
   
   
   
   if(fp!=NULL)
   {
   while( (c=fgetc(fp))!=EOF)
   {
     i=0;
     if(c=='[')
     {
       while((c=fgetc(fp))!=']')
       {
          ch[i]=c;
          i=i+1;
       }
     }
      
     ch[i]='\0';
   
     if( !(strcmp("game",ch)) )
     {
       fscanf(fp,"%s  %d",ch,&value);
       board_size_original=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.time_race=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.two_player_solveF=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.racing_time=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.two_player_gameF=value;
       fscanf(fp,"%s  %s",ch,global.player1_name);
       fscanf(fp,"%s  %s",ch,global.player1_ini);
       fscanf(fp,"%s  %s",ch,global.player2_name);
       fscanf(fp,"%s  %s",ch,global.player2_ini);
       fscanf(fp,"%s  %d",ch,&value);
       global.two_player_time_game=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.minus_points=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.tp_1_time=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.tp_2_time=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.wait_time=value;
       fscanf(fp,"%s  %d",ch,&value);
       global.tp_total_time=value;
     }
     
    
     if( !(strcmp("font",ch)) )
     {
       fscanf(fp,"%s",ch);
       fgets(pick_box_font,250,fp);
       shrink_unwanted_char(pick_box_font);
//       g_print("%s  %s\n",ch,pick_box_font);
//       g_print("%s  %s\n",ch,pick_box_font);
       fscanf(fp,"%s",ch);
       fgets(puzzle_box_font,250,fp);
       shrink_unwanted_char(puzzle_box_font);
       fscanf(fp,"%s",ch);
       fgets(pencil_in_font,250,fp);
       shrink_unwanted_char(pencil_in_font);
       fscanf(fp,"%s",ch);
       fgets(status_text,250,fp);
       shrink_unwanted_char(status_text);
       fscanf(fp,"%s",ch);
       fgets(score_text,250,fp);
       shrink_unwanted_char(score_text);
     }  
   

       
     if( !(strcmp("size",ch)) )
     {
       fscanf(fp,"%s  %d",ch,&pick_square_size);
       fscanf(fp,"%s  %d",ch,&puzzle_box_square_size);
     }  
   
   
   
     if( !(strcmp("color",ch)) )
     {
       fscanf(fp,"%s  %d",ch,&color.hl_dark.red);
       fscanf(fp,"%s  %d",ch,&color.hl_dark.green);
       fscanf(fp,"%s  %d",ch,&color.hl_dark.blue);
       fscanf(fp,"%s  %d",ch,&color.hl_light.red);
       fscanf(fp,"%s  %d",ch,&color.hl_light.green);
       fscanf(fp,"%s  %d",ch,&color.hl_light.blue);
       fscanf(fp,"%s  %d",ch,&color.pick_selected_bg.red);
       fscanf(fp,"%s  %d",ch,&color.pick_selected_bg.green);
       fscanf(fp,"%s  %d",ch,&color.pick_selected_bg.blue);
       fscanf(fp,"%s  %d",ch,&color.pick_selected.red);
       fscanf(fp,"%s  %d",ch,&color.pick_selected.green);
       fscanf(fp,"%s  %d",ch,&color.pick_selected.blue);
       fscanf(fp,"%s  %d",ch,&color.conf_text.red);
       fscanf(fp,"%s  %d",ch,&color.conf_text.green);
       fscanf(fp,"%s  %d",ch,&color.conf_text.blue);
       fscanf(fp,"%s  %d",ch,&color.doubt_text.red);
       fscanf(fp,"%s  %d",ch,&color.doubt_text.green);
       fscanf(fp,"%s  %d",ch,&color.doubt_text.blue);
       fscanf(fp,"%s  %d",ch,&color.puzzle_lines.red);
       fscanf(fp,"%s  %d",ch,&color.puzzle_lines.green);
       fscanf(fp,"%s  %d",ch,&color.puzzle_lines.blue);
       fscanf(fp,"%s  %d",ch,&color.puzzle_bg.red);
       fscanf(fp,"%s  %d",ch,&color.puzzle_bg.green);
       fscanf(fp,"%s  %d",ch,&color.puzzle_bg.blue);
       fscanf(fp,"%s  %d",ch,&color.puzzle_selected.red);
       fscanf(fp,"%s  %d",ch,&color.puzzle_selected.green);
       fscanf(fp,"%s  %d",ch,&color.puzzle_selected.blue);
       fscanf(fp,"%s  %d",ch,&color.key_box.red);
       fscanf(fp,"%s  %d",ch,&color.key_box.green);
       fscanf(fp,"%s  %d",ch,&color.key_box.blue);
       fscanf(fp,"%s  %d",ch,&color.num_fixed_box_bg.red);
       fscanf(fp,"%s  %d",ch,&color.num_fixed_box_bg.green);
       fscanf(fp,"%s  %d",ch,&color.num_fixed_box_bg.blue);
       fscanf(fp,"%s  %d",ch,&color.num_fixed_text.red);
       fscanf(fp,"%s  %d",ch,&color.num_fixed_text.green);
       fscanf(fp,"%s  %d",ch,&color.num_fixed_text.blue);
       fscanf(fp,"%s  %d",ch,&color.conflict_lines.red);
       fscanf(fp,"%s  %d",ch,&color.conflict_lines.green);
       fscanf(fp,"%s  %d",ch,&color.conflict_lines.blue);
       fscanf(fp,"%s  %d",ch,&color.pencil_in.red);
       fscanf(fp,"%s  %d",ch,&color.pencil_in.green);
       fscanf(fp,"%s  %d",ch,&color.pencil_in.blue);
       fscanf(fp,"%s  %d",ch,&color.status_text_color.red);
       fscanf(fp,"%s  %d",ch,&color.status_text_color.green);
       fscanf(fp,"%s  %d",ch,&color.status_text_color.blue);
       fscanf(fp,"%s  %d",ch,&color.score_text_color.red);
       fscanf(fp,"%s  %d",ch,&color.score_text_color.green);
       fscanf(fp,"%s  %d",ch,&color.score_text_color.blue);
     }  
   
    
     if( !(strcmp("generator",ch)) )
     {
       fscanf(fp,"%s  %d\n",ch,&global.guess_threshold);
       fscanf(fp,"%s  %d\n",ch,&value);
       global.symmetric_puzzleF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_hidden_unique_candidate=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_block_interaction_with_row_and_column=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_row_and_column_interaction_with_block=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_visible_doublets_triplets_etc=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_block_block_interaction=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_hidden_doublets_triplets_etc=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_xwing=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.g_swordfish=value;
     }
        
   
     if( !(strcmp("solver",ch)) )
     {
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_hidden_unique_candidate=value;
//       g_print("value  s_:  %s  %d   %d\n",ch,value,global.s_hidden_unique_candidate);
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_block_interaction_with_row_and_column=value;
//       g_print("value  s_:  %s  %d   %d\n",ch,value,global.s_block_interaction_with_row_and_column);
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_row_and_column_interaction_with_block=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_visible_doublets_triplets_etc=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_block_block_interaction=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_xwing=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_hidden_doublets_triplets_etc=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.s_swordfish=value;
     }
   
   
     if( !(strcmp("preference",ch)) )
     {
       fscanf(fp,"%s  %d\n",ch,&value);
       toolbar_mode=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.show_status_barF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.show_splash_screenF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.show_tips_and_tricksF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       sticky_selection=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.key_movement_fixed_box_no_limit=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.key_movement_restrictive=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.show_figures_while_solving=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.show_console_messegesF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.editor_check_puzzle_validity=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.auto_pencil_in_remove=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.check_for_conflictF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.consider_doubt_text_as_confirm_textF=value;
       fscanf(fp,"%s  %d\n",ch,&value);
       global.treat_doubt_as_pencil_in=value;
//       g_print("value:  %d    %d\n",global.show_console_messegesF,global.editor_check_puzzle_validity);
     }
    
   
   }
   fclose(fp);
   }
    
   
   
  if(global.show_splash_screenF==TRUE)
  {
    splash_screen = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (splash_screen), "gs splash");
    gtk_window_set_position(GTK_WINDOW (splash_screen),GTK_WIN_POS_CENTER_ALWAYS);
    image=gtk_image_new_from_file("images/splash_image.gif");
    gtk_container_add (GTK_CONTAINER (splash_screen),image);
    gtk_widget_show(image);
    g_signal_connect (G_OBJECT (splash_screen), "delete_event",G_CALLBACK (destroy_given_widget), NULL);
  }

  
  if(global.show_tips_and_tricksF==TRUE)
  {
   tips_and_tricks=gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title (GTK_WINDOW (tips_and_tricks), "GS Tips and Tricks");
   gtk_window_set_default_size(GTK_WINDOW(tips_and_tricks),300,250);
   create_tips_and_tricks(tips_and_tricks);
   g_signal_connect (G_OBJECT (tips_and_tricks), "delete_event",G_CALLBACK (destroy_given_widget), NULL);
  }
  //initializing///////////////
  
  timer_tag_id=0;
  tag_id=0;
  
  board_size=board_size_original;
  pixmap=NULL;
  pixmap_bckup=NULL;  
  settings_widget=NULL;
  colorseldlg=NULL;
  fontseldlg=NULL;
  gc=NULL;
  global.highlighted_pick_box=-1;
  global.selected_pick_box=-1;
  p_m=-1;
  global.edit_modeF=TRUE;

  if(board_size==3)
  {
    global.number_of_free_boxes=81;
    number_of_picks=18;
  }  
  else if(board_size==4)
  {
    global.number_of_free_boxes=256;
    number_of_picks=32;
  }  
     
     
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    for(k=0;k<number_of_picks/2+1;k++)
      pencil_in[i][j][k]=-1;
  }
  }

  
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    puzzle_box[i][j].value=-1;
    puzzle_box[i][j].type=0;      
  }
  }
  
  
  global.keyboard_presentF=FALSE;
  key_row=number_of_picks/4;
  key_column=key_row;
  global.two_player_game=FALSE;

  ////////////////////////////
      
//  getchar();
  
  gs_main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku");
//  gtk_window_set_policy(GTK_WINDOW(gs_main_window),FALSE,FALSE,FALSE);
//  gtk_window_set_icon (GTK_WINDOW (gs_main_window),icon);
  g_signal_connect (G_OBJECT (gs_main_window), "delete_event",G_CALLBACK (delete_event), NULL);
  g_signal_connect (G_OBJECT (gs_main_window), "key_press_event",G_CALLBACK (key_presses), NULL);
  gtk_widget_realize (gs_main_window);
    
   
  main_vbox=gtk_vbox_new(FALSE,0); 
  gtk_container_set_border_width (GTK_CONTAINER (main_vbox), 0);
  gtk_container_add (GTK_CONTAINER (gs_main_window),main_vbox);
      
  vbox1=gtk_vbox_new(FALSE,0); 
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 0);
  gtk_box_pack_start (GTK_BOX (main_vbox), vbox1, FALSE, TRUE, 0);
   
  hbox1=gtk_hbox_new(FALSE,0); 
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 10);
  gtk_box_pack_start (GTK_BOX (main_vbox), hbox1,FALSE,TRUE,0);
   
  hbox2=gtk_hbox_new(FALSE,0); 
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 0);
  gtk_box_pack_end (GTK_BOX (main_vbox), hbox2, FALSE, TRUE, 0);
  
  hbox3=gtk_hbox_new(FALSE,0); 
  gtk_container_set_border_width (GTK_CONTAINER (hbox3), 0);
     
    
  do_ui_manager (vbox1,gs_main_window);
   
  
  drawing_area=gtk_drawing_area_new();
  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",(GtkSignalFunc) expose_event, NULL);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "motion_notify_event",(GtkSignalFunc) mouse_movement_event, NULL);
  g_signal_connect (G_OBJECT (drawing_area), "button_press_event",G_CALLBACK (drawing_area_clicked), NULL);
 
  gtk_widget_set_events (drawing_area, GDK_EXPOSURE_MASK
			 | GDK_BUTTON_PRESS_MASK
                         | GDK_POINTER_MOTION_MASK
                         | GDK_POINTER_MOTION_HINT_MASK);


  gtk_box_pack_start (GTK_BOX (hbox1), drawing_area, TRUE, FALSE, 0);
  
  
  
  initialize_board();
  //  getchar();
  
  status_bar=gtk_scrolled_window_new( NULL,NULL );    
  gtk_scrolled_window_set_policy  (GTK_SCROLLED_WINDOW (status_bar), GTK_POLICY_NEVER, GTK_POLICY_NEVER);
  gtk_container_add(GTK_CONTAINER(hbox2),status_bar);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (status_bar),hbox3);
  
  status_bar_label_1=gtk_label_new("  Editor mode");
  gtk_misc_set_alignment (GTK_MISC(status_bar_label_1),0,0.5);
  gtk_box_pack_start (GTK_BOX (hbox3), status_bar_label_1, TRUE, TRUE, 0);
  gtk_widget_show(status_bar_label_1);
  
  vseperator=gtk_vseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox3), vseperator,FALSE,TRUE,0);
  gtk_widget_show (vseperator);
  
  status_bar_label_2=gtk_label_new("  ");
  update_status_bar_num_of_occupied_box();
  gtk_box_pack_end (GTK_BOX (hbox3), status_bar_label_2, FALSE, TRUE, 0);
  gtk_widget_show(status_bar_label_2);

  
  //  getchar();
  
  gtk_widget_show(drawing_area); 
  gtk_widget_show(vbox1); 
  gtk_widget_show(hbox1);   
  gtk_widget_show(hbox2);
  if(global.show_status_barF==TRUE)
    gtk_widget_show(status_bar);  
  gtk_widget_show(hbox3);
  gtk_widget_show(main_vbox);    
  gtk_widget_show(gs_main_window);  

  
  if(global.show_tips_and_tricksF==TRUE)
    gtk_widget_show(tips_and_tricks);  
  
  
  if(global.show_splash_screenF==TRUE)
    gtk_widget_show (splash_screen);

  gc=gdk_gc_new(drawing_area->window);
  colormap=gdk_colormap_get_system();
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.conf_text );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.doubt_text );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.hl_light );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.hl_dark ); 
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pick_selected);
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pick_selected_bg );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_bg );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_lines );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_selected );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.key_box );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.num_fixed_box_bg );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.num_fixed_text );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.conflict_lines );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pencil_in );
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.status_text_color);
  gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.score_text_color);
  
  if(argv[1]==NULL)
    draw_empty_puzzle();
  else
    load_the_puzzle(argv[1]);
  
  create_new_undo(); 
//  getchar();
  gdk_threads_enter();
  gtk_main ();
  gdk_threads_leave();
  return 0;
}

//88main8888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88create_tips_and_tricks8888888888888888888888888888888888888888888888888888888888888888888

void create_tips_and_tricks(GtkWidget *tips_and_tricks)
{

   GtkWidget *vbox;
   GtkWidget *nbbox;
   GtkWidget *table;
   GtkWidget *notebook;
   GtkWidget *tab_label;
   GtkWidget *label;
   GtkWidget *button;
   GtkWidget *seperator;

    
   
   
   
   notebook=gtk_notebook_new();
   gtk_notebook_set_show_tabs(GTK_NOTEBOOK(notebook),FALSE);
   gtk_notebook_set_show_border (GTK_NOTEBOOK(notebook),FALSE);
  
  
   vbox=gtk_vbox_new(FALSE,0); 
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);
   gtk_container_add (GTK_CONTAINER (tips_and_tricks),vbox);
  
   gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);

      
    nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 1\n\nYou can use keyboard or mouse to enter values in the puzzle box, read manual for more details.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 1");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
  
   nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 2\n\nTo start an empty puzzle, disable 'check puzzle validiy for created puzzle' from settings->preference. Now, goto editor mode. With empty puzzle, click 'play created puzzle' to start a game with empty puzzle.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 2");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
  
   nbbox=gtk_vbox_new(FALSE,0); 
   label=gtk_label_new("Tip 3\n\nTo speed up game generation disable 'draw figures while drawing and 'show console messages' from settings->preference.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 3");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
  
   nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 4\n\nDisable 'visible doublets triplets etc' and 'hidden doublets triplets etc' for solver and generator to generate 16x16 puzzle within 10 minutes.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 4");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
  
    nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 5\n\nFor 9x9 puzzle guess threshold of 16 is suffice. For 16x16 a guess threshold of 84 is suffice.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 5");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  

 
   nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 6\n\nTo clear a candidate entered into a cell, use middle button from the mouse or 0(zero) from the keyboard.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 6");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
   
   
   nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 7\n\nIn tough puzzle, if you think you are stuck(or you cannot find visible unique candidate) then, look for hidden unique candidate. Next look for visible doublets, triplets etc. All others occur rarely.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 7");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
    
   nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 8\n\nUse pencil-in to solve the puzzle easily, but you will miss all the fun.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 8");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
   nbbox=gtk_vbox_new(FALSE,0); 
   //gtk_container_set_border_width (GTK_CONTAINER (nbbox), 0);
   //label=gtk_label_new("This ");
   label=gtk_label_new("Tip 9\n\nYou can even change name, initial, time values during a game, and it will be reflected immediatly.");
   gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
   gtk_box_pack_start (GTK_BOX (nbbox), label, TRUE, TRUE, 24);
   gtk_widget_show(label);
   gtk_widget_show(nbbox);
   tab_label = gtk_label_new ("Tip 9");
   gtk_notebook_append_page(GTK_NOTEBOOK(notebook),nbbox,tab_label );
   gtk_widget_show (tab_label);
  
  
  
  
  
  
   seperator= gtk_hseparator_new ();
   gtk_box_pack_start (GTK_BOX (vbox), seperator,FALSE,TRUE,3);
   gtk_widget_show (seperator);
   
     
   table = gtk_table_new (1, 3, FALSE);
   gtk_container_set_border_width(GTK_CONTAINER(table),0);
   gtk_box_pack_end (GTK_BOX (vbox), table,FALSE,TRUE,0);

   button = gtk_button_new_with_label ("Previous");
   gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 0, 1);
   gtk_widget_show(button);
   g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(tips_previous),notebook);

   button = gtk_button_new_with_label ("Next");
   gtk_table_attach_defaults (GTK_TABLE (table), button, 1, 2, 0, 1);
   gtk_widget_show(button);
   g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(tips_next),notebook);

   button=gtk_button_new_from_stock(GTK_STOCK_CLOSE);
   //gtk_button_set_label(GTK_BUTTON(button), (const gchar*)" Close");
   gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 0, 1);
   //gtk_table_attach (GTK_TABLE (table), button, 2, 3, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
   gtk_widget_show(button);
   g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(close_tips_and_tricks),tips_and_tricks);


   gtk_widget_show(notebook);
   gtk_widget_show(seperator);
   gtk_widget_show(table);
   gtk_widget_show(vbox);
   


}

//88create_tips_and_tricks8888888888888888888888888888888888888888888888888888888888888888888
//88close_tips_and_tricks88888888888888888888888888888888888888888888888888888888888888888888

gboolean close_tips_and_tricks(GtkWidget *button, gpointer data)
{
  gtk_widget_destroy( (GtkWidget *) data);
  return TRUE;
}


//88close_tips_and_tricks88888888888888888888888888888888888888888888888888888888888888888888
//88tips_previous8888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean tips_previous(GtkWidget *button, gpointer data)
{
  gint page_number;
  page_number=gtk_notebook_get_current_page(GTK_NOTEBOOK((GtkWidget *) data));

  if(page_number<1)
    page_number=1;
         
  gtk_notebook_set_current_page (GTK_NOTEBOOK( (GtkWidget *) data),page_number-1);       
         
}

//88tips_previous8888888888888888888888888888888888888888888888888888888888888888888888888888
//88tips_next88888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean tips_next(GtkWidget *button, gpointer data)
{
         
  gint page_number;
  page_number=gtk_notebook_get_current_page(GTK_NOTEBOOK((GtkWidget *) data));
         
  gtk_notebook_set_current_page (GTK_NOTEBOOK( (GtkWidget *) data),page_number+1);       
         
         
}         

//88tips_next88888888888888888888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888

