/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#define MAX_STR_LEN  255

GtkWidget *gs_main_window;
GtkWidget *settings_widget;
GtkWidget *colorseldlg;
GtkWidget *fontseldlg;

GtkWidget *drawing_area;

GtkWidget *toolbar;
GtkWidget *status_bar;
GtkWidget *status_bar_label_1;
GtkWidget *status_bar_label_2;


GdkGC *gc;
GdkColormap *colormap;
GdkPixmap *pixmap;
GdkPixmap *pixmap_bckup;

GRand* grand;

GtkActionGroup *actions;

GThread *thread;

gchar pick_box_font[255];
gchar puzzle_box_font[255];
gchar pencil_in_font[255];
gchar status_text[255];
gchar score_text[255];
gchar path[PATH_MAX];


guint timer_tag_id;
guint tag_id;




int mouse_x;
int mouse_y;


short number_of_picks;//18 or 32
short board_size_original; //3 or 4
short board_size; 
short pick_square_size;
short puzzle_box_square_size;
short puzzle_box_y; 

short pencil_in[16][16][17];

short key_row;
short key_column;
short key_value;

short p_m;
short p_n;


short sticky_selection;  //1 sticky  2 non sticky  3 semi-sticky
short toolbar_mode;  //1 icons  2 text  3 both



short drawing_area_w;
short drawing_area_h;




struct global
{

short selected_pick_box;
short highlighted_pick_box;
short guess_threshold;
short number_of_free_boxes;
unsigned long puzzle_number;

char player1_name[100];
char player1_ini[5];
char player2_name[100];
char player2_ini[5];
short p1_points;
short p2_points;
short minus_points;
short wait_time;
int racing_time;
int tp_total_time;
short tp_1_time;
short tp_2_time;


short num_hidden_unique_candidate;
short num_visible_doublets_triplets_etc;
short num_hidden_doublets_triplets_etc;
short num_row_and_column_interaction_with_block;
short num_block_interaction_with_row_and_column;
short num_block_block_interaction;
short num_xwing;
short num_swordfish;
short guesses;
int solver_time;
int generator_time;





unsigned custom_puzzle :1;
unsigned keyboard_presentF :1;
unsigned is_there_conflictsF:1;
unsigned edit_modeF:1;
unsigned conflict_by_player1 :1;
unsigned whose_turn :1;
unsigned disable_mouse :1;
unsigned disable_keyboard :1;


unsigned two_player_unlimited_total_time :1;
unsigned two_player_time_game :1; //original
unsigned two_player_time_game_dupe :1;
unsigned two_player_gameF :1; //original
unsigned two_player_game :1;
unsigned time_race :1;
unsigned two_player_solveF :1;


unsigned s_hidden_unique_candidate :1;
unsigned s_visible_doublets_triplets_etc :1;
unsigned s_hidden_doublets_triplets_etc :1;
unsigned s_row_and_column_interaction_with_block : 1;
unsigned s_block_interaction_with_row_and_column : 1;
unsigned s_block_block_interaction : 1;
unsigned s_xwing : 1;
unsigned s_swordfish : 1;
unsigned g_hidden_unique_candidate :1;
unsigned g_visible_doublets_triplets_etc :1;
unsigned g_hidden_doublets_triplets_etc :1;
unsigned g_row_and_column_interaction_with_block : 1;
unsigned g_block_interaction_with_row_and_column : 1;
unsigned g_block_block_interaction : 1;
unsigned g_xwing : 1;
unsigned g_swordfish : 1;
unsigned have_solution :1;
unsigned have_to_guess :1;
unsigned found_a_puzzle : 1;
unsigned solver_finished : 1;
unsigned generator_finished : 1;
unsigned abort_generator :1;
unsigned symmetric_puzzleF:1;
unsigned puzzle_generation_successfulF :1;
unsigned invalid_puzzleF :1;


unsigned show_status_barF:1;
unsigned show_splash_screenF:1;
unsigned show_tips_and_tricksF:1;
unsigned key_movement_restrictive :1;
unsigned key_movement_fixed_box_no_limit :1;
unsigned show_figures_while_solving :1;
unsigned treat_doubt_as_pencil_in :1;
unsigned editor_check_puzzle_validity:1;
unsigned consider_doubt_text_as_confirm_textF:1;
unsigned check_for_conflictF:1;
unsigned show_console_messegesF:1;
unsigned auto_pencil_in_remove :1;

}global;



struct pick
{
short int x;
short int y;
short int mouse_over;
}pick[32];

struct puzzle_box
{
short int x;
short int y;
short int value;
short int type;    //type 1 is fixed  &&  11 fixed with no boundry
}puzzle_box[16][16];



struct timing
{
short wait_time;
int tp_total_time;
short tp_1_time;
short tp_2_time;
}timing;

struct second_copy
{
char player1_name[100];
char player1_ini[5];
char player2_name[100];
char player2_ini[5];
}sec_copy;

struct color
{
 GdkColor hl_dark;
 GdkColor hl_light;
 
 GdkColor pick_selected;
 GdkColor pick_selected_bg; 
 
 GdkColor conf_text;
 GdkColor doubt_text;
 
 
 GdkColor puzzle_bg;
 GdkColor puzzle_lines;
 GdkColor puzzle_selected;
 
 GdkColor num_fixed_box_bg;
 GdkColor num_fixed_text;
 
 GdkColor key_box;
 
 GdkColor conflict_lines;
 
 GdkColor pencil_in;  

 GdkColor status_text_color;  
 GdkColor score_text_color;  
  
}color;




struct undo_redo
{
  short number_of_free_boxes;
  short pencil_in[16][16][17];
  struct puzzle_box puzzle_box[16][16];
  struct undo_redo *next;
  struct undo_redo *prev;
};
struct undo_redo *ur;


enum {
  FLAGS_FOR_GOTO_EDITOR,
  FLAGS_FOR_EDITOR,
  FLAGS_FOR_ONE_PLAYER_GAME,
  FLAGS_FOR_TWO_PLAYER_GAME,
  FLAGS_FOR_OTHERS
};

 
 
//In gsudoku.c 
#ifdef LINUX
void get_executable_path(char* buffer,size_t len);
#endif
void shrink_unwanted_char(gchar ch[255]);
//int main(int argc,char *argv[])
void create_tips_and_tricks(GtkWidget *tips_and_tricks);
gboolean close_tips_and_tricks(GtkWidget *button, gpointer data); 
gboolean tips_previous(GtkWidget *button, gpointer data); 
gboolean tips_next(GtkWidget *button, gpointer data); 

//In da_interactive.c
void calculate_pencil_in(short i,short j,short value);
void initialize_and_draw_empty_puzzle();
void draw_and_select_key_box(short mode);
void draw_and_unselect_key_box();
gboolean key_presses(GtkWidget *widget, GdkEventKey *event);
void select_pick_box();
void unselect_pick_box();
void unselect_puzzle_box();
gboolean drawing_area_clicked(GtkWidget *widget, GdkEventButton *event);
void drawing_area_mclicked();
void drawing_area_rclicked();
void drawing_area_lclicked();
void highlight_pick_box();
void unhighlight_box ();
gboolean mouse_movement_event( GtkWidget *widget, GdkEventMotion *event );
void convert_num_to_ascii(int num,char *ch);

//In da_drawing.c
void draw_select_puzzle_box(short m,short n,short value,short mode);
void draw_unselect_puzzle_box(short m,short n);
void draw_select_pick_box(short pick_box_number,short mode);
void draw_highlight_pick_box(short pick_box_number);
void draw_original_pick_box (short pick_box_number);
void draw_line(short m,short n, short p,short q);
void draw_pencil_in(short m,short n,short mode);
void draw_score(short mode,short score);
void draw_empty_puzzle();
void draw_puzzle();


//In menu.c
void do_ui_manager (GtkWidget *box1,GtkWidget *window);


//In gsignal.c
void menu_change_auto_pencil_in (GtkAction *action);
void menu_change_auto_conflict_check (GtkAction *action);
void menu_change_board_size (GtkAction *action, GtkRadioAction *current);
void menu_change_number_of_players (GtkAction *action, GtkRadioAction *current);
void menu_change_time_game (GtkAction *action);
gboolean export_as_png(GtkWidget *widget);
gboolean open_saved_game(GtkWidget *widget);
gboolean save_game(GtkWidget *widget);
gboolean selection_handle_text_entry(GtkWidget *text_entry,  GdkEventKey *event, gpointer data);
gboolean select_game(GtkWidget *widget);
gboolean delete_event( GtkWidget *widget, GdkEvent  *event, gpointer   data );
gboolean destroy_given_widget(GtkWidget *widget, GdkEvent  *event, gpointer   data);
gboolean expose_event( GtkWidget *widget, GdkEventExpose *event );
gboolean goto_editor(GtkWidget *widget);
gboolean solve(GtkWidget *widget);
gboolean check_conflicts(GtkWidget *widget);
gpointer solver_thread2(gpointer data);
gboolean play(GtkWidget *widget);
gboolean check_the_solution(GtkWidget *widget);
gboolean one_player_game(GtkWidget *widget);
gboolean two_player_game(GtkWidget *widget);
gboolean new_random_game(GtkWidget *widget);


//In settings.c
char* number_to_string(short value);
int string_to_number(char str[12]);
gboolean settings_dialog(GtkWidget *widget);
gboolean delete_settings_dialog( GtkWidget *widget, GdkEvent  *event, gpointer   data );
gboolean help_button_clicked (GtkWidget *widget,gpointer data);
gboolean default_button_clicked (GtkWidget *widget,gpointer data);
gboolean revert_button_clicked (GtkWidget *widget,gpointer data);
GtkListStore *create_liststore(void);
GtkWidget* create_view_and_model(void);
void change_gcheckbox(GtkWidget *widget, gpointer data);
void change_gradio(GtkWidget *widget, gpointer data);
gboolean gtext_boxes_key(GtkWidget *text_entry,  GdkEventKey *event, gpointer data);
gboolean gtext_boxes_focus_out(GtkWidget *text_entry, GdkEventFocus *event,gpointer data);
void settings_stuff_game(GtkWidget *game_widget);
void choose_notebook_tab  (GtkTreeView *treeview,  gpointer user_data);
void change_font(GtkFontButton *font_button, gpointer data);
void settings_stuff_font(GtkWidget *font_widget);
void change_color(GtkColorButton *color_button, gpointer data);
void settings_stuff_color(GtkWidget *color_widget);
gboolean key_change_size(GtkWidget *text_entry,  GdkEventKey *event, gpointer data);
gboolean change_size(GtkWidget *text_entry, GdkEventFocus *event,gpointer data);
void settings_stuff_size(GtkWidget *size_widget);
gboolean key_change_threshold(GtkWidget *text_entry,  GdkEventKey *event, gpointer data);
gboolean change_threshold(GtkWidget *text_entry, GdkEventFocus *event,gpointer data);
void check_button_generator (GtkWidget *widget, gpointer data);
void settings_stuff_generator(GtkWidget *generator_widget);
void check_button_solver (GtkWidget *widget, gpointer data);
void settings_stuff_solver(GtkWidget *solver_widget);
void change_pcheckbox(GtkWidget *widget, gpointer data);
void change_psticky(GtkWidget *widget, gpointer data);
void change_ptbar(GtkWidget *widget, gpointer data);
void settings_stuff_preference(GtkWidget *preference_widget);


//In other.c
void puzzle_flag_init(short mode);
void start_puzzle_using_settings();
void load_the_puzzle(char str[PATH_MAX]);
void update_gsudoku_window_label_with_new_puzzle_number();
void status_bar_update_tp_whoes_turn();
void update_status_bar_num_of_occupied_box();
void save_settings_to_file();
void delete_all_undo();
void create_new_undo();
void do_undo();
void do_redo();
void check_and_remove_and_display_pencil_in(short  i,short j,short value);
void remove_all_pencilin();
void create_and_draw_all_pencilin();
void initialize_board();
void exit_game();
void check_conflicts_for_selected_pbox(short row,short column);
void check_all_conflicts();
void switch_on_the_timer();
gboolean timer_on_function(gpointer data);

//In generator_solver.c

gboolean puzzle_generator_timer(gpointer data);
gboolean puzzle_solver_timer(gpointer data);
void popup_dialog_solver();
gpointer solver_thread(gpointer data);
void popup_dialog_generator();
gpointer generator_thread(gpointer data);
void generator(guint32 puzzle_number,short guess_threshold,gboolean symmetric);
void solver(short mode);
gboolean check_if_fits(short puzzle_box_value[][number_of_picks/2],short i,short j,short k);
gboolean check_for_candidate_available_once_in_row_column_or_box(short possibles[][number_of_picks/2][number_of_picks/2+1]);
gboolean check_for_candidates_contained_in_row_or_column_of_a_box(short possibles[][number_of_picks/2][number_of_picks/2+1]);
gboolean check_for_row_column_number_contain_in_single_box(short possibles[][number_of_picks/2][number_of_picks/2+1]);
gboolean check_for_doublets_triplets_etc(short possibles[][number_of_picks/2][number_of_picks/2+1]);
gboolean check_for_advanced_doublets_triplets_etc(short possibles[][number_of_picks/2][number_of_picks/2+1]);
gboolean check_block_block_interaction(short possibles[][number_of_picks/2][number_of_picks/2+1]);
gboolean check_xwing_and_swordfish(short possibles[][number_of_picks/2][number_of_picks/2+1],short mode);
gboolean check_and_remove_number_from_possibles(short 
possibles[][number_of_picks/2][number_of_picks/2+1],short  i,short j,short value);

void back_up_possibles_and_puzzles(
short possibles[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short possibles_bck_up[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short puzzle_box_bck_up[number_of_picks/2][number_of_picks/2],
short puzzle_box_type_bck_up[number_of_picks/2][number_of_picks/2]);
void restore_possibles_and_puzzles(
short possibles[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short possibles_bck_up[number_of_picks/2][number_of_picks/2][number_of_picks/2+1],
short puzzle_box_bck_up[number_of_picks/2][number_of_picks/2],
short puzzle_box_type_bck_up[number_of_picks/2][number_of_picks/2]);
void print_possibles(short possibles[][number_of_picks/2][number_of_picks/2+1]);
short convert_doubt_to_confirmed_text_if_necessery(short value);




//In help_about.c
gboolean about_yzonesoft(GtkWidget *widget);
gboolean about_gsudoku(GtkWidget *widget);
void gsudoku_stuff_about(GtkWidget *about_widget);
void gsudoku_stuff_author(GtkWidget *author_widget);
void gsudoku_stuff_contributors(GtkWidget *contributors_widget);
void gsudoku_stuff_thanks(GtkWidget *thanks_widget);
void gsudoku_stuff_license(GtkWidget *license_widget);
void gsudoku_stuff_puzzle_license(GtkWidget *license_widget);
void open_browser(const gchar *path1);
gboolean open_help_content(void);
