/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"




static GtkActionEntry entries[] = {
  { "FileMenu", NULL, "_File" },               /* name, stock id, label */
  { "EditMenu", NULL, "_Edit" },               /* name, stock id, label */
  { "Helpers", NULL, "Hel_pers" },               /* name, stock id, label */
  { "SettingsMenu", NULL, "_Settings" }, /* name, stock id, label */
  { "PuzzleSizeMenu", NULL, "_Puzzle Size"  },            /* name, stock id, label */
  { "NumberOfPlayersMenu", NULL, "_Number of Players" },             /* name, stock id, label */
  { "DifficultyMenu", NULL, "_Difficulty" },               /* name, stock id, label */
  { "ControlMenu", NULL, "_Control" },               /* name, stock id, label */
  { "FirstPlayerMenu", NULL, "_First Player" },               /* name, stock id, label */
  { "SecondPlayerMenu", NULL, "_Second Player" },               /* name, stock id, label */
  { "HelpMenu", NULL, "_Help" },               /* name, stock id, label */
  
   
  
  { "OnePlayerGame", NULL,                      /* name, stock id */
    "One Player Game", NULL,                      /* label, accelerator */
    "one player game",                       /* tooltip */ 
    G_CALLBACK (one_player_game) },      
  { "TwoPlayerGame", NULL,                    /* name, stock id */
    "Two Player Game",NULL,                      /* label, accelerator */     
    "two player game",                             /* tooltip */
    G_CALLBACK (two_player_game) }, 
  { "NewGame", GTK_STOCK_NEW,                    /* name, stock id */
    "_New Game","<control>N",                      /* label, accelerator */     
    "new random game",                       /* tooltip */
    G_CALLBACK (new_random_game) },
  { "SelectGame", GTK_STOCK_INDEX,                  /* name, stock id */
    "S_elect Game", "F2",                       /* label, accelerator */     
    "Select game",                          /* tooltip */
    G_CALLBACK (select_game) },
  { "OpenGame", GTK_STOCK_OPEN,                  /* name, stock id */
    "_Open Game","<control>O",                       /* label, accelerator */     
    "Open Sudoku",                          /* tooltip */
    G_CALLBACK (open_saved_game) },
  { "SaveGame", GTK_STOCK_SAVE,                  /* name, stock id */
    "_Save Game", "<control>S",                       /* label, accelerator */     
    "Save Sudoku",                          /* tooltip */
    G_CALLBACK (save_game) },
  
  { "CreatePuzzle", GTK_STOCK_EXECUTE,                  /* name, stock id */
    "_Create Puzzle", "F3",                       /* label, accelerator */     
    "Create new puzzle",                          /* tooltip */
    G_CALLBACK (goto_editor) },
  { "PlayCreatedPuzzle", GTK_STOCK_YES,                  /* name, stock id */
    "_Play Created Puzzle", "F4",                       /* label, accelerator */     
    "Play Created Puzzle",                          /* tooltip */
     G_CALLBACK (play) },
  { "ExportAsPNG", NULL,                  /* name, stock id */
    "E_xport as PNG", NULL,                       /* label, accelerator */     
    "Save game as png",                          /* tooltip */
    G_CALLBACK (export_as_png) },
  { "Quit", GTK_STOCK_QUIT,                    /* name, stock id */
    "_Quit", "<control>Q",                     /* label, accelerator */     
    "Quit",                                    /* tooltip */
    G_CALLBACK (exit_game) },
  { "Undo", GTK_STOCK_UNDO,                             /* name, stock id */
    "_Undo", "<control>Z",                    /* label, accelerator */     
    "undo",                                   /* tooltip */  
    G_CALLBACK (do_undo) },
  { "Redo", GTK_STOCK_REDO,                             /* name, stock id */
    "_Redo", "<control><shift>Z",                    /* label, accelerator */     
    "redo",                                   /* tooltip */  
    G_CALLBACK (do_redo) },
  
 
  { "CheckForConflicts", NULL,                             /* name, stock id */
    "_Check for conflicts", "F6",                    /* label, accelerator */     
    "check for conflicts",                                   /* tooltip */  
    G_CALLBACK (check_all_conflicts) },
  
  { "CheckTheSolution", "ICON_CHECK_SOLUTION16",                             /* name, stock id */
    "C_heck the solution", "F7",                    /* label, accelerator */     
    "check the solution",                                   /* tooltip */  
    G_CALLBACK (check_the_solution) },
  
  { "SolveThePuzzle", "ICON_SOLVER16",                             /* name, stock id */
    "_Solve the puzzle", "F8",                    /* label, accelerator */     
    "solve the puzzle",                                   /* tooltip */  
    G_CALLBACK (solve) },

 { "FillPencilIn", NULL,                             /* name, stock id */
    "_Fill pencil in", "<control>F",                    /* label, accelerator */     
    "fill pencil in for all cells",                                   /* tooltip */  
    G_CALLBACK (create_and_draw_all_pencilin) },
 
 { "RemovePencilIn", NULL,                             /* name, stock id */
    "_Remove pencil in", "<control>R",                    /* label, accelerator */     
    "remove pencil in for all cells",                                   /* tooltip */  
    G_CALLBACK (remove_all_pencilin) },
      
  
  
  { "Settings", GTK_STOCK_PREFERENCES,                             /* name, stock id */
    "_Settings", "F5",                    /* label, accelerator */     
    "edit settings and prefernce",                                   /* tooltip */  
    G_CALLBACK (settings_dialog) },
  
  { "HelpOnGsudoku", GTK_STOCK_HELP,                             /* name, stock id */
    "_Help on Gsudoku", "F1",                    /* label, accelerator */     
    "Help on Gsudoku",                                   /* tooltip */  
    G_CALLBACK (open_help_content) },
  { "AboutGsudoku", NULL,                             /* name, stock id */
    "_About Gsudoku", NULL,                    /* label, accelerator */     
    "About Gsudoku",                                   /* tooltip */  
    G_CALLBACK (about_gsudoku) },
  { "AboutYzoneSoftware", NULL,                             /* name, stock id */
    "A_bout Yzone Software", NULL,                    /* label, accelerator */     
    "About Yzone Software",                                   /* tooltip */  
    G_CALLBACK (about_yzonesoft) },

  { "New", GTK_STOCK_NEW,                    /* name, stock id */
    "New",NULL,                      /* label, accelerator */     
    "new random puzzle",                       /* tooltip */
    G_CALLBACK (new_random_game) },
  { "Open", GTK_STOCK_OPEN,                  /* name, stock id */
    "Open", NULL,                       /* label, accelerator */     
    "Open Sudoku",                          /* tooltip */
    G_CALLBACK (open_saved_game) },
  { "Save", GTK_STOCK_SAVE,                  /* name, stock id */
    "Save", NULL,                       /* label, accelerator */     
    "Save Sudoku",                          /* tooltip */
    G_CALLBACK (save_game) },
  { "Help", GTK_STOCK_HELP,                             /* name, stock id */
    "Help", NULL,                    /* label, accelerator */     
    "Help on G-Sudoku",                                   /* tooltip */  
    G_CALLBACK (open_help_content) },
    
  { "Done", "ICON_CHECK_SOLUTION",                             /* name, stock id */
    "Done", NULL,                    /* label, accelerator */     
    "check the solution",                                   /* tooltip */  
    G_CALLBACK (check_the_solution) },
  
  { "Solve", "ICON_SOLVER",                             /* name, stock id */
    "Solve", NULL,                    /* label, accelerator */     
    "solve the puzzle",                                   /* tooltip */  
    G_CALLBACK (solve) },

};
static guint n_entries = G_N_ELEMENTS (entries);

static GtkToggleActionEntry toggle_entries[] = {
  { "AutoCheckConflicts", NULL,                    /* name, stock id */
     "Auto Check Conflicts", NULL,                    /* label, accelerator */     
    "automatically check conflicts on value enter",                                    /* tooltip */
    G_CALLBACK (menu_change_auto_conflict_check), 
    TRUE },                                    /* is_active */
  
  { "AutoRemovePencilin", NULL,                    /* name, stock id */
     "Auto remove pencil in", NULL,                    /* label, accelerator */     
    "automatically remove pencil in",                                    /* tooltip */
    G_CALLBACK (menu_change_auto_pencil_in), 
    TRUE },                                    /* is_active */
  
  { "TimeGame", GTK_STOCK_BOLD,                    /* name, stock id */
     "_Time game", NULL,                    /* label, accelerator */     
    "Time game",                                    /* tooltip */
    G_CALLBACK (menu_change_time_game), 
    TRUE },                                    /* is_active */
};
static guint n_toggle_entries = G_N_ELEMENTS (toggle_entries);


enum {
  PUZZLE_SIZE_THREE,
  PUZZLE_SIZE_FOUR,
};


static GtkRadioActionEntry puzzle_size_entries[] = {
  { "three", NULL,                               /* name, stock id */
    "_3x3", NULL,                      /* label, accelerator */     
    "3x3", PUZZLE_SIZE_THREE },                      /* tooltip, value */
  { "four", NULL,                             /* name, stock id */
    "_4x4", NULL,                    /* label, accelerator */     
    "4x4", PUZZLE_SIZE_FOUR },                    /* tooltip, value */
  };
static guint n_puzzle_size_entries = G_N_ELEMENTS (puzzle_size_entries);


enum {
  NUMBER_OF_PLAYERS_ONE,
  NUMBER_OF_PLAYERS_TWO,
};


static GtkRadioActionEntry number_of_players_entries[] = {
  { "one", NULL,                               /* name, stock id */
    "_One", NULL,                      /* label, accelerator */     
    "single player game", NUMBER_OF_PLAYERS_ONE },                      /* tooltip, value */
  { "two", NULL,                             /* name, stock id */
    "_Two", NULL,                    /* label, accelerator */     
    "Two player game", NUMBER_OF_PLAYERS_TWO },                    /* tooltip, value */
  };
static guint n_number_of_players_entries = G_N_ELEMENTS (number_of_players_entries);




static const gchar *ui_info = 
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='FileMenu'>"
"      <menuitem action='OnePlayerGame'/>"
"      <menuitem action='TwoPlayerGame'/>"
"      <separator/>"
"      <menuitem action='NewGame'/>"
"      <menuitem action='SelectGame'/>"
"      <separator/>"
"      <menuitem action='OpenGame'/>"
"      <menuitem action='SaveGame'/>"
"      <separator/>"
"      <separator/>"
"      <menuitem action='CreatePuzzle'/>"
"      <menuitem action='PlayCreatedPuzzle'/>"
"      <separator/>"
"      <menuitem action='ExportAsPNG'/>"
"      <separator/>"
"      <menuitem action='Quit'/>"
"    </menu>"

"    <menu action='EditMenu'>"
"	<menuitem action='Undo'/>"
"	<menuitem action='Redo'/>"
"    </menu>"
"    <menu action='Helpers'>"
"       <menuitem action='CheckForConflicts'/>"
"       <menuitem action='CheckTheSolution'/>"
"	<menuitem action='SolveThePuzzle'/>"
"       <menuitem action='FillPencilIn'/>"
"       <menuitem action='RemovePencilIn'/>"
"	<menuitem action='AutoRemovePencilin'/>"
"       <menuitem action='AutoCheckConflicts'/>"
"    </menu>"

"    <menu action='SettingsMenu'>"
"     <menu action='PuzzleSizeMenu'>"
"      <menuitem action='three'/>"
"      <menuitem action='four'/>"
"     </menu>"
"     <menu action='NumberOfPlayersMenu'>"
"      <menuitem action='one'/>"
"      <menuitem action='two'/>"
"     </menu>"
"     <menuitem action='TimeGame'/>"
"     <separator/>"
"     <menuitem action='Settings'/>"
"    </menu>"
"    <menu action='HelpMenu'>"
"     <menuitem action='HelpOnGsudoku'/>"
"     <separator/>"
"     <menuitem action='AboutGsudoku'/>"
"     <menuitem action='AboutYzoneSoftware'/>"
"    </menu>"
"  </menubar>"

"  <toolbar  name='ToolBar'>"
"    <toolitem action='New'/>"
"     <separator/>"
"    <toolitem action='Open'/>"
"    <toolitem action='Save'/>"
"     <separator/>"
"    <toolitem action='Undo'/>"
"    <toolitem action='Redo'/>"
"     <separator/>"
"    <toolitem action='Solve'/>"
"    <toolitem action='Done'/>"
"      <separator/>"
"    <toolitem action='Help'/>"
"  </toolbar>"
"</ui>";



void do_ui_manager (GtkWidget *box1,GtkWidget *window)
{
 
//      GtkWidget *box1;
      GtkUIManager *ui;
      GError *error = NULL;
      GtkIconFactory *icon_factory;
      GtkIconSet *icon_set;
      GdkPixbuf *pixbuf;
//      GError *error=NULL;
      

      icon_factory=gtk_icon_factory_new();
      pixbuf=gdk_pixbuf_new_from_file("icons/tsolver.png",&error);
      icon_set=gtk_icon_set_new_from_pixbuf (pixbuf);
      gtk_icon_factory_add(icon_factory, (const char*)"ICON_SOLVER", icon_set);
      
      pixbuf=gdk_pixbuf_new_from_file("icons/tcheck_solution.png",&error);
      icon_set=gtk_icon_set_new_from_pixbuf (pixbuf);
      gtk_icon_factory_add(icon_factory, (const char*)"ICON_CHECK_SOLUTION", icon_set);
      
      pixbuf=gdk_pixbuf_new_from_file("icons/tsolver16.png",&error);
      icon_set=gtk_icon_set_new_from_pixbuf (pixbuf);
      gtk_icon_factory_add(icon_factory, (const char*)"ICON_SOLVER16", icon_set);
      
      pixbuf=gdk_pixbuf_new_from_file("icons/tcheck_solution16.png",&error);
      icon_set=gtk_icon_set_new_from_pixbuf (pixbuf);
      gtk_icon_factory_add(icon_factory, (const char*)"ICON_CHECK_SOLUTION16", icon_set);
      
      gtk_icon_factory_add_default(icon_factory);
      
      actions = gtk_action_group_new ("Actions");
      gtk_action_group_add_actions (actions, entries, n_entries, NULL);
      gtk_action_group_add_toggle_actions (actions, 
					   toggle_entries, n_toggle_entries, 
					   NULL);
      gtk_action_group_add_radio_actions (actions, 
					  puzzle_size_entries, n_puzzle_size_entries, 
					  PUZZLE_SIZE_THREE,
					  G_CALLBACK (menu_change_board_size), 
					  NULL);
      gtk_action_group_add_radio_actions (actions, 
					  number_of_players_entries, n_number_of_players_entries, 
					  NUMBER_OF_PLAYERS_ONE,
					  G_CALLBACK (menu_change_number_of_players), 
					  NULL);
      
      ui = gtk_ui_manager_new ();
      gtk_ui_manager_insert_action_group (ui, actions, 0);
      gtk_window_add_accel_group (GTK_WINDOW (window), 
				  gtk_ui_manager_get_accel_group (ui));
//      gtk_window_set_title (GTK_WINDOW (window), "UI Manager");
//      gtk_container_set_border_width (GTK_CONTAINER (window), 0);
      
      if (!gtk_ui_manager_add_ui_from_string (ui, ui_info, -1, &error))
	{
	  g_message ("building menus failed: %s", error->message);
	  g_error_free (error);
	}

	
      gtk_box_pack_start (GTK_BOX (box1),
			  gtk_ui_manager_get_widget (ui, "/MenuBar"),
			  FALSE, FALSE, 0);

      toolbar=gtk_ui_manager_get_widget (ui, "/ToolBar");
      gtk_box_pack_start (GTK_BOX (box1),
			  toolbar,
			  FALSE, FALSE, 0);
      
      if(toolbar_mode==1)
       gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_ICONS);
      else if(toolbar_mode==2) 
       gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_TEXT);
      else if(toolbar_mode==3) 
       gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_BOTH);
        
      if(global.auto_pencil_in_remove==TRUE)
        gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoRemovePencilin")),TRUE);
      else
        gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoRemovePencilin")),FALSE);

      if(global.check_for_conflictF==TRUE)
        gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoCheckConflicts")),TRUE);
      else
        gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoCheckConflicts")),FALSE);
       
       if(board_size_original==3)
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"three")), TRUE);
       else
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"four")), TRUE);
 
       if(global.two_player_gameF==TRUE)
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"two")), TRUE);
       else
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"one")), TRUE);
 
       if(global.two_player_gameF==TRUE)
       {
         if(global.two_player_time_game==TRUE)
           gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
	 else
           gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
       }
       else
       {
         if(global.time_race==TRUE)
           gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
	 else
           gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
       }



}
