/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"
#include <stdio.h>



/*
void puzzle_flag_init(short mode)
void start_puzzle_using_settings()
void load_the_puzzle(char str[PATH_MAX])
void update_gsudoku_window_label_with_new_puzzle_number()
void status_bar_update_tp_whoes_turn()
void update_status_bar_num_of_occupied_box()
void save_settings_to_file()
void delete_all_undo()
void create_new_undo()
void do_undo()
void do_redo()
void check_and_remove_and_display_pencil_in(short  i,short j,short value)
void remove_all_pencilin()
void create_and_draw_all_pencilin()
void initialize_board()
void exit_game()
void check_conflicts_for_selected_pbox(short row,short column)
void check_all_conflicts()
void switch_on_the_timer()
gboolean timer_on_function(gpointer data)


*/

//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88puzzle_flag_init8888888888888888888888888888888888888888888888888888888888888888888888888

void puzzle_flag_init(short mode)
{
  
  if(mode!=FLAGS_FOR_EDITOR)
  board_size=board_size_original;

  if(global.two_player_gameF==TRUE)
    global.two_player_game=TRUE;
  else
    global.two_player_game=FALSE; 

  global.disable_mouse=FALSE;
  global.disable_keyboard=FALSE;

  global.edit_modeF=FALSE;
  global.keyboard_presentF=FALSE; 
   
  strcpy(sec_copy.player1_name,global.player1_name);
  strcpy(sec_copy.player1_ini,global.player1_ini);
  strcpy(sec_copy.player2_name,global.player2_name);
  strcpy(sec_copy.player2_ini,global.player2_ini);
        
  if(tag_id!=0)
  {
    g_source_remove(tag_id);
    tag_id=0;
  }

  if(mode==FLAGS_FOR_GOTO_EDITOR)
   global.edit_modeF=TRUE; 

  if(mode==FLAGS_FOR_EDITOR)
    global.custom_puzzle=TRUE;
   
  if(mode==FLAGS_FOR_OTHERS)
    global.custom_puzzle=FALSE;

  if(mode==FLAGS_FOR_ONE_PLAYER_GAME)
    global.two_player_game=FALSE;

  if(mode==FLAGS_FOR_TWO_PLAYER_GAME)
    global.two_player_game=TRUE;
  
  
    
     
}     

//88puzzle_flag_init8888888888888888888888888888888888888888888888888888888888888888888888888
//88start_puzzle_using_settings88888888888888888888888888888888888888888888888888888888888888

void start_puzzle_using_settings()
{
     
     draw_puzzle();

     gdk_draw_pixmap(drawing_area->window,
                     drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                     pixmap,
                     0, 0, 0, 0,
                     drawing_area_w,drawing_area_h);
  
     update_status_bar_num_of_occupied_box();

     if(global.two_player_game==TRUE)
     {
        global.p1_points=0;
        global.p2_points=0;
   
        draw_score(0,global.p1_points);
        draw_score(1,global.p2_points);

        timing.wait_time= global.wait_time;
        timing.tp_total_time=global.tp_total_time;
        timing.tp_1_time=global.tp_1_time;
        timing.tp_2_time=global.tp_2_time;
     
	
        if(global.two_player_time_game==FALSE)
        {
           grand=g_rand_new();
           global.whose_turn= g_rand_int(grand)%2;

           if(global.whose_turn==1)
           {  
              global.disable_mouse=TRUE;
              global.disable_keyboard=FALSE;
           }  
           else
           {  
              global.disable_mouse=FALSE;
              global.disable_keyboard=TRUE;
           }  
	   
	       status_bar_update_tp_whoes_turn(); 
        }
        else
        {
           global.disable_mouse=TRUE;
           global.disable_keyboard=TRUE;
//           gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  "); 
           if(timing.wait_time==0)
             timing.wait_time=1;

    	}
     
     }  
     else
     {
        timing.tp_total_time=global.racing_time;
 
     }
   
     global.two_player_time_game_dupe=global.two_player_time_game;
     
     
     if((global.two_player_game==TRUE && global.two_player_time_game==TRUE) || (global.two_player_game==FALSE && global.time_race==TRUE) )  
       switch_on_the_timer();
 
 
  delete_all_undo();
  
  if(global.two_player_game==FALSE)
    create_new_undo();
     

}

//88start_puzzle_using_settings88888888888888888888888888888888888888888888888888888888888888
//88load_the_puzzle88888888888888888888888888888888888888888888888888888888888888888888888888

void load_the_puzzle(char str[PATH_MAX])
{
  FILE *fp; 
  short i,j,k;
  short len;
  char *s;
  char filename[PATH_MAX];
  char temp[PATH_MAX];
    
  struct variables
  {
   short number_of_picks;//18 or 32
   short board_size; //3 or 4
   short pencil_in[16][16][17];
   short p1_points;
   short p2_points;
   unsigned long puzzle_number;
   short number_of_free_boxes;
   struct pick pick[32];
   struct puzzle_box puzzle_box[16][16];
   struct timing timing;
   char player1_name[100];
   char player1_ini[5];
   char player2_name[100];
   char player2_ini[5];
   unsigned two_player_unlimited_total_time :1;
   unsigned two_player_time_game :1;
   unsigned two_player_game :1;
   unsigned time_race :1;
   unsigned whose_turn :1;
   unsigned disable_mouse :1;
   unsigned disable_keyboard :1;
   unsigned custom_puzzle :1;
   unsigned edit_modeF:1;   
  }variable1;

  
    strcpy(temp,str);
    len=strlen(temp);
       
    for(i=0;i<len;i++)
    {
      if(temp[i]=='\\')
        temp[i]='/';                  
    
    }                  

    
    for(i=len-1;i>=0;i--)
    {
      if(temp[i]=='/')
	break;
    
    }                  

    for(j=i+1;j<len;j++)
     filename[j-(i+1)]=temp[j];
    
    filename[j-(i+1)]='\0';  
    temp[i]='\0';
    
    chdir(temp);
  
    
    fp=fopen(filename,"rb");
    fread(&variable1, sizeof(variable1),1,fp);
    fclose(fp);
    number_of_picks=variable1.number_of_picks;
    board_size=variable1.board_size;
    timing=variable1.timing;
    if(timing.wait_time==0)
      timing.wait_time=1;

    
    global.puzzle_number=variable1.puzzle_number;
    global.number_of_free_boxes=variable1.number_of_free_boxes;
    global.custom_puzzle=variable1.custom_puzzle;
    global.edit_modeF=variable1.edit_modeF;
    
    global.two_player_unlimited_total_time=variable1.two_player_unlimited_total_time;
    global.two_player_time_game=variable1.two_player_time_game;
    global.two_player_game=variable1.two_player_game;
    global.time_race=variable1.time_race;
    global.whose_turn=variable1.whose_turn;
    global.disable_mouse=variable1.disable_mouse;
    global.disable_keyboard=variable1.disable_keyboard;
    
    global.p1_points=variable1.p1_points;
    global.p2_points=variable1.p2_points;
    
    strcpy(sec_copy.player1_name,variable1.player1_name);
    strcpy(sec_copy.player1_ini,variable1.player1_ini);
    strcpy(sec_copy.player2_name,variable1.player2_name);
    strcpy(sec_copy.player2_ini,variable1.player2_ini);

    
    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
      for(k=0;k<number_of_picks/2+1;k++)
        pencil_in[i][j][k]=variable1.pencil_in[i][j][k];
    }
    }
    
    for(i=0;i<number_of_picks/2;i++)
      pick[i]=variable1.pick[i];
    
    for(i=0;i<number_of_picks/2;i++)
    {
      for(j=0;j<number_of_picks/2;j++)
       puzzle_box[i][j]=variable1.puzzle_box[i][j];
    }

  
  
  
  initialize_board();
  draw_puzzle();

  if(global.edit_modeF==TRUE)
    gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  Editor mode");
  else
    gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  ");
  
  if(global.two_player_game==TRUE)
    status_bar_update_tp_whoes_turn();

  update_status_bar_num_of_occupied_box();
  if(global.edit_modeF==FALSE)
  {
    if(global.custom_puzzle==TRUE)
      gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku #custom");
    else
      update_gsudoku_window_label_with_new_puzzle_number();
  }
  else
    gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku");

  global.two_player_time_game_dupe=global.two_player_time_game;
  
  if((global.two_player_game==TRUE && global.two_player_time_game==TRUE) || (global.two_player_game==FALSE && global.time_race==TRUE) )  
   switch_on_the_timer();
 
  delete_all_undo();

  
  chdir(path);

}

//88load_the_puzzle88888888888888888888888888888888888888888888888888888888888888888888888888    
//88update_gsudoku_window_label_with_new_puzzle_number888888888888888888888888888888888888888

void update_gsudoku_window_label_with_new_puzzle_number()
{

  char str[80];
  unsigned long tmp_val;
  short len,i;
  
  strcpy(str,"G-Sudoku  #");  

  tmp_val=global.puzzle_number;
  len=0;
  while(tmp_val>0)
  {
    tmp_val=tmp_val/10;
    len=len+1;
  }
//  g_print("\ntmp value: %lu\n",tmp_val);
  tmp_val=global.puzzle_number;
//  g_print("tmp value: %lu\n",tmp_val);
  for(i=11+len-1;i>=11;i--)
  {
    str[i]=48+tmp_val%10;  
    tmp_val=tmp_val/10;
  }
  str[11+len]='\0';
  gtk_window_set_title (GTK_WINDOW (gs_main_window), str);

}

//88update_gsudoku_window_label_with_new_puzzle_number888888888888888888888888888888888888888
//88status_bar_update_tp_whoes_turn8888888888888888888888888888888888888888888888888888888888

void status_bar_update_tp_whoes_turn()
{

  char str[150];
  strcpy(str,"  ");  
  if(global.disable_mouse==FALSE)
    strcat(str,sec_copy.player1_name);
   else
    strcat(str,sec_copy.player2_name);  

  strcat(str,", its your turn");  
  
  gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) str); 

}

//88status_bar_update_tp_whoes_turn8888888888888888888888888888888888888888888888888888888888
//88update_status_bar_num_of_occupied_box8888888888888888888888888888888888888888888888888888

void update_status_bar_num_of_occupied_box()
{
  char str[24];
  short i;
  short value;
  short num;
  short len;  
  short offset;
  
  value=((number_of_picks/2)*(number_of_picks/2))-global.number_of_free_boxes;
  strcpy(str,"  occupied cell: ");
  offset=strlen(str);
  num=value;
  if(num==0)
  {
    str[offset]='0';
    len=1;
  }
  else
  {
    len=0;
    while(num>0)
    {
      num=num/10;
      len=len+1;
    }
  
    num=value;
    for(i=len+offset-1;i>=offset;i--)
    {
      str[i]=48+num%10;  
      num=num/10;
    }
  }
  str[len+offset]=' ';
  str[len+offset+1]=' ';
  str[len+offset+2]='\0';
  
  gtk_label_set_text(GTK_LABEL(status_bar_label_2),(const char*) str);

}

//88update_status_bar_num_of_occupied_box8888888888888888888888888888888888888888888888888888
//88save_settings_to_file88888888888888888888888888888888888888888888888888888888888888888888

void save_settings_to_file()
{

  FILE *fp;
  char ch[255];
  int value;
  fp=fopen("settings","w");
   
  strcpy(ch,"Note: Take a backup before you edit\n\n");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"[game]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"board_size");
  value=board_size_original;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"time_race");
  value=global.time_race;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"two_player_solve");
  value=global.two_player_solveF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"total_time");
  value=global.racing_time;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"two_player_game");
  value=global.two_player_gameF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"Player1_name");
  fprintf(fp,"%s:  %s\n",ch,global.player1_name);
  strcpy(ch,"player1_initial");
  fprintf(fp,"%s:  %s\n",ch,global.player1_ini);
  strcpy(ch,"player2_name");
  fprintf(fp,"%s:  %s\n",ch,global.player2_name);
  strcpy(ch,"player2_initial");
  fprintf(fp,"%s:  %s\n",ch,global.player2_ini);
  strcpy(ch,"time_game");
  value=global.two_player_time_game;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"minus_point");
  value=global.minus_points;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"player1_time");
  value=global.tp_1_time;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"player2_time");
  value=global.tp_2_time;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"wait_time");
  value=global.wait_time;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"total_time");
  value=global.tp_total_time;
  fprintf(fp,"%s:  %d\n",ch,value);
  fprintf(fp,"\n\n");
   
   
  strcpy(ch,"[font]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"pick_box_font");
  fprintf(fp,"%s:  %s\n",ch,pick_box_font);
  strcpy(ch,"puzzle_box_font");
  fprintf(fp,"%s:  %s\n",ch,puzzle_box_font);
  strcpy(ch,"pencil_in_font");
  fprintf(fp,"%s:  %s\n",ch,pencil_in_font);
  strcpy(ch,"status_text");
  fprintf(fp,"%s:  %s\n",ch,status_text);
  strcpy(ch,"score_text");
  fprintf(fp,"%s:  %s\n",ch,score_text);
  fprintf(fp,"\n\n");
  
  
  strcpy(ch,"[size]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"pick_square_size");
  fprintf(fp,"%s:  %d\n",ch,pick_square_size);
  strcpy(ch,"puzzle_box_square_size");
  fprintf(fp,"%s:  %d\n",ch,puzzle_box_square_size);
  fprintf(fp,"\n\n");
  
  
  strcpy(ch,"[color]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"highlight_border_red");
  fprintf(fp,"%s:  %d\n",ch,color.hl_dark.red);
  strcpy(ch,"highlight_border_green");
  fprintf(fp,"%s:  %d\n",ch,color.hl_dark.green);
  strcpy(ch,"highlight_border_blue");
  fprintf(fp,"%s:  %d\n",ch, color.hl_dark.blue);
  strcpy(ch,"highlight_bg_red");
  fprintf(fp,"%s:  %d\n",ch,color.hl_light.red);
  strcpy(ch,"highlight_bg_green");
  fprintf(fp,"%s:  %d\n",ch,color.hl_light.green);
  strcpy(ch,"highlight_bg_blue");
  fprintf(fp,"%s:  %d\n",ch,color.hl_light.blue);
  strcpy(ch,"pick_selected_bg_red");
  fprintf(fp,"%s:  %d\n",ch,color.pick_selected_bg.red);
  strcpy(ch,"pick_selected_bg_green");
  fprintf(fp,"%s:  %d\n",ch,color.pick_selected_bg.green);
  strcpy(ch,"pick_selected_bg_blue");
  fprintf(fp,"%s:  %d\n",ch,color.pick_selected_bg.blue);
  strcpy(ch,"pick_selected_border_red");
  fprintf(fp,"%s:  %d\n",ch,color.pick_selected.red);
  strcpy(ch,"pick_selected_border_green");
  fprintf(fp,"%s:  %d\n",ch,color.pick_selected.green);
  strcpy(ch,"pick_selected_border_blue");
  fprintf(fp,"%s:  %d\n",ch,color.pick_selected.blue);
  strcpy(ch,"confirm_text_red");
  fprintf(fp,"%s:  %d\n",ch,color.conf_text.red);
  strcpy(ch,"confirm_text_green");
  fprintf(fp,"%s:  %d\n",ch,color.conf_text.green);
  strcpy(ch,"confirm_text_blue");
  fprintf(fp,"%s:  %d\n",ch,color.conf_text.blue);
  strcpy(ch,"doubt_text_red");
  fprintf(fp,"%s:  %d\n",ch,color.doubt_text.red);
  strcpy(ch,"doubt_text_green");
  fprintf(fp,"%s:  %d\n",ch,color.doubt_text.green);
  strcpy(ch,"doubt_text_blue");
  fprintf(fp,"%s:  %d\n",ch,color.doubt_text.blue);
  strcpy(ch,"puzzle_lines_red");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_lines.red);
  strcpy(ch,"puzzle_lines_green");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_lines.green);
  strcpy(ch,"puzzle_lines_blue");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_lines.blue);
  strcpy(ch,"puzzle_bg_red");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_bg.red);
  strcpy(ch,"puzzle_bg_green");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_bg.green);
  strcpy(ch,"puzzle_bg_blue");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_bg.blue);
  strcpy(ch,"mouse_box_red");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_selected.red);
  strcpy(ch,"mouse_box_green");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_selected.green);
  strcpy(ch,"mouse_box_blue");
  fprintf(fp,"%s:  %d\n",ch,color.puzzle_selected.blue);
  strcpy(ch,"key_box_red");
  fprintf(fp,"%s:  %d\n",ch,color.key_box.red);
  strcpy(ch,"key_box_green");
  fprintf(fp,"%s:  %d\n",ch,color.key_box.green);
  strcpy(ch,"key_box_blue");
  fprintf(fp,"%s:  %d\n",ch,color.key_box.blue);
  strcpy(ch,"num_fixed_box_bg_red");
  fprintf(fp,"%s:  %d\n",ch,color.num_fixed_box_bg.red);
  strcpy(ch,"num_fixed_box_bg_green");
  fprintf(fp,"%s:  %d\n",ch,color.num_fixed_box_bg.green);
  strcpy(ch,"num_fixed_box_bg_blue");
  fprintf(fp,"%s:  %d\n",ch,color.num_fixed_box_bg.blue);
  strcpy(ch,"num_fixed_text_red");
  fprintf(fp,"%s:  %d\n",ch,color.num_fixed_text.red);
  strcpy(ch,"num_fixed_box_bg_green");
  fprintf(fp,"%s:  %d\n",ch,color.num_fixed_text.green);
  strcpy(ch,"num_fixed_box_bg_blue");
  fprintf(fp,"%s:  %d\n",ch,color.num_fixed_text.blue);
  strcpy(ch,"conflict_lines_red");
  fprintf(fp,"%s:  %d\n",ch,color.conflict_lines.red);
  strcpy(ch,"conflict_lines_green");
  fprintf(fp,"%s:  %d\n",ch,color.conflict_lines.green);
  strcpy(ch,"conflict_lines_blue");
  fprintf(fp,"%s:  %d\n",ch,color.conflict_lines.blue);
  strcpy(ch,"pencil_in_red");
  fprintf(fp,"%s:  %d\n",ch,color.pencil_in.red);
  strcpy(ch,"pencil_in_green");
  fprintf(fp,"%s:  %d\n",ch,color.pencil_in.green);
  strcpy(ch,"pencil_in_blue");
  fprintf(fp,"%s:  %d\n",ch,color.pencil_in.blue);
  strcpy(ch,"status_text_color_red");
  fprintf(fp,"%s:  %d\n",ch,color.status_text_color.red);
  strcpy(ch,"status_text_color_green");
  fprintf(fp,"%s:  %d\n",ch,color.status_text_color.green);
  strcpy(ch,"status_text_color_blue");
  fprintf(fp,"%s:  %d\n",ch,color.status_text_color.blue);
  strcpy(ch,"score_text_color_red");
  fprintf(fp,"%s:  %d\n",ch,color.score_text_color.red);
  strcpy(ch,"score_text_color_green");
  fprintf(fp,"%s:  %d\n",ch,color.score_text_color.green);
  strcpy(ch,"score_text_color_blue");
  fprintf(fp,"%s:  %d\n",ch,color.score_text_color.blue);
  fprintf(fp,"\n\n");
   
  
  strcpy(ch,"[generator]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"guess_threshold");
  fprintf(fp,"%s:  %d\n",ch,global.guess_threshold);
  strcpy(ch,"generate_symmetric_puzzle");
  value=global.symmetric_puzzleF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"hidden_unique_candidate");
  value=global.g_hidden_unique_candidate;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"block_interaction_with_row_and_column");
  value=global.g_block_interaction_with_row_and_column;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"row_and_column_interaction_with_block");
  value=global.g_row_and_column_interaction_with_block;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"visible_doublets_triplets_etc");
  value=global.g_visible_doublets_triplets_etc;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"block_block_interaction");
  value=global.g_block_block_interaction;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"hidden_doublets_triplets_etc");
  value=global.g_hidden_doublets_triplets_etc;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"xwing");
  value=global.g_xwing;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"swordfish");
  value=global.g_swordfish;
  fprintf(fp,"%s:  %d\n",ch,value);
  fprintf(fp,"\n\n");

  
  strcpy(ch,"[solver]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"hidden_unique_candidate");
  value=global.s_hidden_unique_candidate;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"block_interaction_with_row_and_column");
  value=global.s_block_interaction_with_row_and_column;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"row_and_column_interaction_with_block");
  value=global.s_row_and_column_interaction_with_block;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"visible_doublets_triplets_etc");
  value=global.s_visible_doublets_triplets_etc;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"block_block_interaction");
  value=global.s_block_block_interaction;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"xwing");
  value=global.s_xwing;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"hidden_doublets_triplets_etc");
  value=global.s_hidden_doublets_triplets_etc;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"swordfish");
  value=global.s_swordfish;
  fprintf(fp,"%s:  %d\n",ch,value);
  fprintf(fp,"\n\n");
   
  
  strcpy(ch,"[preference]");
  fprintf(fp,"%s\n",ch);
  strcpy(ch,"toolbar_mode");
  value=toolbar_mode;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"show_status_bar");
  value=global.show_status_barF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"show_splash_screen");
  value=global.show_splash_screenF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"show_tips_and_tricks");
  value=global.show_tips_and_tricksF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"sticky_selection_method");
  value=sticky_selection;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"keyboard_cursor_move_over_fixed_box");
  value=global.key_movement_fixed_box_no_limit;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"keyboard_cursor_border_restriction");
  value=global.key_movement_restrictive;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"draw_figures_while_computer_solving");
  value=global.show_figures_while_solving;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"show_console_messeges");
  value=global.show_console_messegesF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"check_puzzle_validity_for_created_puzzle");
  value=global.editor_check_puzzle_validity;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"automatic_remove_pencil_in");
  value=global.auto_pencil_in_remove;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"show_conflicts_while_keying");
  value=global.check_for_conflictF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"assume_doubt_text_as_confirmed_text");
  value=global.consider_doubt_text_as_confirm_textF;
  fprintf(fp,"%s:  %d\n",ch,value);
  strcpy(ch,"use_doubt_text_for_pencil_in");
  value=global.treat_doubt_as_pencil_in;
  fprintf(fp,"%s:  %d\n",ch,value);
  fprintf(fp,"\n\n");
  
  fclose(fp);


}

//88save_settings_to_file88888888888888888888888888888888888888888888888888888888888888888888
//88delete_all_undo88888888888888888888888888888888888888888888888888888888888888888888888888

void delete_all_undo()
{

  if(ur!=NULL)
  {
   
    if(ur->prev!=NULL)
      ur=ur->prev;
   
    if(ur->next!=NULL)
    {
      struct undo_redo *tmp2; 
      struct undo_redo *tmp3;     
      tmp2=ur->next;
      while(tmp2!=NULL)
      {
        tmp3=tmp2->next;
        g_free(tmp2);
        tmp2=tmp3;
      }
      g_free(tmp2); 
    } 
    g_free(ur);
  }
  
  ur=NULL;

}


//88delete_all_undo88888888888888888888888888888888888888888888888888888888888888888888888888
//88create_new_undo88888888888888888888888888888888888888888888888888888888888888888888888888

void create_new_undo()
{
 
  short i,j,k;
 
  
  if(ur==NULL)
  {
     ur=g_malloc(sizeof(struct undo_redo));
     ur->next=NULL;
     ur->prev=NULL;
     for(i=0;i<number_of_picks/2;i++)
     {
     for(j=0;j<number_of_picks/2;j++)
     {
       for(k=0;k<number_of_picks/2+1;k++)
         ur->pencil_in[i][j][k]=pencil_in[i][j][k];
       ur->puzzle_box[i][j]=puzzle_box[i][j];
     }
     }
     ur->number_of_free_boxes=global.number_of_free_boxes;
  }   
  else
  {
    if(ur->next!=NULL)
    {
      struct undo_redo *tmp2; 
      struct undo_redo *tmp3;     
      tmp2=ur->next;
      while(tmp2!=NULL)
      {
        tmp3=tmp2->next;
        g_free(tmp2);
        tmp2=tmp3;
      }
      g_free(tmp2); 
    } 
    struct undo_redo *tmp;
    tmp=g_malloc(sizeof(struct undo_redo));
    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
     for(k=0;k<number_of_picks/2+1;k++)
       tmp->pencil_in[i][j][k]=pencil_in[i][j][k];
     tmp->puzzle_box[i][j]=puzzle_box[i][j];
    }
    }
    tmp->number_of_free_boxes=global.number_of_free_boxes;
    ur->next=tmp;
    tmp->prev=ur;
    tmp->next=NULL;
   
    ur=tmp;
  }

}

//88create_new_undo88888888888888888888888888888888888888888888888888888888888888888888888888
//88do_undo8888888888888888888888888888888888888888888888888888888888888888888888888888888888

void do_undo()
{
 
  short i,j,k;
 
  if(ur!=NULL && ur->prev!=NULL)
  {
    ur=ur->prev;
    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
      for(k=0;k<number_of_picks/2+1;k++)
        pencil_in[i][j][k]=ur->pencil_in[i][j][k];
      puzzle_box[i][j]=ur->puzzle_box[i][j];
    }
    }

    initialize_board();
    draw_puzzle();
    global.number_of_free_boxes=ur->number_of_free_boxes;
    update_status_bar_num_of_occupied_box();
//    g_print("thats a good boy\n");
  }
  
}

//88do_undo8888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88do_redo8888888888888888888888888888888888888888888888888888888888888888888888888888888888

void do_redo()
{
  
  short i,j,k;
 
  if(ur!=NULL && ur->next!=NULL)
  {
    ur=ur->next;
    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
      for(k=0;k<number_of_picks/2+1;k++)
        pencil_in[i][j][k]=ur->pencil_in[i][j][k];
      puzzle_box[i][j]=ur->puzzle_box[i][j];
    }
    }
    initialize_board();
    draw_puzzle();
    global.number_of_free_boxes=ur->number_of_free_boxes;
    update_status_bar_num_of_occupied_box();
  
  }


}

//88do_redo8888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88check_and_remove_and_display_pencil_in888888888888888888888888888888888888888888888888888

void check_and_remove_and_display_pencil_in(short  i,short j,short value)
{

  short x,y,z,w;
  short tmp1,tmp2;
  gboolean put_break;

  for(w=0;w<number_of_picks/2;w++)
  {
    if(pencil_in[i][j][w]!=-1)
      pencil_in[i][j][w]=-1;
    else
      break;
  }
  
  draw_pencil_in(i,j,1);	      

  for(x=0;x<number_of_picks/2;x++)
  {
     put_break=FALSE;
     for(z=0;z<number_of_picks/2;z++)
     {
    
       if(pencil_in[x][j][z]==-1)
         break;
       if(pencil_in[x][j][z]==value)
       {
         put_break=TRUE;
	 for(w=z;w<number_of_picks/2;w++)
	 {
	   pencil_in[x][j][w]=pencil_in[x][j][w+1];
           if(pencil_in[x][j][w]==-1)
	   {
              draw_pencil_in(x,j,1);	      
	      break;
	   }   
	  
	 } 	        
       }
       if(put_break==TRUE)
         break;
    
     }
    
  }

 for(x=0;x<number_of_picks/2;x++)
 {
    put_break=FALSE;

    for(z=0;z<number_of_picks/2;z++)
    {
    
        if(pencil_in[i][x][z]==-1)
         break;
    
       if(pencil_in[i][x][z]==value)
       {
         put_break=TRUE;         
	 for(w=z;w<number_of_picks/2;w++)
	 {
	   pencil_in[i][x][w]=pencil_in[i][x][w+1];
           if(pencil_in[i][x][w]==-1)
	   {
              draw_pencil_in(i,x,1);	      
	      break;
	   }   
	  
	  } 	        
       }
       if(put_break==TRUE)
         break;
    
     }
 
  }

  tmp1=board_size*(i/board_size);
  tmp2=board_size*(j/board_size);

  for(x=tmp1;x<tmp1+board_size;x++)
  {
  for(y=tmp2;y<tmp2+board_size;y++)
  {
        put_break=FALSE;

    for(z=0;z<number_of_picks/2;z++)
    {
    
       if(pencil_in[x][y][z]==-1)
         break;
    
       if(pencil_in[x][y][z]==value)
       {
           put_break=TRUE;	         
	 for(w=z;w<number_of_picks/2;w++)
	 {
           pencil_in[x][y][w]=pencil_in[x][y][w+1];
           if(pencil_in[x][y][w]==-1)
	   {
              draw_pencil_in(x,y,1);	      
	      break;
	   }   
	  
	  } 	        
       }
       if(put_break==TRUE)
         break;
    
     }
   
  }
  }



}

//88check_and_remove_and_display_pencil_in888888888888888888888888888888888888888888888888888
//88remove_all_pencilin8888888888888888888888888888888888888888888888888888888888888888888888

void remove_all_pencilin()
{
  
  short i,j,k,m;
 
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    if(pencil_in[i][j][0]!=-1)
    {
      for(k=0;k<number_of_picks/2+1;k++)
        pencil_in[i][j][k]=-1;
      draw_pencil_in(i,j,1); 
    }
  }
  }

  create_new_undo(); 
 
 
}

//88remove_all_pencilin8888888888888888888888888888888888888888888888888888888888888888888888
//88create_and_draw_all_pencilin8888888888888888888888888888888888888888888888888888888888888

void create_and_draw_all_pencilin()
{
 
 short i,j,k,m;
 short puzzle_box_value[number_of_picks/2][number_of_picks/2];
 
 for(i=0;i<number_of_picks/2;i++)
 {
 for(j=0;j<number_of_picks/2;j++)
 {
   puzzle_box_value[i][j]=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][j].value);
   for(k=0;k<number_of_picks/2+1;k++)
     pencil_in[i][j][k]=-1;
 }
 }

 for(i=0;i<number_of_picks/2;i++)
 {
 for(j=0;j<number_of_picks/2;j++)
 {
     
   if(puzzle_box_value[i][j]==-1)
   {
   for(k=0;k<number_of_picks/2;k++)
   {
       if(check_if_fits(puzzle_box_value,i,j,k)==TRUE)
        {
	  for(m=0;m<number_of_picks/2;m++)
	  {
	    if(pencil_in[i][j][m]==-1)
	    {
	      pencil_in[i][j][m]=k;
	      break;
	    
	    }  
	  }
        }
   
   
    }
    }
   
   
 }
 }

 for(i=0;i<number_of_picks/2;i++)
 {
 for(j=0;j<number_of_picks/2;j++)
 {
   if(puzzle_box_value[i][j]==-1)
     draw_pencil_in(i,j,1); 
   
  
 }
 }
 
  create_new_undo(); 

}

//88create_and_draw_all_pencilin8888888888888888888888888888888888888888888888888888888888888
//88initialize_board8888888888888888888888888888888888888888888888888888888888888888888888888


void initialize_board()
{

  short i,j;
  short x,y;
  short pick_box_y;
  int text_w;
  int text_h;
  PangoLayout      *layout;
  PangoFontDescription *fontdesc;
  
  puzzle_box_y=0;
  pick_box_y=0;
  if(global.time_race==TRUE && global.two_player_game==FALSE && global.edit_modeF==FALSE)
  {
    layout = gtk_widget_create_pango_layout (drawing_area, "88");
    fontdesc = pango_font_description_from_string (status_text);
    pango_layout_set_font_description (layout, fontdesc); 
    pango_layout_get_pixel_size (layout, &text_w, &text_h);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);
    puzzle_box_y=text_h;
    pick_box_y=text_h+1;
  }
  
  if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
  {
     if(global.two_player_time_game==TRUE)
     {
       layout = gtk_widget_create_pango_layout (drawing_area, "88");
       fontdesc = pango_font_description_from_string (status_text);
       pango_layout_set_font_description (layout, fontdesc); 
       pango_layout_get_pixel_size (layout, &text_w, &text_h);
       pango_font_description_free (fontdesc);
       g_object_unref (layout);
       puzzle_box_y=text_h;
       pick_box_y=text_h+1;
     }
     
       layout = gtk_widget_create_pango_layout (drawing_area, "fg88");
       fontdesc = pango_font_description_from_string (score_text);
       pango_layout_set_font_description (layout, fontdesc); 
       pango_layout_get_pixel_size (layout, &text_w, &text_h);
       pango_font_description_free (fontdesc);
       g_object_unref (layout);
       puzzle_box_y=text_h+puzzle_box_y-6;
       
  }

  puzzle_box_y=10+puzzle_box_y+2*pick_square_size;
    
  if(board_size==3)
  {
    number_of_picks=18;
    drawing_area_w=puzzle_box_square_size*9+5;
    drawing_area_h=puzzle_box_square_size*9+puzzle_box_y+5;
  }
  else if(board_size==4)
  {
    number_of_picks=32;
    drawing_area_w=puzzle_box_square_size*16+6;
    drawing_area_h=puzzle_box_square_size*16+puzzle_box_y+6;
    
  }
    
  
  
   x=drawing_area_w/2-(pick_square_size*(number_of_picks/2))/2; 
   y=pick_box_y;   
   //g_print("y: %d\n",y);
  
  for(i=0;i<number_of_picks/2;i++)
  {
    pick[i].x=x;
    pick[i].y=y;
    pick[i].mouse_over=0;  
    x=x+pick_square_size;
  }

  x=drawing_area_w/2-(pick_square_size*(number_of_picks/2))/2; 
  y=y+pick_square_size+3;
  
  for(i=0;i<number_of_picks/2;i++)
  {
    pick[number_of_picks/2+i].x=x;
    pick[number_of_picks/2+i].y=y;
    pick[number_of_picks/2+i].mouse_over=0;  
    x=x+pick_square_size;
  }


  y=1+puzzle_box_y;
  
  for(i=0;i<number_of_picks/2;i++)
  {
    x=1;
    for(j=0;j<number_of_picks/2;j++)
    {
  
    
     puzzle_box[i][j].x=x;
     puzzle_box[i][j].y=y;
     
     if( (j+1)%board_size !=0)
       x=x+puzzle_box_square_size;
      else
       x=x+puzzle_box_square_size+1;
     
    }
    if( (i+1)%board_size !=0)
      y=y+puzzle_box_square_size;
    else
      y=y+puzzle_box_square_size+1;

  }

  if (pixmap)
    gdk_pixmap_unref(pixmap);

  if (pixmap_bckup)
    gdk_pixmap_unref(pixmap_bckup);

  
  pixmap = gdk_pixmap_new(drawing_area->window,
                          drawing_area_w, drawing_area_h,
                          -1);
  
  pixmap_bckup = gdk_pixmap_new(drawing_area->window,
                          drawing_area_w, drawing_area_h,
                          -1);
  
  gtk_widget_set_size_request (drawing_area, drawing_area_w, drawing_area_h);
  gtk_window_resize(GTK_WINDOW(gs_main_window),10, 10);


}

//88initialize_board8888888888888888888888888888888888888888888888888888888888888888888888888
//88exit_game88888888888888888888888888888888888888888888888888888888888888888888888888888888

void exit_game()
{

/*    gdk_colormap_free_colors (colormap,&color.doubt_text,1);
    gdk_colormap_free_colors (colormap,&color.conf_text,1);
    gdk_colormap_free_colors (colormap,&color.pick_selected,1);
    gdk_colormap_free_colors (colormap,&color.pick_selected_bg,1);
    gdk_colormap_free_colors (colormap,&color.hl_light,1);
    gdk_colormap_free_colors (colormap,&color.hl_dark,1);
    gdk_colormap_free_colors (colormap,&color.puzzle_bg,1);
    gdk_colormap_free_colors (colormap,&color.puzzle_lines,1);
    gdk_colormap_free_colors (colormap,&color.puzzle_selected,1);
    gdk_colormap_free_colors (colormap,&color.key_box,1);
  

    gdk_colormap_free_colors (colormap,&color.num_fixed_box_bg,1);
    gdk_colormap_free_colors (colormap,&color.num_fixed_text,1);
    
    gdk_colormap_free_colors (colormap,&color.pencil_in,1);
    
    gdk_colormap_free_colors (colormap,&color.status_text_color,1);
    gdk_colormap_free_colors (colormap,&color.score_text_color,1);

           
    //gdk_gc_unref(gc);
    
    gtk_main_quit ();
*/

  exit(0);


}

//88exit_game88888888888888888888888888888888888888888888888888888888888888888888888888888888
//88check_conflicts_for_selected_pbox88888888888888888888888888888888888888888888888888888888
void check_conflicts_for_selected_pbox(short row,short column)
{

  short i,j,tmp1,tmp2;
  short check_value, search_value;

  global.is_there_conflictsF=FALSE;
  gdk_draw_drawable (pixmap_bckup,drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)], pixmap, 0, puzzle_box_y, 0, puzzle_box_y, drawing_area_w, drawing_area_h-puzzle_box_y);


  check_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[row][column].value);
  if(check_value!=-1)
  {

     for(i=0;i<number_of_picks/2;i++)
     {
        search_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][column].value);
  
        if(row != i && check_value==search_value)
          draw_line(row,column,i,column);

     }

     for(i=0;i<number_of_picks/2;i++)
     {
        search_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[row][i].value);
        if(column != i && check_value==search_value)
          draw_line(row,column,row,i);

     }


     tmp1=board_size*(row/board_size);
     tmp2=board_size*(column/board_size);

     
     for(i=tmp1;i<tmp1+board_size;i++)
     {
     for(j=tmp2;j<tmp2+board_size;j++)
     {
       
        search_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][j].value);

        if(i!= row && j !=column && check_value==search_value)
          draw_line(row,column,i,j);
  
     }
     }

  }


  if(global.is_there_conflictsF==TRUE)
    gdk_draw_pixmap(drawing_area->window,
                    drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                    pixmap,
                    0, puzzle_box_y, 0, puzzle_box_y,
                    drawing_area_w,drawing_area_h-puzzle_box_y);




}

//88check_conflicts_for_selected_pbox88888888888888888888888888888888888888888888888888888888
//88check_all_conflicts8888888888888888888888888888888888888888888888888888888888888888888888

void check_all_conflicts()
{

  short i,j,r,s,tmp1,tmp2;
  short check_value, search_value;
  global.is_there_conflictsF=FALSE;
 
  gdk_draw_drawable (pixmap_bckup,drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)], pixmap, 0, puzzle_box_y, 0, puzzle_box_y, drawing_area_w, drawing_area_h-puzzle_box_y);


  for(r=0;r<number_of_picks/2;r++)
  {
  for(s=0;s<number_of_picks/2;s++)
  {
      check_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[r][s].value);

      if(check_value!=-1)
      {
         for(i=0;i<number_of_picks/2;i++)
         {
            search_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][s].value);
            if(r != i && check_value==search_value)
              draw_line(r,s,i,s);
         }

         for(i=0;i<number_of_picks/2;i++)
         {
            search_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[r][i].value);
            if(s != i && check_value==search_value)
              draw_line(r,s,r,i);
         }

         tmp1=board_size*(r/board_size);
         tmp2=board_size*(s/board_size);

         for(i=tmp1;i<tmp1+board_size;i++)
         {
         for(j=tmp2;j<tmp2+board_size;j++)
         {
            search_value=convert_doubt_to_confirmed_text_if_necessery(puzzle_box[i][j].value);
    
            if(i!= r && j !=s && check_value==search_value)
              draw_line(r,s,i,j);
         }
         }
       }

  }
  }


  if(global.is_there_conflictsF==TRUE)
    gdk_draw_pixmap(drawing_area->window,
                    drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
                    pixmap,
                    0, puzzle_box_y, 0, puzzle_box_y,
                    drawing_area_w,drawing_area_h-puzzle_box_y);


}

//88check_all_conflicts8888888888888888888888888888888888888888888888888888888888888888888888
//88switch_on_the_timer8888888888888888888888888888888888888888888888888888888888888888888888

void switch_on_the_timer()
{
  
  tag_id=g_timeout_add(1000,(GSourceFunc)timer_on_function,NULL);
 
}

//88switch_on_the_timer8888888888888888888888888888888888888888888888888888888888888888888888
//88timer_on_function888888888888888888888888888888888888888888888888888888888888888888888888

gboolean timer_on_function(gpointer data)
{
  int text_w;
  int text_h;
  short num=0;
  short count=11;
  short min;
  short sec;
  char ch2[20]={'T','i','m','e',' ','l','e','f','t',':',' '};
  const gchar *message1="Time up. You lose.";
  const gchar *message2="Solution is valid. You Win. Congratulations.";
  const gchar *message2pg1="%s Wins";
  const gchar *message2pg2="%s Wins";
  const gchar *message2pg3="Game draw";


  GtkWidget *message_dialog;	    

  PangoLayout *layout;
  PangoFontDescription *fontdesc;
  GdkRectangle update_rect; 
            
           
  if(global.two_player_game==FALSE)
  {
        timing.tp_total_time=timing.tp_total_time-1;
  
        num=timing.tp_total_time/3600;
        if(num!=0)
        {
          ch2[count]=48+num/10;
          count=count+1;
          ch2[count]=48+num%10;
          count=count+1;
          ch2[count]=':';
          count=count+1;
        }
  
        num=(timing.tp_total_time%3600)/60;
        ch2[count]=48+num/10;
        count=count+1;
        ch2[count]=48+num%10;
        count=count+1;
	ch2[count]=':';
        count=count+1;
  
        num=(timing.tp_total_time%3600)%60;
        ch2[count]=48+num/10;
        count=count+1;
        ch2[count]=48+num%10;
        count=count+1;
        
        ch2[count]='\0';
  
        gdk_gc_set_foreground(gc,&color.status_text_color);
        layout = gtk_widget_create_pango_layout (drawing_area, ch2);
        fontdesc = pango_font_description_from_string (status_text);
        pango_layout_set_font_description (layout, fontdesc); 
        pango_layout_get_pixel_size (layout, &text_w, &text_h);

        update_rect.x = 0;
        update_rect.y = 0;
        update_rect.width = text_w+4;
        update_rect.height = text_h-2;
  
        gdk_draw_rectangle (pixmap,
                            drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                            TRUE,
                            update_rect.x, update_rect.y,
                            update_rect.width, update_rect.height);
 
  
        gdk_draw_layout (pixmap,gc,0,0,layout);
        pango_font_description_free (fontdesc);
        g_object_unref (layout);
 
        gtk_widget_draw (drawing_area, &update_rect);
		      
//        g_print("%s    %d\n",ch2,racing_time);		      
  
  
  
        if(timing.tp_total_time==0)
        {
           g_source_remove(tag_id);
           tag_id=0;
 
           check_all_conflicts();
 
           if(global.number_of_free_boxes!=0 || global.is_there_conflictsF ==TRUE)
           {
              message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_OK,message1);

              gtk_window_set_title (GTK_WINDOW (message_dialog), "Game Result");
	      g_signal_connect_swapped (message_dialog, "response",G_CALLBACK (gtk_widget_destroy),       message_dialog);
              gtk_widget_show(message_dialog);
           }
           else
           {
              message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_OK,message2);
              gtk_window_set_title (GTK_WINDOW (message_dialog), "Game Result");
              g_signal_connect_swapped (message_dialog, "response",G_CALLBACK (gtk_widget_destroy),       message_dialog);
              gtk_widget_show(message_dialog);
            
	   }
        }

  }
  else
  {
     if(timing.wait_time!=0)
     {
       strcpy(ch2,"Wait Time: ");
       //ch2[20]={'W','a','i','t',' ','T','i','m','e',':',' '};
       count=11;
       timing.wait_time=timing.wait_time-1;
   
        num=timing.wait_time/3600;
        if(num!=0)
        {
          ch2[count]=48+num/10;
          count=count+1;
          ch2[count]=48+num%10;
          count=count+1;
          ch2[count]=':';
          count=count+1;
        }
  
        num=(timing.wait_time%3600)/60;
        ch2[count]=48+num/10;
        count=count+1;
        ch2[count]=48+num%10;
        count=count+1;
	ch2[count]=':';
        count=count+1;
  
        num=(timing.wait_time%3600)%60;
        ch2[count]=48+num/10;
        count=count+1;
        ch2[count]=48+num%10;
        count=count+1;
    
        ch2[count]='\0';

//        g_print("%s    %d\n",ch2,timing.wait_time);		      

        gdk_gc_set_foreground(gc,&color.status_text_color);
        layout = gtk_widget_create_pango_layout (drawing_area, ch2);
        fontdesc = pango_font_description_from_string (status_text);
        pango_layout_set_font_description (layout, fontdesc); 
        pango_layout_get_pixel_size (layout, &text_w, &text_h);

        update_rect.x = drawing_area_w/2-text_w/2;
        update_rect.y = 0;
        update_rect.width = text_w+4;
        update_rect.height = text_h-2;
  
        gdk_draw_rectangle (pixmap,
                            drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                            TRUE,
                            update_rect.x, update_rect.y,
                            update_rect.width, update_rect.height);
 
  
        gdk_draw_layout (pixmap,gc,update_rect.x,0,layout);
        pango_font_description_free (fontdesc);
        g_object_unref (layout);
 
        gtk_widget_draw (drawing_area, &update_rect);
       
        if(timing.wait_time==0)
        {
            grand=g_rand_new();
            global.whose_turn= g_rand_int(grand)%2;
//	    g_print("whose turn:  %d\n",global.whose_turn);
         
            if(global.whose_turn==1)
            {  
               global.disable_mouse=TRUE;
               global.disable_keyboard=FALSE;
            }  
            else
            {  
               global.disable_mouse=FALSE;
               global.disable_keyboard=TRUE;
            }  
	    
	    status_bar_update_tp_whoes_turn(); 
	    
        }
     }
     else
     {
        if(timing.tp_total_time!=-1)
	{
           strcpy(ch2,"Time Left: ");
           //ch2[20]={'T','i','m','e',' ','L','e','f','t',':',' '};
           count=11;
           timing.tp_total_time=timing.tp_total_time-1;
  
           num=timing.tp_total_time/3600;
           
	   if(num!=0)
           {
              ch2[count]=48+num/10;
              count=count+1;
              ch2[count]=48+num%10;
              count=count+1;
              ch2[count]=':';
              count=count+1;
           }
  
           num=(timing.tp_total_time%3600)/60;
           ch2[count]=48+num/10;
           count=count+1;
           ch2[count]=48+num%10;
           count=count+1;
	   ch2[count]=':';
           count=count+1;
  
           num=(timing.tp_total_time%3600)%60;
           ch2[count]=48+num/10;
           count=count+1;
           ch2[count]=48+num%10;
           count=count+1;
    
           ch2[count]='\0';
//           g_print("%s    %d\n",ch2,timing.tp_total_time);		      
  
           gdk_gc_set_foreground(gc,&color.status_text_color);
           layout = gtk_widget_create_pango_layout (drawing_area, ch2);
           fontdesc = pango_font_description_from_string (status_text);
           pango_layout_set_font_description (layout, fontdesc); 
           pango_layout_get_pixel_size (layout, &text_w, &text_h);

           update_rect.x = drawing_area_w/2-text_w/2-4;
           update_rect.y = 0;
           update_rect.width = text_w+8;
           update_rect.height = text_h-2;
  
           gdk_draw_rectangle (pixmap,
                               drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                               TRUE,
                               update_rect.x, update_rect.y,
                               update_rect.width, update_rect.height);
 
  
           gdk_draw_layout (pixmap,gc,update_rect.x+4,0,layout);
           pango_font_description_free (fontdesc);
           g_object_unref (layout);
 
           gtk_widget_draw (drawing_area, &update_rect);
		      
   
  
          if(timing.tp_total_time==0)
          {
             g_source_remove(tag_id);
             tag_id=0;
 
             if(global.p1_points>global.p2_points)
                message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_OK,message2pg1,sec_copy.player1_name);
             else if(global.p1_points>global.p2_points)
                message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_OK,message2pg2,sec_copy.player2_name);
	     else
                message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_OK,message2pg3);
            
             gtk_window_set_title (GTK_WINDOW (message_dialog), "Game Result");

	     g_signal_connect_swapped (message_dialog, "response",G_CALLBACK (gtk_widget_destroy),       message_dialog);
             gtk_widget_show(message_dialog);

         }
      }
  
        
      if(global.disable_mouse==FALSE)
      {
         strcpy(ch2,sec_copy.player1_ini);
         count=strlen(ch2);
         ch2[count]=':';
         count=count+1;
         ch2[count]=' ';
         count=count+1;
	 
         timing.tp_1_time=timing.tp_1_time-1;
  
         num=timing.tp_1_time/3600;
         if(num!=0)
         {
            ch2[count]=48+num/10;
            count=count+1;
            ch2[count]=48+num%10;
            count=count+1;
            ch2[count]=':';
            count=count+1;
         }
  
         num=(timing.tp_1_time%3600)/60;
         ch2[count]=48+num/10;
         count=count+1;
         ch2[count]=48+num%10;
         count=count+1;
	 ch2[count]=':';
         count=count+1;
  
         num=(timing.tp_1_time%3600)%60;
         ch2[count]=48+num/10;
         count=count+1;
         ch2[count]=48+num%10;
         count=count+1;
    
         ch2[count]='\0';
//         g_print("%s    %d\n",ch2,timing.tp_total_time);		      
  
         gdk_gc_set_foreground(gc,&color.status_text_color);
	 
	 layout = gtk_widget_create_pango_layout (drawing_area, ch2);
         fontdesc = pango_font_description_from_string (status_text);
         pango_layout_set_font_description (layout, fontdesc); 
         pango_layout_get_pixel_size (layout, &text_w, &text_h);
        
         update_rect.x = drawing_area_w-text_w-2;
         update_rect.y = 0;
         update_rect.width = text_w+4;
         update_rect.height = text_h;
  
         gdk_draw_rectangle (pixmap,
                             drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                             TRUE,
                             update_rect.x, update_rect.y,
                             update_rect.width, update_rect.height);
 
         if(timing.tp_1_time!=0)
            gdk_draw_layout (pixmap,gc,drawing_area_w-text_w-2,0,layout);

         pango_font_description_free (fontdesc);
         g_object_unref (layout);
       
         gtk_widget_draw (drawing_area, &update_rect);
	

     }

	
	
     if(global.disable_keyboard==FALSE)
     {
         strcpy(ch2,sec_copy.player2_ini);
         count=strlen(ch2);
         ch2[count]=':';
         count=count+1;
         ch2[count]=' ';
         count=count+1;
	 
        timing.tp_2_time=timing.tp_2_time-1;
 	num=timing.tp_2_time/3600;
        
	if(num!=0)
        {
           ch2[count]=48+num/10;
           count=count+1;
           ch2[count]=48+num%10;
           count=count+1;
           ch2[count]=':';
           count=count+1;
        }
  
        num=(timing.tp_2_time%3600)/60;
        ch2[count]=48+num/10;
        count=count+1;
        ch2[count]=48+num%10;
        count=count+1;
	ch2[count]=':';
        count=count+1;
  
        num=(timing.tp_2_time%3600)%60;
        ch2[count]=48+num/10;
        count=count+1;
        ch2[count]=48+num%10;
        count=count+1;
    
        ch2[count]='\0';
//        g_print("%s    %d\n",ch2,timing.tp_total_time);		      
  
        gdk_gc_set_foreground(gc,&color.status_text_color);
	 
	layout = gtk_widget_create_pango_layout (drawing_area, ch2);
        fontdesc = pango_font_description_from_string (status_text);
        pango_layout_set_font_description (layout, fontdesc); 
        pango_layout_get_pixel_size (layout, &text_w, &text_h);
        
        update_rect.x = 0;
        update_rect.y = 0;
        update_rect.width = text_w+6;
        update_rect.height = text_h;
  
        gdk_draw_rectangle (pixmap,
                            drawing_area->style->bg_gc[GTK_STATE_NORMAL],
                            TRUE,
                            update_rect.x, update_rect.y,
                            update_rect.width, update_rect.height);
 
        if(timing.tp_2_time!=0)
	  gdk_draw_layout (pixmap,gc,0,0,layout);
        
	pango_font_description_free (fontdesc);
        g_object_unref (layout);
       
        gtk_widget_draw (drawing_area, &update_rect);
	
     }
	
     
     //to have uniform time interval
     if(timing.tp_1_time==0 && global.disable_mouse==FALSE)  
     {
	    //if(p_m!=-1)
	    //unselect_puzzle_box();
	    global.disable_mouse=TRUE;
	    global.disable_keyboard=FALSE;
  	    timing.tp_1_time=global.tp_1_time;
	    status_bar_update_tp_whoes_turn();
      }
      
      if(timing.tp_2_time==0 && global.disable_keyboard==FALSE)
      {
        //draw_and_unselect_key_box();
	    global.disable_mouse=FALSE;
	    global.disable_keyboard=TRUE;
  	    timing.tp_2_time=global.tp_2_time;
        status_bar_update_tp_whoes_turn();
      }
	
		
     }
  
  }
  
  
  return TRUE;


}

//88timer_on_function888888888888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888

