/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <gtk/gtk.h>
#include "gsudoku.h"


GtkWidget *notebook;

 
struct tmp_settings
{
   
  GtkWidget *gradio_b[2];
  GtkWidget *gcheck_box[4];
  GtkWidget *gt_entry[10];
  
  GtkWidget *ffont_button[5];
 
  GtkWidget *sztext_entry[3];
  
  GtkWidget *ccolor_button[3][9];

  GtkWidget *gentext_entry;
  GtkWidget *gencheck_box[9];

  GtkWidget *solcheck_box[8];
  
  GtkWidget *pradio_tbar[3];
  GtkWidget *pradio_sticky[3];
  GtkWidget *pcheck_box[12];

  
  
  struct tmp_game
  {
    short board_size;
    int racing_time;
    char player1_name[100];
    char player1_ini[3];
    char player2_name[100];
    char player2_ini[3];
    short minus_points;
    short tp_1_time;
    short tp_2_time;
    short wait_time;
    int tp_total_time;
    unsigned time_race:1;
    unsigned two_player_solveF:1;
    unsigned two_player_gameF:1;
    unsigned two_player_time_game:1;
  }tmp_game;
  
   
  struct tmp_font
  {
    gchar pick_box_font[255];
    gchar puzzle_box_font[255];
    gchar pencil_in_font[255];
    gchar status_text[255];
    gchar score_text[255];
  }tmp_font;
  
  
  struct color tmp_color;
  
  struct tmp_size
  {
    short pick_square_size;
    short puzzle_box_square_size;
  }tmp_size;
  
  
  struct tmp_gen
  {
    short guess_threshold;
    unsigned symmetric_puzzleF :1;
    unsigned g_hidden_unique_candidate :1;
    unsigned g_visible_doublets_triplets_etc :1;
    unsigned g_hidden_doublets_triplets_etc :1;
    unsigned g_row_and_column_interaction_with_block : 1;
    unsigned g_block_interaction_with_row_and_column : 1;
    unsigned g_block_block_interaction : 1;
    unsigned g_xwing : 1;
    unsigned g_swordfish : 1;
  }tmp_gen;
  
  
  struct tmp_sol
  {
    unsigned s_hidden_unique_candidate :1;
    unsigned s_visible_doublets_triplets_etc :1;
    unsigned s_hidden_doublets_triplets_etc :1;
    unsigned s_row_and_column_interaction_with_block : 1;
    unsigned s_block_interaction_with_row_and_column : 1;
    unsigned s_block_block_interaction : 1;
    unsigned s_xwing : 1;
    unsigned s_swordfish : 1;
  }tmp_sol;
  
 
  struct tmp_pref
  {
    short toolbar_mode;
    short sticky_selection;
    unsigned show_status_barF : 1;
    unsigned show_splash_screenF : 1;
    unsigned show_tips_and_tricksF : 1;
    unsigned key_movement_fixed_box_no_limit : 1;
    unsigned key_movement_restrictive : 1;
    unsigned show_figures_while_solving : 1;
    unsigned show_console_messegesF : 1;
    unsigned editor_check_puzzle_validity : 1;
    unsigned auto_pencil_in_remove : 1;
    unsigned check_for_conflictF : 1;
    unsigned consider_doubt_text_as_confirm_textF : 1;
    unsigned treat_doubt_as_pencil_in : 1;
  }tmp_pref;
 
  
};
  
struct tmp_settings *tmps;
 
 

enum
{
 COL_ICON=0,
 COL_TEXT,
 NUM_COLS
};

short which_settings_dialog_active;



/*

char* number_to_string(short value)
int string_to_number(char str[12])
gboolean settings_dialog(GtkWidget *widget)
gboolean delete_settings_dialog( GtkWidget *widget, GdkEvent  *event, gpointer   data )
gboolean help_button_clicked (GtkWidget *widget,gpointer data)
gboolean default_button_clicked (GtkWidget *widget,gpointer data)
gboolean revert_button_clicked (GtkWidget *widget,gpointer data)
GtkListStore *create_liststore(void)
GtkWidget* create_view_and_model(void)
void change_gcheckbox(GtkWidget *widget, gpointer data)
void change_gradio(GtkWidget *widget, gpointer data)
gboolean gtext_boxes_key(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
gboolean gtext_boxes_focus_out(GtkWidget *text_entry, GdkEventFocus *event,gpointer data)
void settings_stuff_game(GtkWidget *game_widget)
void choose_notebook_tab  (GtkTreeView *treeview,  gpointer user_data)
void change_font(GtkFontButton *font_button, gpointer data)
void settings_stuff_font(GtkWidget *font_widget)
void change_color(GtkColorButton *color_button, gpointer data)
void settings_stuff_color(GtkWidget *color_widget)
gboolean key_change_size(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
gboolean change_size(GtkWidget *text_entry, GdkEventFocus *event,gpointer data)
void settings_stuff_size(GtkWidget *size_widget)
gboolean key_change_threshold(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
gboolean change_threshold(GtkWidget *text_entry, GdkEventFocus *event,gpointer data)
void check_button_generator (GtkWidget *widget, gpointer data)
void settings_stuff_generator(GtkWidget *generator_widget)
void check_button_solver (GtkWidget *widget, gpointer data)
void settings_stuff_solver(GtkWidget *solver_widget)
void change_pcheckbox(GtkWidget *widget, gpointer data)
void change_psticky(GtkWidget *widget, gpointer data)
void change_ptbar(GtkWidget *widget, gpointer data)
void settings_stuff_preference(GtkWidget *preference_widget)

*/

//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88number_to_string8888888888888888888888888888888888888888888888888888888888888888888888888

char* number_to_string(short value)
{
  static char str[12];
  short len,i;
  short tmp;
  
  if(value==0)
  {
   str[0]='0';
   str[1]='\0';
  }
  else
  {
  len=0;
  tmp=value;
  
  while(tmp>0)
  {
    tmp=tmp/10;
    len=len+1;
  }
  
  tmp=value;
  for(i=len-1;i>=0;i--)
  {
    str[i]=48+tmp%10;  
    tmp=tmp/10;
  }
  str[len]='\0';
  }
  return str; 

}

//88number_to_string8888888888888888888888888888888888888888888888888888888888888888888888888
//88string_to_number8888888888888888888888888888888888888888888888888888888888888888888888888

int string_to_number(char str[12])
{
  short len,i;
  int value;
  
  
  len=strlen(str);
  value=0;
  
  for(i=0;i<len;i++)
   value=value*10+(str[i]-48);
  
  return value; 

}

//88string_to_number8888888888888888888888888888888888888888888888888888888888888888888888888
//88settings_dialog88888888888888888888888888888888888888888888888888888888888888888888888888
 
gboolean settings_dialog(GtkWidget *widget)
{
 
  if(settings_widget==NULL)
  {
 
    GtkWidget *main_hbox;
    GtkWidget *bbox;  //button boxes
    GtkWidget *vbox1;
    GtkWidget *vbox2;
    GtkWidget *view;
    GtkWidget *scroll_window;
 
    GtkWidget *view_seperator;
 
    GtkWidget *button;
    GtkWidget *tab_label;
    GtkWidget *game_widget;
    GtkWidget *font_widget;
    GtkWidget *color_widget;
    GtkWidget *size_widget;
    GtkWidget *preference_widget;
    GtkWidget *generator_widget;
    GtkWidget *solver_widget;
 
 
 
    
     tmps=g_malloc(sizeof(struct tmp_settings));
    
     which_settings_dialog_active=0;
     settings_widget=gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_window_set_title (GTK_WINDOW (settings_widget), "Settings Dialog");
 //    gtk_window_set_default_size(GTK_WINDOW(settings_widget),200,555);
     g_signal_connect (G_OBJECT (settings_widget), "delete_event",G_CALLBACK (delete_settings_dialog), NULL);
    
    
     main_hbox=gtk_hbox_new(FALSE,0); 
     gtk_container_set_border_width (GTK_CONTAINER (main_hbox), 4);
     gtk_container_add (GTK_CONTAINER (settings_widget),main_hbox);
      
     vbox1=gtk_vbox_new(FALSE,0); 
     gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);
     gtk_box_pack_start (GTK_BOX (main_hbox), vbox1, FALSE, TRUE, 0);
   
     vbox2=gtk_vbox_new(FALSE,0); 
     gtk_container_set_border_width (GTK_CONTAINER (vbox2), 4);
     gtk_box_pack_end (GTK_BOX (main_hbox), vbox2,TRUE,TRUE,0);
   
     scroll_window=gtk_scrolled_window_new( NULL,NULL );    
     gtk_scrolled_window_set_policy  (GTK_SCROLLED_WINDOW (scroll_window), GTK_POLICY_NEVER, GTK_POLICY_NEVER);
    
     gtk_container_add(GTK_CONTAINER(vbox1),scroll_window);
    
     
     view=create_view_and_model();
//     gtk_widget_set_size_request (view, 160,400);
//    gtk_container_add(GTK_CONTAINER(vbox1),view);
     g_signal_connect (G_OBJECT (view), "cursor-changed",G_CALLBACK (choose_notebook_tab), NULL);

     gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (scroll_window),view);
    
    
     tmps->tmp_game.board_size=board_size_original;
     tmps->tmp_game.racing_time=global.racing_time;
     strcpy(tmps->tmp_game.player1_name,global.player1_name);
     strcpy(tmps->tmp_game.player1_ini,global.player1_ini);
     strcpy(tmps->tmp_game.player2_name,global.player2_name);
     strcpy(tmps->tmp_game.player2_ini,global.player2_ini);
     tmps->tmp_game.minus_points=global.minus_points;
     tmps->tmp_game.tp_1_time=global.tp_1_time;
     tmps->tmp_game.tp_2_time=global.tp_2_time;
     tmps->tmp_game.wait_time=global.wait_time;
     tmps->tmp_game.tp_total_time=global.tp_total_time;
     tmps->tmp_game.time_race=global.time_race;
     tmps->tmp_game.two_player_solveF=global.two_player_solveF;
     tmps->tmp_game.two_player_gameF=global.two_player_gameF;
     tmps->tmp_game.two_player_time_game=global.two_player_time_game;
     game_widget=gtk_vbox_new(FALSE,0);
     settings_stuff_game(game_widget);
     
     
     strcpy(tmps->tmp_font.pick_box_font,pick_box_font);
     strcpy(tmps->tmp_font.puzzle_box_font,puzzle_box_font);
     strcpy(tmps->tmp_font.pencil_in_font,pencil_in_font);
     strcpy(tmps->tmp_font.status_text,status_text);
     strcpy(tmps->tmp_font.score_text,score_text);
     font_widget=gtk_vbox_new(FALSE,0);
     settings_stuff_font(font_widget);
          
     
     tmps->tmp_size.pick_square_size=pick_square_size;
     tmps->tmp_size.puzzle_box_square_size=puzzle_box_square_size;
     size_widget=gtk_vbox_new(FALSE,0);
     settings_stuff_size(size_widget);
          
     
     tmps->tmp_color=color;
     color_widget=gtk_vbox_new(FALSE,0); 
     settings_stuff_color(color_widget);     
     
     
     tmps->tmp_gen.guess_threshold=global.guess_threshold;
     tmps->tmp_gen.symmetric_puzzleF=global.symmetric_puzzleF;
     tmps->tmp_gen.g_hidden_unique_candidate=global.g_hidden_unique_candidate;
     tmps->tmp_gen.g_visible_doublets_triplets_etc=global.g_visible_doublets_triplets_etc;
     tmps->tmp_gen.g_hidden_doublets_triplets_etc=global.g_hidden_doublets_triplets_etc;
     tmps->tmp_gen.g_row_and_column_interaction_with_block=global.g_row_and_column_interaction_with_block;
     tmps->tmp_gen.g_block_interaction_with_row_and_column=global.g_block_interaction_with_row_and_column;
     tmps->tmp_gen.g_block_block_interaction=global.g_block_block_interaction;
     tmps->tmp_gen.g_xwing=global.g_xwing;
     tmps->tmp_gen.g_swordfish=global.g_swordfish;
     generator_widget=gtk_vbox_new(FALSE,0);
     settings_stuff_generator(generator_widget);  

     
     tmps->tmp_sol.s_hidden_unique_candidate=global.s_hidden_unique_candidate;
     tmps->tmp_sol.s_visible_doublets_triplets_etc=global.s_visible_doublets_triplets_etc;
     tmps->tmp_sol.s_hidden_doublets_triplets_etc=global.s_hidden_doublets_triplets_etc;
     tmps->tmp_sol.s_row_and_column_interaction_with_block=global.s_row_and_column_interaction_with_block;
     tmps->tmp_sol.s_block_interaction_with_row_and_column=global.s_block_interaction_with_row_and_column;
     tmps->tmp_sol.s_block_block_interaction=global.s_block_block_interaction;
     tmps->tmp_sol.s_xwing=global.s_xwing;
     tmps->tmp_sol.s_swordfish=global.s_swordfish;
     solver_widget=gtk_vbox_new(FALSE,0);
     settings_stuff_solver(solver_widget);  
          
     
     tmps->tmp_pref.toolbar_mode=toolbar_mode;
     tmps->tmp_pref.sticky_selection=sticky_selection;
     tmps->tmp_pref.show_status_barF=global.show_status_barF;
     tmps->tmp_pref.show_splash_screenF=global.show_splash_screenF;
     tmps->tmp_pref.show_tips_and_tricksF=global.show_tips_and_tricksF;
     tmps->tmp_pref.key_movement_fixed_box_no_limit=global.key_movement_fixed_box_no_limit;
     tmps->tmp_pref.key_movement_restrictive=global.key_movement_restrictive;
     tmps->tmp_pref.show_figures_while_solving=global.show_figures_while_solving;
     tmps->tmp_pref.show_console_messegesF=global.show_console_messegesF;
     tmps->tmp_pref.editor_check_puzzle_validity=global.editor_check_puzzle_validity;
     tmps->tmp_pref.auto_pencil_in_remove=global.auto_pencil_in_remove;
     tmps->tmp_pref.check_for_conflictF=global.check_for_conflictF;
     tmps->tmp_pref.consider_doubt_text_as_confirm_textF=global.consider_doubt_text_as_confirm_textF;
     tmps->tmp_pref.treat_doubt_as_pencil_in=global.treat_doubt_as_pencil_in;
     preference_widget=gtk_vbox_new(FALSE,0);
     settings_stuff_preference(preference_widget);  
     
     
     
     
     gtk_widget_show (game_widget);
     gtk_widget_show (font_widget);
     gtk_widget_show (size_widget);
     gtk_widget_show (color_widget);
     gtk_widget_show (generator_widget);
     gtk_widget_show (solver_widget);
     gtk_widget_show (preference_widget);

     
     
     notebook=gtk_notebook_new();
     gtk_notebook_set_show_tabs(GTK_NOTEBOOK(notebook),FALSE);
     gtk_notebook_set_show_border (GTK_NOTEBOOK(notebook),FALSE);
    
     //gtk_container_add(GTK_CONTAINER(vbox2),notebook);
     gtk_box_pack_start (GTK_BOX (vbox2), notebook, TRUE, TRUE, 0);

        
     tab_label = gtk_label_new ("Game");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),game_widget,tab_label );
    
     tab_label = gtk_label_new ("Font");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),font_widget,tab_label );
    
     tab_label = gtk_label_new ("Size");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),size_widget,tab_label );
    
     tab_label = gtk_label_new ("Color");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),color_widget,tab_label );
    
     tab_label = gtk_label_new ("Generator");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),generator_widget,tab_label );

     tab_label = gtk_label_new ("Solver");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),solver_widget,tab_label );
       
     tab_label = gtk_label_new ("Preference");
     gtk_widget_show (tab_label);
     gtk_notebook_append_page(GTK_NOTEBOOK(notebook),preference_widget,tab_label );
   
     view_seperator= gtk_hseparator_new ();
     gtk_box_pack_start (GTK_BOX (vbox2), view_seperator,FALSE,TRUE,0);
     gtk_widget_show (view_seperator);
        
     bbox = gtk_hbutton_box_new ();
     gtk_container_set_border_width (GTK_CONTAINER (bbox), 5);
     gtk_box_pack_end (GTK_BOX (vbox2), bbox,FALSE,TRUE,0);
    
     gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox), GTK_BUTTONBOX_END);
     gtk_box_set_spacing (GTK_BOX (bbox), 10);
    
     button = gtk_button_new_from_stock (GTK_STOCK_HELP);
     gtk_container_add (GTK_CONTAINER (bbox), button);
     gtk_widget_show (button);
     g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(help_button_clicked),NULL);

     button = gtk_button_new_with_label("Default");
     gtk_container_add (GTK_CONTAINER (bbox), button);
     gtk_widget_show (button);
     g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(default_button_clicked),NULL);
    
     button = gtk_button_new_with_label ("Revert");
     gtk_container_add (GTK_CONTAINER (bbox), button);
     gtk_widget_show (button);
     g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(revert_button_clicked),NULL);
   
     gtk_widget_show (bbox); 
     gtk_widget_show (notebook);  
     gtk_widget_show (view);
     gtk_widget_show (scroll_window); 
     gtk_widget_show (vbox1);   
     gtk_widget_show (vbox2);   
     gtk_widget_show (main_hbox);   
     gtk_widget_show (settings_widget);
  }

  return TRUE;
  
  
}

//88settings_dialog88888888888888888888888888888888888888888888888888888888888888888888888888
//88delete_settings_dialog8888888888888888888888888888888888888888888888888888888888888888888

gboolean delete_settings_dialog( GtkWidget *widget, GdkEvent  *event, gpointer   data )
{  
  gtk_widget_destroy(settings_widget);
  settings_widget=NULL;
  save_settings_to_file();
  g_free(tmps);
  return TRUE;

}

//88delete_settings_dialog8888888888888888888888888888888888888888888888888888888888888888888
//88help_button_clicked8888888888888888888888888888888888888888888888888888888888888888888888

gboolean help_button_clicked (GtkWidget *widget,gpointer data)
{

  gint page_number;
  page_number=gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
  
  if(page_number==0)
//   open_browser("manual/settings_dialog.html#game_tab");
   open_browser("manual/settings_dialog.html");   
  else if(page_number==1)
//   open_browser("manual/settings_dialog.html#font_tab");
   open_browser("manual/settings_dialog.html");   
  else if(page_number==2)
//   open_browser("manual/settings_dialog.html#size_tab");
   open_browser("manual/settings_dialog.html");   
  else if(page_number==3)
//   open_browser("manual/settings_dialog.html#color_tab");
   open_browser("manual/settings_dialog.html");   
  else if(page_number==4)
//   open_browser("manual/settings_dialog.html#gen_tab");
   open_browser("manual/settings_dialog.html");   
  else if(page_number==5)
//   open_browser("manual/settings_dialog.html#sol_tab");
   open_browser("manual/settings_dialog.html");   
  else if(page_number==6)
//   open_browser("manual/settings_dialog.html#pref_tab");
   open_browser("manual/settings_dialog.html");   

  return TRUE;
  
}

//88help_button_clicked8888888888888888888888888888888888888888888888888888888888888888888888
//88default_button_clicked8888888888888888888888888888888888888888888888888888888888888888888

gboolean default_button_clicked (GtkWidget *widget,gpointer data)
{
 
  gint page_number;
  page_number=gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
 
  if(page_number==0)
  {
     
     char str[100];
     
     strcpy(global.player1_name,"player1");
     strcpy(global.player1_ini,"PL1");
     strcpy(global.player2_name,"player2");
     strcpy(global.player2_ini,"PL2");

     board_size_original=3;
     global.time_race=0;
     global.two_player_solveF=0;
     global.racing_time=1500;
     global.two_player_gameF=0;
     global.two_player_time_game=0;
     global.minus_points=5;
     global.tp_1_time=60;
     global.tp_2_time=60;
     global.wait_time=10;
     global.tp_total_time=2250;
    
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->gradio_b[board_size_original-3]), TRUE);
    
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[0])),FALSE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[1])),FALSE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[2])),FALSE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[3])),FALSE);
   
     strcpy(str,"1500");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[0]), (const char*)str);
     strcpy(str,"Player1");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[1]), (const char*)str);
     strcpy(str,"PL1");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[2]), (const char*)str);
     strcpy(str,"Player2");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[3]), (const char*)str);
     strcpy(str,"PL2");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[4]), (const char*)str);
     strcpy(str,"5");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[5]), (const char*)str);
     strcpy(str,"60");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[6]), (const char*)str);
     strcpy(str,"60");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[7]), (const char*)str);
     strcpy(str,"10");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[8]), (const char*)str);
     strcpy(str,"2250");  
     gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[9]), (const char*)str); 
 
  }

  
  if(page_number==1)
  {
     strcpy(pick_box_font,"Cursor 16");
     strcpy(puzzle_box_font,"Cursor 16");
     strcpy(pencil_in_font,"Cursor 8");
     strcpy(status_text,"Cursor 12");
     strcpy(score_text,"Cursor 10");
     initialize_board();  
     draw_puzzle();
  
     gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[0]),(const char*)pick_box_font);
     gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[1]),(const char*)puzzle_box_font);
     gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[2]),(const char*)pencil_in_font);
     gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[3]),(const char*)status_text);
     gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[4]),(const char*)score_text);
  }
 
  if(page_number==2)
  {
     char pick_txt[20];
     char puzz_txt[20];
  
     pick_square_size=32;
     puzzle_box_square_size=42;
     strcpy(pick_txt,"32");
     strcpy(puzz_txt,"42");
     initialize_board();
     draw_puzzle();
  
     gtk_entry_set_text(GTK_ENTRY(tmps->sztext_entry[1]),(const char*)pick_txt);
     gtk_entry_set_text(GTK_ENTRY(tmps->sztext_entry[2]),(const char*)puzz_txt);
  }
 
 
  if(page_number==3)
  {
     gdk_colormap_free_colors (colormap,&color.doubt_text,1);
     gdk_colormap_free_colors (colormap,&color.conf_text,1);
     gdk_colormap_free_colors (colormap,&color.pick_selected,1);
     gdk_colormap_free_colors (colormap,&color.pick_selected_bg,1);
     gdk_colormap_free_colors (colormap,&color.hl_light,1);
     gdk_colormap_free_colors (colormap,&color.hl_dark,1);
     gdk_colormap_free_colors (colormap,&color.puzzle_bg,1);
     gdk_colormap_free_colors (colormap,&color.puzzle_lines,1);
     gdk_colormap_free_colors (colormap,&color.puzzle_selected,1);
     gdk_colormap_free_colors (colormap,&color.key_box,1);
     gdk_colormap_free_colors (colormap,&color.num_fixed_box_bg,1);
     gdk_colormap_free_colors (colormap,&color.num_fixed_text,1);
     gdk_colormap_free_colors (colormap,&color.pencil_in,1);
     gdk_colormap_free_colors (colormap,&color.status_text_color,1);
     gdk_colormap_free_colors (colormap,&color.score_text_color,1);
     
     color.hl_dark.red = 0;
     color.hl_dark.blue = 192*65535/255;
     color.hl_dark.green = 0;

     color.hl_light.red = 192*65535/255;
     color.hl_light.blue = 65535;
     color.hl_light.green = 192*65535/255;

     color.pick_selected_bg.red = 65535;
     color.pick_selected_bg.blue = 203*65535/255;
     color.pick_selected_bg.green = 192*65535/255;
  
     color.pick_selected.red = 165*65535/255;
     color.pick_selected.blue = 42*65535/255;
     color.pick_selected.green = 42*65535/255;
  
     color.conf_text.red = 0;
     color.conf_text.blue = 0;
     color.conf_text.green = 0;
  
     color.doubt_text.red = 0*65535/255;
     color.doubt_text.blue = 255*65535/255;
     color.doubt_text.green = 10*65535/255;
  
     color.puzzle_lines.red = 0;
     color.puzzle_lines.blue = 0;
     color.puzzle_lines.green = 0;
 
     color.puzzle_bg.red = 65535;
     color.puzzle_bg.blue = 65535;
     color.puzzle_bg.green = 65535;
  
     color.puzzle_selected.red = 0;
     color.puzzle_selected.blue = 65535;
     color.puzzle_selected.green = 0;
 
     color.key_box.red = 0;
     color.key_box.blue = 0;
     color.key_box.green = 65535;
 
     color.num_fixed_box_bg.red = 229*65535/255;
     color.num_fixed_box_bg.blue = 229*65535/255;
     color.num_fixed_box_bg.green = 229*65535/255;
  
     color.num_fixed_text.red = 0;
     color.num_fixed_text.blue = 0;
     color.num_fixed_text.green = 0;
  
     color.conflict_lines.red = 65535;
     color.conflict_lines.blue = 0;
     color.conflict_lines.green = 0;
  
     color.pencil_in.red = 0;
     color.pencil_in.blue = 65535;
     color.pencil_in.green = 0;
  
     color.status_text_color.red = 65535;
     color.status_text_color.blue = 0;
     color.status_text_color.green = 0;
  
     color.score_text_color.red = 65535;
     color.score_text_color.blue = 0;
     color.score_text_color.green = 0;
   
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.conf_text );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.doubt_text );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.hl_light );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.hl_dark ); 
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pick_selected);
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pick_selected_bg );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_bg );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_lines );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_selected );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.key_box );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.num_fixed_box_bg );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.num_fixed_text );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.conflict_lines );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pencil_in );
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.status_text_color);
     gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.score_text_color);
     
     draw_puzzle();
  
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][1]),&color.hl_light);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][2]),&color.hl_dark);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][3]),&color.pick_selected_bg);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][4]),&color.pick_selected);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][5]),&color.conf_text);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][6]),&color.doubt_text);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][7]),&color.status_text_color);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][8]),&color.score_text_color);

     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][1]),&color.puzzle_bg);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][2]),&color.puzzle_lines);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][3]),&color.num_fixed_box_bg);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][4]),&color.puzzle_selected);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][5]),&color.key_box);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][6]),&color.conflict_lines);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][7]),&color.num_fixed_text);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][8]),&color.pencil_in);
  }

   
  if(page_number==4)
  {

     global.guess_threshold=16;
     global.symmetric_puzzleF=TRUE;
     global.g_hidden_unique_candidate=TRUE;
     global.g_visible_doublets_triplets_etc=TRUE;
     global.g_hidden_doublets_triplets_etc=TRUE;
     global.g_row_and_column_interaction_with_block=TRUE;
     global.g_block_interaction_with_row_and_column=TRUE;
     global.g_block_block_interaction=TRUE;
     global.g_xwing=TRUE;
     global.g_swordfish=TRUE;
 
     gtk_entry_set_text(GTK_ENTRY(tmps->gentext_entry), (const char*)"16");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[0])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[1])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[2])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[3])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[4])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[5])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[6])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[7])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[8])),TRUE);
  } 
 
 
  if(page_number==5)
  {
 
     global.s_hidden_unique_candidate=TRUE;
     global.s_visible_doublets_triplets_etc=TRUE;
     global.s_hidden_doublets_triplets_etc=TRUE;
     global.s_row_and_column_interaction_with_block=TRUE;
     global.s_block_interaction_with_row_and_column=TRUE;
     global.s_block_block_interaction=TRUE;
     global.s_xwing=TRUE;
     global.s_swordfish=TRUE;
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[0])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[1])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[2])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[3])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[4])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[5])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[6])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[7])),TRUE);
  } 

 
  if(page_number==6)
  {
     toolbar_mode=3;
     global.show_status_barF=1;
     global.show_splash_screenF=1;
     global.show_tips_and_tricksF=1;
     sticky_selection=3;
     global.key_movement_fixed_box_no_limit=1;
     global.key_movement_restrictive=0;
     global.show_figures_while_solving=1;
     global.show_console_messegesF=0;
     global.editor_check_puzzle_validity=1;
     global.auto_pencil_in_remove=1;
     global.check_for_conflictF=1;
     global.consider_doubt_text_as_confirm_textF=0;
     global.treat_doubt_as_pencil_in=1;
  
  
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->pradio_tbar[toolbar_mode-1]), TRUE);
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->pradio_sticky[sticky_selection-1]), TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[0])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[1])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[2])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[3])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[4])),FALSE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[5])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[6])),FALSE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[7])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[8])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[9])),TRUE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[10])),FALSE);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[11])),TRUE);
  
   
     gtk_window_resize(GTK_WINDOW(gs_main_window),10, 10);

  } 
 
  return TRUE;
  
}

//88default_button_clicked8888888888888888888888888888888888888888888888888888888888888888888
//88revert_button_clicked88888888888888888888888888888888888888888888888888888888888888888888


gboolean revert_button_clicked (GtkWidget *widget,gpointer data)
{
 
 gint page_number;
 page_number=gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
 
 if(page_number==0)
 {
     char str[100];
     
     
     strcpy(global.player1_name,"player1");
     strcpy(global.player1_ini,"PL1");
     strcpy(global.player2_name,"player2");
     strcpy(global.player2_ini,"PL2");

     board_size_original=tmps->tmp_game.board_size;
     global.time_race=tmps->tmp_game.time_race;
     global.two_player_solveF=tmps->tmp_game.two_player_solveF;
     global.racing_time=tmps->tmp_game.racing_time;
     global.two_player_gameF=tmps->tmp_game.two_player_gameF;
     global.two_player_time_game=tmps->tmp_game.two_player_time_game;
     global.minus_points=tmps->tmp_game.minus_points;
     global.tp_1_time=tmps->tmp_game.tp_1_time;
     global.tp_2_time=tmps->tmp_game.tp_2_time;
     global.wait_time=tmps->tmp_game.wait_time;
     global.tp_total_time=tmps->tmp_game.tp_total_time;
  
  
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->gradio_b[board_size_original-3]), TRUE);
  if(global.two_player_gameF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[0])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[0])),FALSE);
  if(global.time_race==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[1])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[1])),FALSE);
  if(global.two_player_solveF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[2])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[2])),FALSE);
  if(global.two_player_time_game==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[3])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[3])),FALSE);
  
  strcpy(str,number_to_string(global.racing_time));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[0]), (const char*)str);
  strcpy(str,"Player1");  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[1]), (const char*)str);
  strcpy(str,"PL1");  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[2]), (const char*)str);
  strcpy(str,"Player2");  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[3]), (const char*)str);
  strcpy(str,"PL2");  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[4]), (const char*)str);
  strcpy(str,number_to_string(global.minus_points) );  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[5]), (const char*)str);
  strcpy(str,number_to_string(global.tp_1_time) );  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[6]), (const char*)str);
  strcpy(str,number_to_string(global.tp_2_time) );  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[7]), (const char*)str);
  strcpy(str,number_to_string(global.wait_time) );  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[8]), (const char*)str);
  strcpy(str,number_to_string(global.tp_total_time) );  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[9]), (const char*)str);
 
 }


 if(page_number==1)
 {
   strcpy(pick_box_font,tmps->tmp_font.pick_box_font);
   strcpy(puzzle_box_font,tmps->tmp_font.puzzle_box_font);
   strcpy(pencil_in_font,tmps->tmp_font.pencil_in_font);
   strcpy(status_text,tmps->tmp_font.status_text);
   strcpy(score_text,tmps->tmp_font.score_text);
   initialize_board();  
   draw_puzzle();
  
   gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[0]),(const char*)pick_box_font);
   gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[1]),(const char*)puzzle_box_font);
   gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[2]),(const char*)pencil_in_font);
   gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[3]),(const char*)status_text);
   gtk_font_button_set_font_name(GTK_FONT_BUTTON(tmps->ffont_button[4]),(const char*)score_text);
 }
 
 
 if(page_number==2)
 {
   char pick_txt[20];
   char puzz_txt[20];
   short tmp,len,i;
   pick_square_size=tmps->tmp_size.pick_square_size;
   puzzle_box_square_size=tmps->tmp_size.puzzle_box_square_size;
  
   tmp=pick_square_size;
   len=0;
   while(tmp>0)
   {
     tmp=tmp/10;
     len=len+1;
   }
  
   tmp=pick_square_size;
   for(i=len;i>0;i--)
   {
     pick_txt[i-1]=48+tmp%10;
     tmp=tmp/10;   
   }
   pick_txt[len]='\0';
  
   tmp=puzzle_box_square_size;
   len=0;
   while(tmp>0)
   {
     tmp=tmp/10;
     len=len+1;
   }
  
   tmp=puzzle_box_square_size;
   for(i=len;i>0;i--)
   {
     puzz_txt[i-1]=48+tmp%10;
     tmp=tmp/10;   
   }
   puzz_txt[len]='\0';
  
   initialize_board();
   draw_puzzle();
  
   gtk_entry_set_text(GTK_ENTRY(tmps->sztext_entry[1]),(const char*)pick_txt);
   gtk_entry_set_text(GTK_ENTRY(tmps->sztext_entry[2]),(const char*)puzz_txt);
 }
 
 if(page_number==3)
 {
  
  color=tmps->tmp_color;
  draw_puzzle();
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][1]),&color.hl_light);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][2]),&color.hl_dark);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][3]),&color.pick_selected_bg);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][4]),&color.pick_selected);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][5]),&color.conf_text);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][6]),&color.doubt_text);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][7]),&color.status_text_color);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[1][8]),&color.score_text_color);

  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][1]),&color.puzzle_bg);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][2]),&color.puzzle_lines);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][3]),&color.num_fixed_box_bg);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][4]),&color.puzzle_selected);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][5]),&color.key_box);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][6]),&color.conflict_lines);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][7]),&color.num_fixed_text);
  gtk_color_button_set_color(GTK_COLOR_BUTTON(tmps->ccolor_button[2][8]),&color.pencil_in);
  
 }

 if(page_number==4)
 {
   
   char str[12];
   short tmp_val;
   short len,i;
   
   global.guess_threshold=tmps->tmp_gen.guess_threshold;
   global.symmetric_puzzleF=tmps->tmp_gen.symmetric_puzzleF;
   global.g_hidden_unique_candidate=tmps->tmp_gen.g_hidden_unique_candidate;
   global.g_visible_doublets_triplets_etc=tmps->tmp_gen.g_visible_doublets_triplets_etc;
   global.g_hidden_doublets_triplets_etc=tmps->tmp_gen.g_hidden_doublets_triplets_etc;
   global.g_row_and_column_interaction_with_block=tmps->tmp_gen.g_row_and_column_interaction_with_block;
   global.g_block_interaction_with_row_and_column=tmps->tmp_gen.g_block_interaction_with_row_and_column;
   global.g_block_block_interaction=tmps->tmp_gen.g_block_block_interaction;
   global.g_xwing=tmps->tmp_gen.g_xwing;
   global.g_swordfish=tmps->tmp_gen.g_swordfish;
 
   tmp_val=global.guess_threshold;
   len=0;
   while(tmp_val>0)
   {
     tmp_val=tmp_val/10;
     len=len+1;
   }
  
   tmp_val=global.guess_threshold;
   for(i=len-1;i>=0;i--)
   {
     str[i]=48+tmp_val%10;  
     tmp_val=tmp_val/10;
   }
   str[len]='\0';
   gtk_entry_set_text(GTK_ENTRY(tmps->gentext_entry), (const char*)str);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[0])),global.symmetric_puzzleF);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[1])),global.g_hidden_unique_candidate);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[2])),global.g_visible_doublets_triplets_etc);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[3])),global.g_hidden_doublets_triplets_etc);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[4])),global.g_row_and_column_interaction_with_block);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[5])),global.g_block_interaction_with_row_and_column);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[6])),global.g_block_block_interaction);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[7])),global.g_xwing);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[8])),global.g_swordfish);
 
 } 
 
 if(page_number==5)
 {
 
   global.s_hidden_unique_candidate=TRUE;
   global.s_visible_doublets_triplets_etc=TRUE;
   global.s_hidden_doublets_triplets_etc=TRUE;
   global.s_row_and_column_interaction_with_block=TRUE;
   global.s_block_interaction_with_row_and_column=TRUE;
   global.s_block_block_interaction=TRUE;
   global.s_xwing=TRUE;
   global.s_swordfish=TRUE;
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[0])),global.g_hidden_unique_candidate);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[1])),global.g_visible_doublets_triplets_etc);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[2])),global.g_hidden_doublets_triplets_etc);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[3])),global.g_row_and_column_interaction_with_block);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[4])),global.g_block_interaction_with_row_and_column);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[5])),global.g_xwing);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[6])),global.g_block_block_interaction);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[7])),global.g_swordfish);
 
 } 

 
 if(page_number==6)
 {
 
     toolbar_mode=tmps->tmp_pref.toolbar_mode;
     global.show_status_barF=tmps->tmp_pref.show_status_barF;
     global.show_splash_screenF=tmps->tmp_pref.show_splash_screenF;
     global.show_tips_and_tricksF=tmps->tmp_pref.show_tips_and_tricksF;
     sticky_selection=tmps->tmp_pref.sticky_selection;
     global.key_movement_fixed_box_no_limit=tmps->tmp_pref.key_movement_fixed_box_no_limit;
     global.key_movement_restrictive=tmps->tmp_pref.key_movement_restrictive;
     global.show_figures_while_solving=tmps->tmp_pref.show_figures_while_solving;
     global.show_console_messegesF=tmps->tmp_pref.show_console_messegesF;
     global.editor_check_puzzle_validity=tmps->tmp_pref.editor_check_puzzle_validity;
     global.auto_pencil_in_remove=tmps->tmp_pref.auto_pencil_in_remove;
     global.check_for_conflictF=tmps->tmp_pref.check_for_conflictF;
     global.consider_doubt_text_as_confirm_textF=tmps->tmp_pref.consider_doubt_text_as_confirm_textF;
     global.treat_doubt_as_pencil_in=tmps->tmp_pref.treat_doubt_as_pencil_in;
  
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->pradio_tbar[toolbar_mode-1]), TRUE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->pradio_sticky[sticky_selection-1]), TRUE);
  if(global.show_status_barF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[0])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[0])),FALSE);
  
  if(global.show_splash_screenF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[1])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[1])),FALSE);
  
  if(global.show_tips_and_tricksF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[2])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[2])),FALSE);
  
  if(global.key_movement_fixed_box_no_limit==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[3])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[3])),FALSE);
  
  if(global.key_movement_restrictive==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[4])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[4])),FALSE);
  
  if(global.show_figures_while_solving==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[5])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[5])),FALSE);
  
  if(global.show_console_messegesF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[6])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[6])),FALSE);
  
  if(global.editor_check_puzzle_validity==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[7])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[7])),FALSE);
  
  if(global.auto_pencil_in_remove==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[8])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[8])),FALSE);
  
  if(global.check_for_conflictF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[9])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[9])),FALSE);
  
  if(global.consider_doubt_text_as_confirm_textF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[10])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[10])),FALSE);
  
  if(global.treat_doubt_as_pencil_in==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[11])),TRUE);
  else
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[11])),FALSE);
     
  gtk_window_resize(GTK_WINDOW(gs_main_window),10, 10);

 }

 return TRUE;
 
}

//88revert_button_clicked88888888888888888888888888888888888888888888888888888888888888888888
//88create_liststore8888888888888888888888888888888888888888888888888888888888888888888888888

GtkListStore *create_liststore(void)
{

  GtkListStore *store;
  GtkTreeIter iter;
  GdkPixbuf *icon;
  GError *error=NULL;

  store=gtk_list_store_new(NUM_COLS,GDK_TYPE_PIXBUF,G_TYPE_STRING);

  icon=gdk_pixbuf_new_from_file("icons/game.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon, COL_TEXT,"Game",-1);

  icon=gdk_pixbuf_new_from_file("icons/font.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon,COL_TEXT,"Font",-1);

  icon=gdk_pixbuf_new_from_file("icons/size.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon, COL_TEXT,"Size",-1);

  icon=gdk_pixbuf_new_from_file("icons/color.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon, COL_TEXT,"Colors",-1);

  icon=gdk_pixbuf_new_from_file("icons/generator.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon, COL_TEXT,"Generator",-1);

 icon=gdk_pixbuf_new_from_file("icons/solver.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon, COL_TEXT,"Solver",-1);

  icon=gdk_pixbuf_new_from_file("icons/preference.png",&error);
  gtk_list_store_append(store,&iter);
  gtk_list_store_set(store,&iter,COL_ICON,icon, COL_TEXT,"Preference",-1);

return store;
}

//88create_liststore8888888888888888888888888888888888888888888888888888888888888888888888888
//88create_view_and_model88888888888888888888888888888888888888888888888888888888888888888888

GtkWidget* create_view_and_model(void)
{

  GtkTreeViewColumn *col;
  GtkCellRenderer *renderer;
  GtkTreeModel *model;
  GtkWidget *view;

  model=GTK_TREE_MODEL(create_liststore());

  view=gtk_tree_view_new_with_model(model);

  col=gtk_tree_view_column_new();
  gtk_tree_view_column_set_title(col,"Title");
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW(view),FALSE);

  renderer=gtk_cell_renderer_pixbuf_new();
  gtk_cell_renderer_set_fixed_size (renderer,-1,52);
  gtk_tree_view_column_pack_start(col,renderer,FALSE);
  gtk_tree_view_column_set_attributes(col,renderer,"pixbuf",COL_ICON,NULL);


  renderer=gtk_cell_renderer_text_new();
  gtk_tree_view_column_pack_start(col,renderer,TRUE);
  gtk_tree_view_column_set_attributes(col,renderer,"text",COL_TEXT,NULL);


  gtk_tree_view_append_column(GTK_TREE_VIEW(view),col);

  gtk_widget_show_all(view);



  return view;

}

//88create_view_and_model88888888888888888888888888888888888888888888888888888888888888888888
//88change_gcheckbox8888888888888888888888888888888888888888888888888888888888888888888888888

void change_gcheckbox(GtkWidget *widget, gpointer data)
{

  char str[2];
  strcpy(str,(gchar *) data);

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GTK_CHECK_BUTTON(widget)))  ) 
  {
    if(str[0]=='0')
    {
      global.two_player_gameF=TRUE;
      gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions, (const gchar*)"two")), TRUE);
    }
   
    if(str[0]=='1')
      global.time_race=TRUE;
    if(str[0]=='2')
      global.two_player_solveF=TRUE;
    if(str[0]=='3')
      global.two_player_time_game=TRUE;
  }
  else
  { 
    if(str[0]=='0')
    {
      global.two_player_gameF=FALSE;
      gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions, (const gchar*)"one")), TRUE);
    }
    if(str[0]=='1')
      global.time_race=FALSE;
    if(str[0]=='2')
      global.two_player_solveF=FALSE;
    if(str[0]=='3')
      global.two_player_time_game=FALSE;
 
  }
 
 
  if(str[0]=='0' || str[0]=='1' || str[0]=='3') 
  {
    
    if(global.two_player_gameF==TRUE)
    {
      if(global.two_player_time_game==TRUE)
        gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
      else
        gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
    }
    else
    {
      if(global.time_race==TRUE)
        gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
      else
        gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
    }
   
  }

 
 
}

//88change_gcheckbox8888888888888888888888888888888888888888888888888888888888888888888888888
//88change_gradio8888888888888888888888888888888888888888888888888888888888888888888888888888

void change_gradio(GtkWidget *widget, gpointer data)
{

  char str[2];
  strcpy(str,(gchar *) data);


  if(str[0]=='0')
  {
    board_size_original=3;
    gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions, (const gchar*)"three")), TRUE);
  }  
 
  if(str[0]=='1')
  {  
    board_size_original=4;
    gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions, (const gchar*)"four")), TRUE);
  }  
 

}

//88change_gradio8888888888888888888888888888888888888888888888888888888888888888888888888888
//88gtext_boxes_key88888888888888888888888888888888888888888888888888888888888888888888888888
gboolean gtext_boxes_key(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
{

  int key_pressed;
// short event_state;
  char str[2];
  char entry_str[12];
  
  key_pressed=event->keyval;
// event_state=event->state;

  strcpy(str,(gchar *) data);
   
  if(key_pressed==65293)
  {
 
    if(str[0]=='0')
    {
      strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      global.racing_time=string_to_number(entry_str);
      timing.tp_total_time=global.racing_time;
    }
 
    if(str[0]=='1')
    {
      strcpy(global.player1_name,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      strcpy(sec_copy.player1_name,global.player1_name);
      if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
        status_bar_update_tp_whoes_turn();
    }
   
    if(str[0]=='2')
    {
      strcpy(global.player1_ini,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      strcpy(sec_copy.player1_ini,global.player1_ini);
      if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
      {  
	  draw_score(0,global.p1_points);
          initialize_board();
          draw_puzzle();
      }
       
    }
   
    if(str[0]=='3')
    {
      strcpy(global.player2_name,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      strcpy(sec_copy.player2_name,global.player2_name);
      if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
        status_bar_update_tp_whoes_turn();
    }
   
    if(str[0]=='4')
    {
      strcpy(global.player2_ini,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      strcpy(sec_copy.player2_ini,global.player2_ini);
      if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
      {    
	  draw_score(1,global.p2_points);
          initialize_board();
          draw_puzzle();
      }
    
    }
   
    if(str[0]=='5')
    {
      strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      global.minus_points=string_to_number(entry_str);
    }
   
    if(str[0]=='6')
    {
      strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      global.tp_1_time=string_to_number(entry_str);
      timing.tp_1_time=global.tp_1_time;
      timing.tp_1_time=global.tp_1_time;
    }
   
    if(str[0]=='7')
    {
      strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      global.tp_2_time=string_to_number(entry_str);
      timing.tp_2_time=global.tp_1_time;
      timing.tp_2_time=global.tp_2_time;
    }
   
    if(str[0]=='8')
    {
      strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      global.wait_time=string_to_number(entry_str);
      timing.wait_time= global.wait_time;
    }
   
    if(str[0]=='9')
    {
      strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      global.tp_total_time=string_to_number(entry_str);
      timing.tp_total_time=global.tp_total_time;
    }
   
    return TRUE;
  }
  else if( (key_pressed>=48 &&  key_pressed<=57) || key_pressed==65288 || key_pressed==65535 ||
           (key_pressed>=65361 &&  key_pressed<=65364) || str[0]=='1'|| str[0]=='2'|| str[0]=='3'|| str[0]=='4')
    return FALSE;
  else
    return TRUE;


}

//88gtext_boxes_key88888888888888888888888888888888888888888888888888888888888888888888888888
//88gtext_boxes_focus_out88888888888888888888888888888888888888888888888888888888888888888888

gboolean gtext_boxes_focus_out(GtkWidget *text_entry, GdkEventFocus *event,gpointer data)
{
 
  char str[2];
  char entry_str[12];
  strcpy(str,(gchar *) data);
 
  if(str[0]=='0')
  {
    strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    global.racing_time=string_to_number(entry_str);
    timing.tp_total_time=global.racing_time;
  }
 
  if(str[0]=='1')
  {
    strcpy(global.player1_name,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    strcpy(sec_copy.player1_name,global.player1_name);
    if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
     status_bar_update_tp_whoes_turn();
  }
   
  if(str[0]=='2')
  {
    strcpy(global.player1_ini,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    strcpy(sec_copy.player1_ini,global.player1_ini);
      if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
      {    
	  draw_score(0,global.p1_points);
          initialize_board();
          draw_puzzle();
      }
    
  }
  
  if(str[0]=='3')
  {
    strcpy(global.player2_name,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    strcpy(sec_copy.player2_name,global.player2_name);
    if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
     status_bar_update_tp_whoes_turn();
  }
   
  if(str[0]=='4')
  {
    strcpy(global.player2_ini,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    strcpy(sec_copy.player2_ini,global.player2_ini);
      if(global.two_player_game==TRUE && global.edit_modeF==FALSE)
      {
          draw_score(1,global.p2_points);
          initialize_board();
          draw_puzzle();
      }
  }
   
  if(str[0]=='5')
  {
    strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    global.minus_points=string_to_number(entry_str);
  }
   
  if(str[0]=='6')
  {
    strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    global.tp_1_time=string_to_number(entry_str);
    timing.tp_1_time=global.tp_1_time;
  }
   
  if(str[0]=='7')
  {
    strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    global.tp_2_time=string_to_number(entry_str);
    timing.tp_2_time=global.tp_2_time;
  }
   
  if(str[0]=='8')
  {
    strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    global.wait_time=string_to_number(entry_str);
    timing.wait_time=global.wait_time;
  }
   
  if(str[0]=='9')
  {
    strcpy(entry_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    global.tp_total_time=string_to_number(entry_str);
    timing.tp_total_time=global.tp_total_time;
  }
  
  return FALSE;
  
}

//88gtext_boxes_focus_out88888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_game8888888888888888888888888888888888888888888888888888888888888888888888
void settings_stuff_game(GtkWidget *game_widget)
{

 char str[100];
 
 GtkWidget *vbox;
 GtkWidget *label;
 GtkWidget *frame;
 GtkWidget *table;
 GtkWidget *check_button;
 GtkWidget *text_entry;
 GtkWidget *combo_box;
 
 GSList *group;
 
 
 
  table = gtk_table_new (1, 3, FALSE);
  gtk_box_pack_start (GTK_BOX (game_widget),table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),2);
  
   
  label=gtk_label_new("Puzzle size");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 0, 1);
  gtk_widget_show(label);
 
  tmps->gradio_b[0] = gtk_radio_button_new_with_label (NULL, "3x3");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gradio_b[0], 1, 2, 0, 1);
  gtk_widget_show (tmps->gradio_b[0]);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (tmps->gradio_b[0]));
  g_signal_connect (G_OBJECT (tmps->gradio_b[0]), "toggled", G_CALLBACK (change_gradio), "0");
 
 
 
  tmps->gradio_b[1] = gtk_radio_button_new_with_label (group, "4x4");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gradio_b[1], 2, 3, 0, 1);
  gtk_widget_show (tmps->gradio_b[1]);
  g_signal_connect (G_OBJECT (tmps->gradio_b[1]), "toggled", G_CALLBACK (change_gradio), "1");

 
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->gradio_b[board_size_original-3]), TRUE);
  gtk_widget_show(table);

  tmps->gcheck_box[0]=gtk_check_button_new_with_label("Two player game");
  gtk_box_pack_start (GTK_BOX (game_widget),tmps->gcheck_box[0], FALSE, TRUE, 0);
  if(global.two_player_gameF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[0])),TRUE);
  gtk_widget_show (tmps->gcheck_box[0]);
  g_signal_connect (G_OBJECT (tmps->gcheck_box[0]), "toggled", G_CALLBACK (change_gcheckbox), "0");
 
// hseperator=gtk_hseparator_new();
// gtk_box_pack_start (GTK_BOX (game_widget),hseperator, FALSE, TRUE, 0);
// gtk_widget_show(hseperator);
 
 
  frame=gtk_frame_new( "Single Player Game" );
  gtk_box_pack_start (GTK_BOX (game_widget), frame, FALSE, TRUE, 6);

 
  table = gtk_table_new (2, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
    
  gtk_table_set_row_spacings (GTK_TABLE (table),6);

  tmps->gcheck_box[1]=gtk_check_button_new_with_label("Time race");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gcheck_box[1], 0, 1, 0, 1);
  if(global.time_race==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[1])),TRUE);
  gtk_widget_show (tmps->gcheck_box[1]);
  g_signal_connect (G_OBJECT (tmps->gcheck_box[1]), "toggled", G_CALLBACK (change_gcheckbox), "1");

  tmps->gcheck_box[2]=gtk_check_button_new_with_label("Two player solve");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gcheck_box[2], 1, 2, 0, 1);
  if(global.two_player_solveF==TRUE)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[2])),TRUE);
  gtk_widget_show (tmps->gcheck_box[2]);
  g_signal_connect (G_OBJECT (tmps->gcheck_box[2]), "toggled", G_CALLBACK (change_gcheckbox), "2");
    
  label=gtk_label_new(" Time in seconds:");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 1, 2);
  gtk_widget_show(label);
  
  
  tmps->gt_entry[0]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[0], 1, 2, 1, 2);
  gtk_widget_show (tmps->gt_entry[0]);
  
  strcpy(str,number_to_string(global.racing_time));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[0]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[0]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"0");
  g_signal_connect (G_OBJECT (tmps->gt_entry[0]), "key_press_event",G_CALLBACK (gtext_boxes_key),"0");

    
  gtk_widget_show(table);
  gtk_widget_show(frame);
 
//================
  frame=gtk_frame_new( "Two Player Game" );
  gtk_box_pack_start (GTK_BOX (game_widget), frame, FALSE, TRUE, 0);
 
  vbox =gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  gtk_container_set_border_width(GTK_CONTAINER(vbox),5);
  
  table = gtk_table_new (2, 4, FALSE);
  gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),9);
     
  gtk_table_set_col_spacing (GTK_TABLE (table),1,18);
  gtk_table_set_row_spacing (GTK_TABLE (table),0,2);

  
  label=gtk_label_new("Player1 name");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,GTK_SHRINK,GTK_SHRINK,6,0);
  gtk_widget_show(label);
  tmps->gt_entry[1]=gtk_entry_new();
  gtk_widget_set_size_request(tmps->gt_entry[1],122,-1);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[1], 1, 2, 0, 1);
  gtk_widget_show (tmps->gt_entry[1]);
  strcpy(str,global.player1_name);  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[1]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[1]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"1");
  g_signal_connect (G_OBJECT (tmps->gt_entry[1]), "key_press_event",G_CALLBACK (gtext_boxes_key),"1");
    
  
  
  label=gtk_label_new("initial");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 2, 3, 0, 1,GTK_SHRINK,GTK_SHRINK,6,0);
  gtk_widget_show(label);
  tmps->gt_entry[2]=gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(tmps->gt_entry[2]),3);
  gtk_widget_set_size_request(tmps->gt_entry[2],42,-1);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[2], 3, 4, 0, 1);
  gtk_widget_show (tmps->gt_entry[2]);
  strcpy(str,global.player1_ini);  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[2]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[2]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"2");
  g_signal_connect (G_OBJECT (tmps->gt_entry[2]), "key_press_event",G_CALLBACK (gtext_boxes_key),"2");

  
  label=gtk_label_new("Player2 name");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,GTK_SHRINK,GTK_SHRINK,6,0);
  gtk_widget_show(label);
  tmps->gt_entry[3]=gtk_entry_new();
  gtk_widget_set_size_request(tmps->gt_entry[3],122,-1);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[3], 1, 2, 1, 2);
  gtk_widget_show (tmps->gt_entry[3]);
  strcpy(str,global.player2_name);  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[3]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[3]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"3");
  g_signal_connect (G_OBJECT (tmps->gt_entry[3]), "key_press_event",G_CALLBACK (gtext_boxes_key),"3");

  
        
  label=gtk_label_new("initial");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 2, 3, 1, 2,GTK_SHRINK,GTK_SHRINK,6,0);
  gtk_widget_show(label);
  tmps->gt_entry[4]=gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(tmps->gt_entry[4]),3);
  gtk_widget_set_size_request(tmps->gt_entry[4],42,-1);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[4], 3, 4, 1, 2);
  gtk_widget_show (tmps->gt_entry[4]);
  strcpy(str,global.player2_ini);  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[4]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[4]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"4");
  g_signal_connect (G_OBJECT (tmps->gt_entry[4]), "key_press_event",G_CALLBACK (gtext_boxes_key),"4");

    
  gtk_widget_show(table);

   
  
  table = gtk_table_new (1, 2, FALSE);
  gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, TRUE, 0);
  gtk_table_set_col_spacings (GTK_TABLE (table),22);
  gtk_container_set_border_width(GTK_CONTAINER(table),9);
  label=gtk_label_new("minus point");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 3, 4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->gt_entry[5]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[5], 1, 2, 3, 4);
  gtk_widget_show (tmps->gt_entry[5]);
  strcpy(str,number_to_string(global.minus_points));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[5]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[5]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"5");
  g_signal_connect (G_OBJECT (tmps->gt_entry[5]), "key_press_event",G_CALLBACK (gtext_boxes_key),"5");
      
  gtk_widget_show(table);
  
  
  
  
  
  
  table = gtk_table_new (5, 2, FALSE);
  gtk_box_pack_end (GTK_BOX (vbox), table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),9);
  gtk_table_set_row_spacings (GTK_TABLE (table),4);

  tmps->gcheck_box[3]=gtk_check_button_new_with_label("Time game");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gcheck_box[3], 0, 1, 0, 1);
  if(global.two_player_time_game==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gcheck_box[3])),TRUE);
  gtk_widget_show (tmps->gcheck_box[3]);
  g_signal_connect (G_OBJECT (tmps->gcheck_box[3]), "toggled", G_CALLBACK (change_gcheckbox), "3");
  
  label=gtk_label_new("Player1 Sec/Move");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->gt_entry[6]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[6], 1, 2, 1, 2);
  gtk_widget_show (tmps->gt_entry[6]);
  strcpy(str,number_to_string(global.tp_1_time));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[6]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[6]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"6");
  g_signal_connect (G_OBJECT (tmps->gt_entry[6]), "key_press_event",G_CALLBACK (gtext_boxes_key),"6");

    
  label=gtk_label_new("Player2 Sec/Move");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 2, 3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->gt_entry[7]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[7], 1, 2, 2, 3);
  gtk_widget_show (tmps->gt_entry[7]);
  strcpy(str,number_to_string(global.tp_2_time));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[7]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[7]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"7");
  g_signal_connect (G_OBJECT (tmps->gt_entry[7]), "key_press_event",G_CALLBACK (gtext_boxes_key),"7");
  
  
  label=gtk_label_new("Wait time");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 3, 4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->gt_entry[8]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[8], 1, 2, 3, 4);
  gtk_widget_show (tmps->gt_entry[8]);
  strcpy(str,number_to_string(global.wait_time));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[8]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[8]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"8");
  g_signal_connect (G_OBJECT (tmps->gt_entry[8]), "key_press_event",G_CALLBACK (gtext_boxes_key),"8");

  label=gtk_label_new("Total time in min");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 4, 5,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->gt_entry[9]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->gt_entry[9], 1, 2, 4, 5);
  gtk_widget_show (tmps->gt_entry[9]);
  strcpy(str,number_to_string(global.tp_total_time));  
  gtk_entry_set_text(GTK_ENTRY(tmps->gt_entry[9]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->gt_entry[9]), "focus_out_event",G_CALLBACK (gtext_boxes_focus_out),"9");
  g_signal_connect (G_OBJECT (tmps->gt_entry[9]), "key_press_event",G_CALLBACK (gtext_boxes_key),"9");
      
  gtk_widget_show(table);
  
  
  
  gtk_widget_show(vbox);
  gtk_widget_show(frame);

   
}

//88settings_stuff_game8888888888888888888888888888888888888888888888888888888888888888888888
//88choose_notebook_tab8888888888888888888888888888888888888888888888888888888888888888888888

void choose_notebook_tab  (GtkTreeView *treeview,  gpointer user_data)
{

  GtkTreeSelection *selection;
  GtkTreeModel *model;
  GtkTreeIter iter;

  selection=gtk_tree_view_get_selection (treeview);

  if(gtk_tree_selection_get_selected (selection,&model,&iter) )
  {
     gchar *name;
     gint   int_data;
     GtkListStore *list_store;
     GdkPixbuf *icon;      
      
     gtk_tree_model_get (model, &iter,COL_TEXT,&name,-1);
       
  

     if( strcmp(name,"Game")==0 && which_settings_dialog_active!=1)
     {
       
       which_settings_dialog_active=1;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }
     if( strcmp(name,"Font")==0 && which_settings_dialog_active!=2)
     {
       which_settings_dialog_active=2;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }
     if( strcmp(name,"Size")==0 && which_settings_dialog_active!=3)
     {
       which_settings_dialog_active=3;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }
     if( strcmp(name,"Colors")==0 && which_settings_dialog_active!=4)
     {
       which_settings_dialog_active=4;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }
     if( strcmp(name,"Generator")==0 && which_settings_dialog_active!=5)
     {
       which_settings_dialog_active=5;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }
     if( strcmp(name,"Solver")==0 && which_settings_dialog_active!=6)
     {
       which_settings_dialog_active=6;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }
     if( strcmp(name,"Preference")==0 && which_settings_dialog_active!=7)
     {
       which_settings_dialog_active=7;
       gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook),which_settings_dialog_active-1);
     }

     //g_print("%d",which_settings_dialog_active);
  }

}

//88choose_notebook_tab8888888888888888888888888888888888888888888888888888888888888888888888
//88change_font888888888888888888888888888888888888888888888888888888888888888888888888888888

void change_font(GtkFontButton *font_button, gpointer data)
{
 
  char str[20];
  guint16 alpha;
  strcpy(str,(gchar *) data);
  
  if(str[0]=='0')
  {
    strcpy(pick_box_font,gtk_font_button_get_font_name(GTK_FONT_BUTTON(font_button)) );
  }
 
  if(str[0]=='1')
  {
    strcpy(puzzle_box_font,gtk_font_button_get_font_name(GTK_FONT_BUTTON(font_button)) );
  }
 
  if(str[0]=='2')
  {
    strcpy(pencil_in_font,gtk_font_button_get_font_name(GTK_FONT_BUTTON(font_button)) );
  }
 
  if(str[0]=='3')
  {
    strcpy(status_text,gtk_font_button_get_font_name(GTK_FONT_BUTTON(font_button)) );
  }
 
  if(str[0]=='4')
  {
    strcpy(score_text,gtk_font_button_get_font_name(GTK_FONT_BUTTON(font_button)) );
  }
      
  initialize_board();
  draw_puzzle();
}

//88change_font888888888888888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_font8888888888888888888888888888888888888888888888888888888888888888888888

void settings_stuff_font(GtkWidget *font_widget)
{

  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *font_button;

  frame=gtk_frame_new( "Font" );
  gtk_box_pack_start (GTK_BOX (font_widget), frame, FALSE, TRUE, 0);

  table = gtk_table_new (5, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),24);

  
  label=gtk_label_new("Pick box font");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->ffont_button[0]=gtk_font_button_new_with_font(pick_box_font);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ffont_button[0], 1, 2, 0, 1);
  gtk_widget_show(tmps->ffont_button[0]);
  g_signal_connect (G_OBJECT (tmps->ffont_button[0]), "font_set",G_CALLBACK (change_font),"0pick_font");

  
  label=gtk_label_new("Puzzle box font");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->ffont_button[1]= gtk_font_button_new_with_font   (puzzle_box_font); 
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ffont_button[1], 1, 2, 1, 2);
  gtk_widget_show(tmps->ffont_button[1]);
  g_signal_connect (G_OBJECT (tmps->ffont_button[1]), "font_set",G_CALLBACK (change_font),"1puzz_font");

  
  label=gtk_label_new("Pencil in font");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 2, 3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->ffont_button[2]=gtk_font_button_new_with_font(pencil_in_font);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ffont_button[2], 1, 2, 2, 3);
  gtk_widget_show(tmps->ffont_button[2]);
  g_signal_connect (G_OBJECT (tmps->ffont_button[2]), "font_set",G_CALLBACK (change_font),"2penc_font");

  
  label=gtk_label_new("Time display font");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 3, 4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->ffont_button[3]=gtk_font_button_new_with_font(status_text);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ffont_button[3], 1, 2, 3, 4);
  gtk_widget_show(tmps->ffont_button[3]);
  g_signal_connect (G_OBJECT (tmps->ffont_button[3]), "font_set",G_CALLBACK (change_font),"3time_font");

  
  label=gtk_label_new("Score text font");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 4, 5,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  tmps->ffont_button[4]=gtk_font_button_new_with_font(score_text);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ffont_button[4], 1, 2, 4, 5);
  gtk_widget_show(tmps->ffont_button[4]);
  g_signal_connect (G_OBJECT (tmps->ffont_button[4]),"font_set",G_CALLBACK (change_font),"4score_font");
  
     
  gtk_widget_show(table);
  gtk_widget_show(frame);


}

//88settings_stuff_font8888888888888888888888888888888888888888888888888888888888888888888888
//88change_color98888888888888888888888888888888888888888888888888888888888888888888888888888

void change_color(GtkColorButton *color_button, gpointer data)
{

  char str[20];
  guint16 alpha;
  GdkColor tmp_color;
  strcpy(str,(gchar *) data);
 
  if(str[0]=='1' && str[1]=='1')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.hl_light,1);
    color.hl_light.red = tmp_color.red;
    color.hl_light.blue = tmp_color.blue;
    color.hl_light.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.hl_light );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='2')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.hl_dark,1);
    color.hl_dark.red = tmp_color.red;
    color.hl_dark.blue = tmp_color.blue;
    color.hl_dark.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.hl_dark );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='3')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.pick_selected_bg,1);
    color.pick_selected_bg.red = tmp_color.red;
    color.pick_selected_bg.blue = tmp_color.blue;
    color.pick_selected_bg.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pick_selected_bg );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='4')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.pick_selected,1);
    color.pick_selected.red = tmp_color.red;
    color.pick_selected.blue = tmp_color.blue;
    color.pick_selected.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pick_selected );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='5')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.conf_text,1);
    color.conf_text.red = tmp_color.red;
    color.conf_text.blue = tmp_color.blue;
    color.conf_text.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.conf_text );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='6')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.doubt_text,1);
    color.doubt_text.red = tmp_color.red;
    color.doubt_text.blue = tmp_color.blue;
    color.doubt_text.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.doubt_text );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='7')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.status_text_color,1);
    color.status_text_color.red = tmp_color.red;
    color.status_text_color.blue = tmp_color.blue;
    color.status_text_color.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.status_text_color );
    draw_puzzle();
  }

  if(str[0]=='1' && str[1]=='8')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.score_text_color,1);
    color.score_text_color.red = tmp_color.red;
    color.score_text_color.blue = tmp_color.blue;
    color.score_text_color.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.score_text_color );
    draw_puzzle();
  }

//=========

  if(str[0]=='2' && str[1]=='1') 
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.puzzle_bg,1);
    color.puzzle_bg.red = tmp_color.red;
    color.puzzle_bg.blue = tmp_color.blue;
    color.puzzle_bg.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_bg );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='2')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.puzzle_lines,1);
    color.puzzle_lines.red = tmp_color.red;
    color.puzzle_lines.blue = tmp_color.blue;
    color.puzzle_lines.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_lines );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='3')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.num_fixed_box_bg,1);
    color.num_fixed_box_bg.red = tmp_color.red;
    color.num_fixed_box_bg.blue = tmp_color.blue;
    color.num_fixed_box_bg.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.num_fixed_box_bg );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='4')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.puzzle_selected,1);
    color.puzzle_selected.red = tmp_color.red;
    color.puzzle_selected.blue = tmp_color.blue;
    color.puzzle_selected.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.puzzle_selected );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='5')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.key_box,1);
    color.key_box.red = tmp_color.red;
    color.key_box.blue = tmp_color.blue;
    color.key_box.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.key_box );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='6')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.conflict_lines,1);
    color.conflict_lines.red = tmp_color.red;
    color.conflict_lines.blue = tmp_color.blue;
    color.conflict_lines.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.conflict_lines );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='7')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.num_fixed_text,1);
    color.num_fixed_text.red = tmp_color.red;
    color.num_fixed_text.blue = tmp_color.blue;
    color.num_fixed_text.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.num_fixed_text );
    draw_puzzle();
  }


  if(str[0]=='2' && str[1]=='8')
  {
    gtk_color_button_get_color (GTK_COLOR_BUTTON(color_button),&tmp_color);
    gdk_colormap_free_colors (colormap,&color.pencil_in,1);
    color.pencil_in.red = tmp_color.red;
    color.pencil_in.blue = tmp_color.blue;
    color.pencil_in.green = tmp_color.green;
    gdk_color_alloc(gtk_widget_get_colormap(drawing_area),&color.pencil_in );
    draw_puzzle();
  }


}

//88change_color88888888888888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_color888888888888888888888888888888888888888888888888888888888888888888888

void settings_stuff_color(GtkWidget *color_widget)
{

 GtkWidget *scroll_window;
 GtkWidget *view_port;
 GtkWidget *box;
 GtkWidget *frame;
 GtkWidget *table;
 GtkWidget *label;
// GtkWidget *color_button;
// GtkWidget *button;

  scroll_window=gtk_scrolled_window_new(NULL,NULL );
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll_window),                               GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW (scroll_window),                              GTK_SHADOW_NONE); 
  
  gtk_box_pack_start (GTK_BOX (color_widget), scroll_window, TRUE, TRUE, 6);

  view_port=gtk_viewport_new(NULL,NULL );
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(view_port),GTK_SHADOW_NONE);
  
  //gtk_box_pack_start (GTK_BOX (color_widget), view_port, TRUE, TRUE, 0);
    
  gtk_container_add (GTK_CONTAINER (scroll_window), view_port);
  
  box=gtk_vbox_new(FALSE,0); 
  //gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scroll_window), box);
  gtk_container_add (GTK_CONTAINER (view_port), box);

  
  frame=gtk_frame_new( "Pick box color configuration" );
  gtk_box_pack_start (GTK_BOX (box), frame, FALSE, TRUE, 0);

  table = gtk_table_new (8, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),64);

  
  label=gtk_label_new("Highlight background color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][1]=gtk_color_button_new_with_color(&color.hl_light);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][1], 1, 2, 0, 1);
  gtk_widget_show(tmps->ccolor_button[1][1]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][1]), "color_set",G_CALLBACK (change_color),"11hl_bg");

  
  label=gtk_label_new("Highlight border color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][2]=gtk_color_button_new_with_color(&color.hl_dark);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][2], 1, 2, 1, 2);
  gtk_widget_show(tmps->ccolor_button[1][2]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][2]), "color_set",G_CALLBACK (change_color),"12hl_bord");

  
  label=gtk_label_new("Selected background color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 2, 3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][3]=gtk_color_button_new_with_color(&color.pick_selected_bg);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][3], 1, 2, 2, 3);
  gtk_widget_show(tmps->ccolor_button[1][3]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][3]), "color_set",G_CALLBACK (change_color),"13sel_bg");

  
  label=gtk_label_new("Selected border color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 3, 4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][4]=gtk_color_button_new_with_color(&color.pick_selected);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][4], 1, 2, 3, 4);
  gtk_widget_show(tmps->ccolor_button[1][4]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][4]), "color_set",G_CALLBACK (change_color),"14sel_bord");

  
  label=gtk_label_new("Confirmed text color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 4, 5,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][5]=gtk_color_button_new_with_color(&color.conf_text);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][5], 1, 2, 4, 5);
  gtk_widget_show(tmps->ccolor_button[1][5]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][5]), "color_set",G_CALLBACK (change_color),"15text_conf");

  
  label=gtk_label_new("Doubt text color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 5, 6,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][6]=gtk_color_button_new_with_color(&color.doubt_text);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][6], 1, 2, 5, 6);
  gtk_widget_show(tmps->ccolor_button[1][6]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][6]), "color_set",G_CALLBACK (change_color),"16text_doubt");

  
  label=gtk_label_new("Time text color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 6, 7,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][7]=gtk_color_button_new_with_color(&color.status_text_color);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][7], 1, 2, 6, 7);
  gtk_widget_show(tmps->ccolor_button[1][7]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][7]), "color_set",G_CALLBACK (change_color),"17text_time");

           
  label=gtk_label_new("Score text color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 7, 8,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[1][8]=gtk_color_button_new_with_color(&color.score_text_color);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[1][8], 1, 2, 7, 8);
  gtk_widget_show(tmps->ccolor_button[1][8]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[1][8]), "color_set",G_CALLBACK (change_color),"18text_score");
  
 
  gtk_widget_show(table);
  gtk_widget_show(frame);

//=================


  frame=gtk_frame_new( "Puzzle box color configuration" );
  gtk_box_pack_start (GTK_BOX (box), frame, FALSE, TRUE, 0);

  table = gtk_table_new (8, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),70);

  
  label=gtk_label_new("normal background color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][1]=gtk_color_button_new_with_color(&color.puzzle_bg);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][1], 1, 2, 0, 1);
  gtk_widget_show(tmps->ccolor_button[2][1]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][1]), "color_set",G_CALLBACK (change_color),"21puz_bg");

  
  label=gtk_label_new("normal border color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][2]=gtk_color_button_new_with_color(&color.puzzle_lines);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][2], 1, 2, 1, 2);
  gtk_widget_show(tmps->ccolor_button[2][2]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][2]), "color_set",G_CALLBACK (change_color),"22puz_bord");

  
  label=gtk_label_new("Fixed background color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 2, 3,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][3]=gtk_color_button_new_with_color(&color.num_fixed_box_bg);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][3], 1, 2, 2, 3);
  gtk_widget_show(tmps->ccolor_button[2][3]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][3]), "color_set",G_CALLBACK (change_color),"23fix_bg");

  
  label=gtk_label_new("Selected border color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 3, 4,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][4]=gtk_color_button_new_with_color(&color.puzzle_selected);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][4], 1, 2, 3, 4);
  gtk_widget_show(tmps->ccolor_button[2][4]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][4]), "color_set",G_CALLBACK (change_color),"24fix_bord");

  
  label=gtk_label_new("Keyboard indicate color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 4, 5,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][5]=gtk_color_button_new_with_color(&color.key_box);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][5], 1, 2, 4, 5);
  gtk_widget_show(tmps->ccolor_button[2][5]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][5]), "color_set",G_CALLBACK (change_color),"25key_indi");

  
  label=gtk_label_new("Conflict Line color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 5, 6,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][6]=gtk_color_button_new_with_color(&color.conflict_lines);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][6], 1, 2, 5, 6);
  gtk_widget_show(tmps->ccolor_button[2][6]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][6]), "color_set",G_CALLBACK (change_color),"26conf_line");

  
  label=gtk_label_new("Fixed text color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 6, 7,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][7]=gtk_color_button_new_with_color(&color.num_fixed_text);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][7], 1, 2, 6, 7);
  gtk_widget_show(tmps->ccolor_button[2][7]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][7]), "color_set",G_CALLBACK (change_color),"27text_fix");

           
  label=gtk_label_new("Pencil in color");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 7, 8,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->ccolor_button[2][8]=gtk_color_button_new_with_color(&color.pencil_in);
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->ccolor_button[2][8], 1, 2, 7, 8);
  gtk_widget_show(tmps->ccolor_button[2][8]);
  g_signal_connect (G_OBJECT (tmps->ccolor_button[2][8]), "color_set",G_CALLBACK (change_color),"28text_penc");

 
  gtk_widget_show(table);
  gtk_widget_show(frame);

  gtk_widget_show (view_port);
  gtk_widget_show (scroll_window);
  gtk_widget_show (box);


}

//88settings_stuff_color888888888888888888888888888888888888888888888888888888888888888888888
//88key_change_size88888888888888888888888888888888888888888888888888888888888888888888888888

gboolean key_change_size(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
{

  int key_pressed;
  short event_state;
  char str[2];
  char size_str[20];
  short len;
  short num,i;
  
  //g_print("%d  %d  %s\n",event->keyval,event->state,event->string);
  key_pressed=event->keyval;
  event_state=event->state;

  if(key_pressed==65293)
  {
    
    strcpy(str,(gchar *) data);
 
    if(str[0]=='1')
    {
      strcpy(size_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      len=strlen(size_str);
      num=0;
      for(i=0;i<len;i++)
      {
        num=num*10;
        num=num+(size_str[i]-48);
      }
      pick_square_size=num;
    }
 
    if(str[0]=='2')
    {
      strcpy(size_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
      len=strlen(size_str);
      num=0;
      for(i=0;i<len;i++)
      {
        num=num*10;
        num=num+(size_str[i]-48);
      }
      puzzle_box_square_size=num;
    }
   
    initialize_board();
    draw_puzzle();
   
    return TRUE;
  }
  else if( (key_pressed>=48 &&  key_pressed<=57) || key_pressed==65288 || key_pressed==65535 ||
           (key_pressed>=65361 &&  key_pressed<=65364)  )
    return FALSE;
  else
    return TRUE;



}

//88key_change_size88888888888888888888888888888888888888888888888888888888888888888888888888
//88change_size888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean change_size(GtkWidget *text_entry, GdkEventFocus *event,gpointer data)
{
 
  char str[2];
  char size_str[20];
  short len;
  short num,i;
  strcpy(str,(gchar *) data);
 
  if(str[0]=='1')
  {
    strcpy(size_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    len=strlen(size_str);
    num=0;
    for(i=0;i<len;i++)
    {
      num=num*10;
      num=num+(size_str[i]-48);
    }
    pick_square_size=num;
  }
 
  if(str[0]=='2')
  {
    strcpy(size_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    len=strlen(size_str);
    num=0;
    for(i=0;i<len;i++)
    {
      num=num*10;
      num=num+(size_str[i]-48);
    }
    
    puzzle_box_square_size=num;
//    g_print("puzzle_box_square_size: %d\n",puzzle_box_square_size);
 
  }
  
  initialize_board();  
  draw_puzzle();

  return FALSE;

}

//88change_size888888888888888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_size(888888888888888888888888888888888888888888888888888888888888888888888

void settings_stuff_size(GtkWidget *size_widget)
{

  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *label;
//  GtkWidget *text_entry;
  char str[12];
  short size;
  short len,i;
 
  frame=gtk_frame_new( "Size" );
  gtk_box_pack_start (GTK_BOX (size_widget), frame, FALSE, TRUE, 0);

  table = gtk_table_new (2, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),24);

  
  label=gtk_label_new("Pick box square size");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
   
  tmps->sztext_entry[1]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->sztext_entry[1], 1, 2, 0, 1);
  gtk_widget_show (tmps->sztext_entry[1]);
  size=pick_square_size;
  len=0;
  while(size>0)
  {
    size=size/10;
    len=len+1;
  }
  
  size=pick_square_size;
  for(i=len-1;i>=0;i--)
  {
    str[i]=48+size%10;  
    size=size/10;
  
  }
  //str[0]='1';
  //str[1]='2';
  //str[2]='\0';
  str[len]='\0';
  gtk_entry_set_text(GTK_ENTRY(tmps->sztext_entry[1]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->sztext_entry[1]), "focus_out_event",G_CALLBACK (change_size),"1");
  g_signal_connect (G_OBJECT (tmps->sztext_entry[1]), "key_press_event",G_CALLBACK (key_change_size),"1");
   
  label=gtk_label_new("Puzzle box square size");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->sztext_entry[2]=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->sztext_entry[2], 1, 2, 1, 2);
  gtk_widget_show (tmps->sztext_entry[2]);
  size=puzzle_box_square_size;
  len=0;
  while(size>0)
  {
    size=size/10;
    len=len+1;
  }
  
  size=puzzle_box_square_size;
  for(i=len-1;i>=0;i--)
  {
    str[i]=48+size%10;  
    size=size/10;
  }
  str[len]='\0';
  
  gtk_entry_set_text(GTK_ENTRY(tmps->sztext_entry[2]), (const char*)str);
  g_signal_connect (G_OBJECT (tmps->sztext_entry[2]), "focus_out_event",G_CALLBACK (change_size),"2");
  g_signal_connect (G_OBJECT (tmps->sztext_entry[2]), "key_press_event",G_CALLBACK (key_change_size),"2");
 
  gtk_widget_show(table);
  gtk_widget_show(frame);


}

//88settings_stuff_size8888888888888888888888888888888888888888888888888888888888888888888888
//88key_change_threshold888888888888888888888888888888888888888888888888888888888888888888888

gboolean key_change_threshold(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
{

  int key_pressed;
  short event_state;
  char str[2];
  char tmp_str[20];
  short len;
  short num,i;
 
  //g_print("%d  %d  %s\n",event->keyval,event->state,event->string);
  key_pressed=event->keyval;
  event_state=event->state;

  if(key_pressed==65293)
  {
    strcpy(tmp_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    len=strlen(tmp_str);
    num=0;
    for(i=0;i<len;i++)
    {
      num=num*10;
      num=num+(tmp_str[i]-48);
    }
    
    global.guess_threshold=num;
    return TRUE;
  }
  else if( (key_pressed>=48 &&  key_pressed<=57) || key_pressed==65288 || key_pressed==65535 ||
         (key_pressed>=65361 &&  key_pressed<=65364)  )
    return FALSE;
  else
    return TRUE;

}

//88key_change_threshold888888888888888888888888888888888888888888888888888888888888888888888
//88change_threshold8888888888888888888888888888888888888888888888888888888888888888888888888

gboolean change_threshold(GtkWidget *text_entry, GdkEventFocus *event,gpointer data)
{
 
  char str[2];
  char tmp_str[20];
  short len;
  short num,i;
 
  strcpy(tmp_str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
  len=strlen(tmp_str);
  num=0;
  for(i=0;i<len;i++)
  {
    num=num*10;
    num=num+(tmp_str[i]-48);
  }
  
  global.guess_threshold=num;
 
  return FALSE;
}

//88change_threshold8888888888888888888888888888888888888888888888888888888888888888888888888
//88check_button_generator8888888888888888888888888888888888888888888888888888888888888888888

void check_button_generator (GtkWidget *widget, gpointer data)
{
 
  char str[2];
  strcpy(str,(gchar *) data);
    
 if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GTK_CHECK_BUTTON(widget)))  ) 
 {
   
   if(str[0]=='0')
    global.symmetric_puzzleF=TRUE;
   if(str[0]=='1')
    global.g_hidden_unique_candidate=TRUE;
   if(str[0]=='2')
    global.g_block_interaction_with_row_and_column=TRUE;
   if(str[0]=='3')
    global.g_row_and_column_interaction_with_block=TRUE;
   if(str[0]=='4')
    global.g_visible_doublets_triplets_etc=TRUE;
   if(str[0]=='5')
    global.g_block_block_interaction=TRUE;
   if(str[0]=='6')
    global.g_hidden_doublets_triplets_etc=TRUE;
   if(str[0]=='7')
    global.g_xwing=TRUE;
   if(str[0]=='8')
    global.g_swordfish=TRUE;
 } 
 else 
 {
   if(str[0]=='0')
    global.symmetric_puzzleF=FALSE;
   if(str[0]=='1')
    global.g_hidden_unique_candidate=FALSE;
   if(str[0]=='2')
    global.g_block_interaction_with_row_and_column=FALSE;
   if(str[0]=='3')
    global.g_row_and_column_interaction_with_block=FALSE;
   if(str[0]=='4')
    global.g_visible_doublets_triplets_etc=FALSE;
   if(str[0]=='5')
    global.g_block_block_interaction=FALSE;
   if(str[0]=='6')
    global.g_hidden_doublets_triplets_etc=FALSE;
   if(str[0]=='7')
    global.g_xwing=FALSE;
   if(str[0]=='8')
    global.g_swordfish=FALSE;
    
 }

}

//88check_button_generator8888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_generator88888888888888888888888888888888888888888888888888888888888888888

void settings_stuff_generator(GtkWidget *generator_widget)
{
  
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *table2;  
  GtkWidget *label;
  GtkWidget *vbox;
//  GtkWidget *check_box;
  char str[12];
  short tmp_val;
  short len,i;
   
  frame=gtk_frame_new( "Generator" );
  gtk_box_pack_start (GTK_BOX (generator_widget), frame, FALSE, TRUE, 0);

  vbox=gtk_vbox_new(FALSE,0); 
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 0);
  gtk_container_add(GTK_CONTAINER(frame),vbox);

 
  
  table = gtk_table_new (2, 1, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, TRUE, 0);
  gtk_table_set_row_spacing(GTK_TABLE(table),0,8);

  
  table2 = gtk_table_new (1, 2, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table2),0);
  gtk_table_attach (GTK_TABLE (table), table2, 0, 1, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_table_set_col_spacings (GTK_TABLE (table2),14);
  
  label=gtk_label_new(" Guess threshold");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach (GTK_TABLE (table2), label, 0, 1, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(label);
  
  tmps->gentext_entry=gtk_entry_new();
  gtk_table_attach (GTK_TABLE (table2),tmps->gentext_entry, 1, 2, 0, 1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show(tmps->gentext_entry);
  
  tmp_val=global.guess_threshold;
  len=0;
  while(tmp_val>0)
  {
    tmp_val=tmp_val/10;
    len=len+1;
  }
  
  tmp_val=global.guess_threshold;
  for(i=len-1;i>=0;i--)
  {
    str[i]=48+tmp_val%10;  
    tmp_val=tmp_val/10;
  }
  str[len]='\0';
  gtk_entry_set_text(GTK_ENTRY(tmps->gentext_entry), (const char*)str);

  g_signal_connect (G_OBJECT (tmps->gentext_entry), "focus_out_event",G_CALLBACK (change_threshold),NULL);
  g_signal_connect (G_OBJECT (tmps->gentext_entry), "key_press_event",G_CALLBACK (key_change_threshold),NULL);
  gtk_widget_show(table2);
  
  
  table2 = gtk_table_new (1, 2, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table2),0);
  gtk_table_attach (GTK_TABLE (table), table2, 0, 1, 1, 2,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  
  tmps->gencheck_box[0]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table2),tmps->gencheck_box[0], 0, 1, 0, 1, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.symmetric_puzzleF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[0])),TRUE);
  gtk_widget_show(tmps->gencheck_box[0]);
  label=gtk_label_new("generate symmetrical puzzles");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table2), label, 1, 2, 0, 1);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[0]), "toggled", G_CALLBACK (check_button_generator), "0");
  gtk_widget_show(table2);

  gtk_widget_show(table);

  
  
  table = gtk_table_new (8, 2, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, TRUE, 0);
  
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),8);
  
  
  tmps->gencheck_box[1]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[1], 0, 1, 0, 1, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_hidden_unique_candidate==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[1])),TRUE);
  gtk_widget_show(tmps->gencheck_box[1]);
  label=gtk_label_new("hidden unique candidate");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 0, 1);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[1]), "toggled", G_CALLBACK (check_button_generator), "1");

  
  
    
  tmps->gencheck_box[2]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[2], 0, 1, 1, 2, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_block_interaction_with_row_and_column==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[2])),TRUE);
  gtk_widget_show(tmps->gencheck_box[2]);
  label=gtk_label_new("block interaction with row and column");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 1, 2);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[2]), "toggled", G_CALLBACK (check_button_generator), "2");

  
    
  tmps->gencheck_box[3]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[3], 0, 1, 2, 3, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_row_and_column_interaction_with_block==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[3])),TRUE);
  gtk_widget_show(tmps->gencheck_box[3]);
  label=gtk_label_new("row and column interaction with block");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 2, 3);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[3]), "toggled", G_CALLBACK (check_button_generator), "3");

  
    
  
  tmps->gencheck_box[4]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[4], 0, 1, 3, 4, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_visible_doublets_triplets_etc==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[4])),TRUE);
  gtk_widget_show(tmps->gencheck_box[4]);
  label=gtk_label_new("visible doublets triplets etc");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 3, 4);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[4]), "toggled", G_CALLBACK (check_button_generator), "4");

  
    
 
  tmps->gencheck_box[5]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[5], 0, 1, 4, 5, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_block_block_interaction==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[5])),TRUE);
  gtk_widget_show(tmps->gencheck_box[5]);
  label=gtk_label_new("block block interaction");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 4, 5);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[5]), "toggled", G_CALLBACK (check_button_generator), "5");

  
    
  
  tmps->gencheck_box[6]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[6], 0, 1, 5, 6, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_hidden_doublets_triplets_etc==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[6])),TRUE);
  gtk_widget_show(tmps->gencheck_box[6]);
  label=gtk_label_new("hidden doublets triplets etc");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 5, 6);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[6]), "toggled", G_CALLBACK (check_button_generator), "6");

  
    

  tmps->gencheck_box[7]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[7], 0, 1, 6, 7, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_xwing==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[7])),TRUE);
  gtk_widget_show(tmps->gencheck_box[7]);
  label=gtk_label_new("xwing");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 6, 7);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[7]), "toggled", G_CALLBACK (check_button_generator), "7");

  
    
  
  
    
  tmps->gencheck_box[8]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->gencheck_box[8], 0, 1, 7, 8, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.g_swordfish==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->gencheck_box[8])),TRUE);
  gtk_widget_show(tmps->gencheck_box[8]);
  label=gtk_label_new("swordfish");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 7, 8);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->gencheck_box[8]), "toggled", G_CALLBACK (check_button_generator), "8");

  
    

 gtk_widget_show(table);
 gtk_widget_show(vbox);
 gtk_widget_show(frame);

}


//88settings_stuff_generator88888888888888888888888888888888888888888888888888888888888888888
//88check_button_solver8888888888888888888888888888888888888888888888888888888888888888888888

void check_button_solver (GtkWidget *widget, gpointer data)
{
 
  char str[2];
  strcpy(str,(gchar *) data);
    
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GTK_CHECK_BUTTON(widget)))  ) 
  {
   
    if(str[0]=='0')
      global.s_hidden_unique_candidate=TRUE;
    if(str[0]=='1')
      global.s_block_interaction_with_row_and_column=TRUE;
    if(str[0]=='2')
      global.s_row_and_column_interaction_with_block=TRUE;
    if(str[0]=='3')
      global.s_visible_doublets_triplets_etc=TRUE;
    if(str[0]=='4')
      global.s_block_block_interaction=TRUE;
    if(str[0]=='5')
      global.s_xwing=TRUE;
    if(str[0]=='6')
      global.s_hidden_doublets_triplets_etc=TRUE;
    if(str[0]=='7')
      global.s_swordfish=TRUE;
  } 
  else 
  {
    if(str[0]=='0')
      global.s_hidden_unique_candidate=FALSE;
    if(str[0]=='1')
      global.s_block_interaction_with_row_and_column=FALSE;
    if(str[0]=='2')
      global.s_row_and_column_interaction_with_block=FALSE;
    if(str[0]=='3')
      global.s_visible_doublets_triplets_etc=FALSE;
    if(str[0]=='4')
      global.s_block_block_interaction=FALSE;
    if(str[0]=='5')
      global.s_xwing=FALSE;
    if(str[0]=='6')
      global.s_hidden_doublets_triplets_etc=FALSE;
    if(str[0]=='7')
      global.s_swordfish=FALSE;
      
  }


}

//88check_button_solver8888888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_solver88888888888888888888888888888888888888888888888888888888888888888888

void settings_stuff_solver(GtkWidget *solver_widget)
{
  
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *label;
//  GtkWidget *check_box;
 
  frame=gtk_frame_new( "Solver" );
  gtk_box_pack_start (GTK_BOX (solver_widget), frame, FALSE, TRUE, 0);

  table = gtk_table_new (8, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),8);

  
   
 
  tmps->solcheck_box[0]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[0], 0, 1, 0, 1, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_hidden_unique_candidate==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[0])),TRUE);
  gtk_widget_show(tmps->solcheck_box[0]);
  label=gtk_label_new("hidden unique candidate");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 0, 1);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[0]), "toggled", G_CALLBACK (check_button_solver), "0");
  
 

    
  tmps->solcheck_box[1]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[1], 0, 1, 1, 2, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_block_interaction_with_row_and_column==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[1])),TRUE);
  gtk_widget_show(tmps->solcheck_box[1]);
  label=gtk_label_new("block interaction with row and column");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 1, 2);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[1]), "toggled", G_CALLBACK (check_button_solver), "1");
  
 
 
   
  tmps->solcheck_box[2]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[2], 0, 1, 2, 3, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_row_and_column_interaction_with_block==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[2])),TRUE);
  gtk_widget_show(tmps->solcheck_box[2]);
  label=gtk_label_new("row and column interaction with block");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 2, 3);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[2]), "toggled", G_CALLBACK (check_button_solver), "2");
  
 

    
  tmps->solcheck_box[3]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[3], 0, 1, 3, 4, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_visible_doublets_triplets_etc==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[3])),TRUE);
  gtk_widget_show(tmps->solcheck_box[3]);
  label=gtk_label_new("visible doublets triplets etc");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 3, 4);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[3]), "toggled", G_CALLBACK (check_button_solver), "3");
  
 

   
  tmps->solcheck_box[4]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[4], 0, 1, 4, 5, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_block_block_interaction==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[4])),TRUE);
  gtk_widget_show(tmps->solcheck_box[4]);
  label=gtk_label_new("block block interaction");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 4, 5);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[4]), "toggled", G_CALLBACK (check_button_solver), "4");
  
 

    
  tmps->solcheck_box[5]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[5], 0, 1, 5, 6, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_xwing==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[5])),TRUE);
  gtk_widget_show(tmps->solcheck_box[5]);
  label=gtk_label_new("xwing");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 5, 6);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[5]), "toggled", G_CALLBACK (check_button_solver), "5");
  
 

    
  tmps->solcheck_box[6]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[6], 0, 1, 6, 7, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_hidden_doublets_triplets_etc==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[6])),TRUE);
  gtk_widget_show(tmps->solcheck_box[6]);
  label=gtk_label_new("hidden doublets triplets etc");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 6, 7);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[6]), "toggled", G_CALLBACK (check_button_solver), "6");
  
 

    
  tmps->solcheck_box[7]=gtk_check_button_new ();
  gtk_table_attach (GTK_TABLE (table),tmps->solcheck_box[7], 0, 1, 7, 8, GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  if(global.s_swordfish==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->solcheck_box[7])),TRUE);
  gtk_widget_show(tmps->solcheck_box[7]);
  label=gtk_label_new("swordfish");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table), label, 1, 2, 7, 8);
  gtk_widget_show(label);
  g_signal_connect (G_OBJECT (tmps->solcheck_box[7]), "toggled", G_CALLBACK (check_button_solver), "7");
  
 
  gtk_widget_show(table);
  gtk_widget_show(frame);

}

//88settings_stuff_solver88888888888888888888888888888888888888888888888888888888888888888888
//88change_pcheckbox8888888888888888888888888888888888888888888888888888888888888888888888888

void change_pcheckbox(GtkWidget *widget, gpointer data)
{

  char str[2];
  strcpy(str,(gchar *) data);

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GTK_CHECK_BUTTON(widget)))  ) 
  {
   
    if(str[0]=='0')
    {
      global.show_status_barF=TRUE;
      gtk_widget_show(status_bar);
//    gtk_window_resize(GTK_WINDOW(gs_main_window),10, 10);
    } 
    
    if(str[0]=='1')
      global.show_splash_screenF=TRUE;
    if(str[0]=='2')
      global.show_tips_and_tricksF=TRUE;
    if(str[0]=='3')
      global.key_movement_fixed_box_no_limit=TRUE;
    if(str[0]=='4')
      global.key_movement_restrictive=TRUE;
    if(str[0]=='5')
      global.show_figures_while_solving=TRUE;
    if(str[0]=='6')
      global.show_console_messegesF=TRUE;
    if(str[0]=='7')
      global.editor_check_puzzle_validity=TRUE;
    if(str[0]=='8')
    {
      global.auto_pencil_in_remove=TRUE;
      gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoRemovePencilin")),TRUE);
    } 
    if(str[0]=='9')
    {
      global.check_for_conflictF=TRUE;
      gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoCheckConflicts")),TRUE);
    } 
    if(str[0]=='a')
      global.consider_doubt_text_as_confirm_textF=TRUE;
    if(str[0]=='b')
      global.treat_doubt_as_pencil_in=TRUE;
 
  } 
  else 
  {
    if(str[0]=='0')
    {
      global.show_status_barF=FALSE;
      gtk_widget_hide(status_bar);
      gtk_window_resize(GTK_WINDOW(gs_main_window),10, 10);
    }
    if(str[0]=='1')
      global.show_splash_screenF=FALSE;
    if(str[0]=='2')
      global.show_tips_and_tricksF=FALSE;
    if(str[0]=='3')
      global.key_movement_fixed_box_no_limit=FALSE;
    if(str[0]=='4')
      global.key_movement_restrictive=FALSE;
    if(str[0]=='5')
      global.show_figures_while_solving=FALSE;
    if(str[0]=='6')
      global.show_console_messegesF=FALSE;
    if(str[0]=='7')
      global.editor_check_puzzle_validity=FALSE;
    if(str[0]=='8')
    {
      global.auto_pencil_in_remove=FALSE;
      gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoRemovePencilin")),FALSE);
    } 
    if(str[0]=='9')
    {
      global.check_for_conflictF=FALSE;
      gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoCheckConflicts")),FALSE);
    } 
    if(str[0]=='a')
      global.consider_doubt_text_as_confirm_textF=FALSE;
    if(str[0]=='b')
      global.treat_doubt_as_pencil_in=FALSE;
      
  }
 
 

}

//88change_pcheckbox8888888888888888888888888888888888888888888888888888888888888888888888888
//88change_psticky888888888888888888888888888888888888888888888888888888888888888888888888888

void change_psticky(GtkWidget *widget, gpointer data)
{

  char str[2];
  strcpy(str,(gchar *) data);


  if(str[0]=='0')
    sticky_selection=1;
 
  if(str[0]=='1')
    sticky_selection=2;
 
  if(str[0]=='2')
    sticky_selection=3;


}


//88change_psticky888888888888888888888888888888888888888888888888888888888888888888888888888
//88change_ptbar88888888888888888888888888888888888888888888888888888888888888888888888888888

void change_ptbar(GtkWidget *widget, gpointer data)
{

  char str[2];
  strcpy(str,(gchar *) data);

//  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (GTK_RADIO_BUTTON(widget)));

  if(str[0]=='0')
  {
    gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_ICONS);
    toolbar_mode=1;
  }
  if(str[0]=='1')
  {  
    gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_TEXT);
    toolbar_mode=2;
  }
  if(str[0]=='2')
  {  
    gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_BOTH);
    toolbar_mode=3;
  }

  gtk_window_resize(GTK_WINDOW(gs_main_window),10, 10);

 
}


//88change_ptbar88888888888888888888888888888888888888888888888888888888888888888888888888888
//88settings_stuff_preference8888888888888888888888888888888888888888888888888888888888888888

void settings_stuff_preference(GtkWidget *preference_widget)
{
   
  GtkWidget *label;
  GtkWidget *table; 
  GtkWidget *table2;
  GtkWidget *text_entry;
//  GtkWidget *radio_button;
//  GtkWidget *check_button;
  GtkWidget *frame;
 
  GSList *group1;
  GSList *group2; 
  
  frame=gtk_frame_new( "Widget display preference" );
  gtk_box_pack_start (GTK_BOX (preference_widget), frame, FALSE, TRUE, 0);

 
  table = gtk_table_new (4, 1, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),8);
  gtk_table_set_row_spacing(GTK_TABLE(table),0,2);
  
  table2 = gtk_table_new (1, 4, FALSE);
  gtk_table_attach_defaults (GTK_TABLE (table), table2, 0, 1, 0, 1);
  gtk_container_set_border_width(GTK_CONTAINER(table2),0);

  label=gtk_label_new("Toolbar");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table2), label, 0, 1, 0, 1);
  gtk_widget_show(label);

    
  tmps->pradio_tbar[0] = gtk_radio_button_new_with_label (NULL, "icon only");
  gtk_table_attach_defaults (GTK_TABLE (table2), tmps->pradio_tbar[0], 1, 2, 0, 1);
  gtk_widget_show (tmps->pradio_tbar[0]);
  group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (tmps->pradio_tbar[0]));
  g_signal_connect (G_OBJECT (tmps->pradio_tbar[0]), "toggled", G_CALLBACK (change_ptbar), "0");
 
  tmps->pradio_tbar[1] = gtk_radio_button_new_with_label (group1, "text only");
  gtk_table_attach_defaults (GTK_TABLE (table2), tmps->pradio_tbar[1], 2, 3, 0, 1);
  gtk_widget_show (tmps->pradio_tbar[1]);
  group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (tmps->pradio_tbar[1]));
  g_signal_connect (G_OBJECT (tmps->pradio_tbar[1]), "toggled", G_CALLBACK (change_ptbar), "1");
 
  tmps->pradio_tbar[2] = gtk_radio_button_new_with_label (group1, "both");
  gtk_table_attach_defaults (GTK_TABLE (table2), tmps->pradio_tbar[2], 3, 4, 0, 1);
  gtk_widget_show (tmps->pradio_tbar[2]);
  g_signal_connect (G_OBJECT (tmps->pradio_tbar[2]), "toggled", G_CALLBACK (change_ptbar), "2");
 
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->pradio_tbar[toolbar_mode-1]), TRUE);
  gtk_widget_show (table2);

  tmps->pcheck_box[0]=gtk_check_button_new_with_label("Show status bar");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[0], 0, 1, 1, 2);
  if(global.show_status_barF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[0])),TRUE);
  gtk_widget_show (tmps->pcheck_box[0]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[0]), "toggled", G_CALLBACK (change_pcheckbox), "0");
  
  tmps->pcheck_box[1]=gtk_check_button_new_with_label("Show splash screen at start up");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[1], 0, 1, 2, 3);
  if(global.show_splash_screenF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[1])),TRUE);
  gtk_widget_show (tmps->pcheck_box[1]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[1]), "toggled", G_CALLBACK (change_pcheckbox), "1");
 
  tmps->pcheck_box[2]=gtk_check_button_new_with_label("Show tips and tricks at start up");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[2], 0, 1, 3, 4);
  if(global.show_tips_and_tricksF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[2])),TRUE);
  gtk_widget_show (tmps->pcheck_box[2]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[2]), "toggled", G_CALLBACK (change_pcheckbox), "2");
 
 
  gtk_widget_show (table);
  gtk_widget_show (frame);
 
 
 
  frame=gtk_frame_new( "Mouse and keyboard preference" );
  gtk_box_pack_start (GTK_BOX (preference_widget), frame, FALSE, TRUE, 0);

 
  table = gtk_table_new (3, 1, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),8);
  gtk_table_set_row_spacing(GTK_TABLE(table),0,2);
  
  table2 = gtk_table_new (1, 4, FALSE);
  gtk_table_attach_defaults (GTK_TABLE (table), table2, 0, 1, 0, 1);
  gtk_container_set_border_width(GTK_CONTAINER(table2),0);
  
  label=gtk_label_new("Sticky clicks");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach_defaults (GTK_TABLE (table2), label, 0, 1, 0, 1);
  gtk_widget_show(label);

  tmps->pradio_sticky[0] = gtk_radio_button_new_with_label (NULL, "Yes");
  gtk_table_attach_defaults (GTK_TABLE (table2), tmps->pradio_sticky[0], 1, 2, 0, 1);
  gtk_widget_show (tmps->pradio_sticky[0]);
  group2 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (tmps->pradio_sticky[0]));
  g_signal_connect (G_OBJECT (tmps->pradio_sticky[0]), "toggled", G_CALLBACK (change_psticky), "0");
    
  tmps->pradio_sticky[1] = gtk_radio_button_new_with_label (group2, "No");
  gtk_table_attach_defaults (GTK_TABLE (table2), tmps->pradio_sticky[1], 2, 3, 0, 1);
  gtk_widget_show (tmps->pradio_sticky[1]);
  group2 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (tmps->pradio_sticky[1]));
  g_signal_connect (G_OBJECT (tmps->pradio_sticky[1]), "toggled", G_CALLBACK (change_psticky), "1");
 
  tmps->pradio_sticky[2] = gtk_radio_button_new_with_label (group2, "Partial");
  gtk_table_attach_defaults (GTK_TABLE (table2), tmps->pradio_sticky[2], 3, 4, 0, 1);
  gtk_widget_show (tmps->pradio_sticky[2]);
  g_signal_connect (G_OBJECT (tmps->pradio_sticky[2]), "toggled", G_CALLBACK (change_psticky), "2");

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmps->pradio_sticky[sticky_selection-1]), TRUE);
  gtk_widget_show (table2);
   
  tmps->pcheck_box[3]=gtk_check_button_new_with_label("keyboard cursor move over fixed box");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[3], 0, 1, 1, 2);
  if(global.key_movement_fixed_box_no_limit==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[3])),TRUE);
  gtk_widget_show (tmps->pcheck_box[3]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[3]), "toggled", G_CALLBACK (change_pcheckbox), "3");


  tmps->pcheck_box[4]=gtk_check_button_new_with_label("keyboard cursor border restriction");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[4], 0, 1, 2, 3);
  if(global.key_movement_restrictive==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[4])),TRUE);
  gtk_widget_show (tmps->pcheck_box[4]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[4]), "toggled", G_CALLBACK (change_pcheckbox), "4");
    
    
  gtk_widget_show (table);
  gtk_widget_show (frame);
  
  
  frame=gtk_frame_new( "Solver preference" );
  gtk_box_pack_start (GTK_BOX (preference_widget), frame, FALSE, TRUE, 0);

 
  table = gtk_table_new (2, 1, FALSE);
  gtk_container_add(GTK_CONTAINER(frame),table);
  gtk_container_set_border_width(GTK_CONTAINER(table),8);
  gtk_table_set_row_spacing(GTK_TABLE(table),0,2);
  
  tmps->pcheck_box[5]=gtk_check_button_new_with_label("draw figures while computer solving");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[5], 0, 1, 0, 1);
  if(global.show_figures_while_solving==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[5])),TRUE);
  gtk_widget_show (tmps->pcheck_box[5]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[5]), "toggled", G_CALLBACK (change_pcheckbox), "5");


  tmps->pcheck_box[6]=gtk_check_button_new_with_label("show console messages");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[6], 0, 1, 1, 2);
  if(global.show_console_messegesF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[6])),TRUE);
  gtk_widget_show (tmps->pcheck_box[6]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[6]), "toggled", G_CALLBACK (change_pcheckbox), "6");
    
  gtk_widget_show (table);
  gtk_widget_show (frame);
  
  table = gtk_table_new (5, 1, FALSE);
  gtk_box_pack_start (GTK_BOX (preference_widget),table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),12);
  gtk_table_set_row_spacings (GTK_TABLE (table),3);




  tmps->pcheck_box[7]=gtk_check_button_new_with_label("check puzzle validity for created puzzle");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[7], 0, 1, 0, 1);
  if(global.editor_check_puzzle_validity==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[7])),TRUE);
  gtk_widget_show (tmps->pcheck_box[7]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[7]), "toggled", G_CALLBACK (change_pcheckbox), "7");


  tmps->pcheck_box[8]=gtk_check_button_new_with_label("automatically remove pencil in");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[8], 0, 1, 1, 2);
  if(global.auto_pencil_in_remove==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[8])),TRUE);
  gtk_widget_show (tmps->pcheck_box[8]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[8]), "toggled", G_CALLBACK (change_pcheckbox), "8");


  tmps->pcheck_box[9]=gtk_check_button_new_with_label("check for conflicts while keying");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[9], 0, 1, 2, 3);
  if(global.check_for_conflictF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[9])),TRUE);
  gtk_widget_show (tmps->pcheck_box[9]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[9]), "toggled", G_CALLBACK (change_pcheckbox), "9");


  tmps->pcheck_box[10]=gtk_check_button_new_with_label("assume doubt text as confirmed text");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[10], 0, 1, 3, 4);
  if(global.consider_doubt_text_as_confirm_textF==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[10])),TRUE);
  gtk_widget_show (tmps->pcheck_box[10]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[10]), "toggled", G_CALLBACK (change_pcheckbox), "a");

    
  tmps->pcheck_box[11]=gtk_check_button_new_with_label("use doubt text for pencil in");
  gtk_table_attach_defaults (GTK_TABLE (table), tmps->pcheck_box[11], 0, 1, 4, 5);
  if(global.treat_doubt_as_pencil_in==TRUE)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(GTK_CHECK_BUTTON(tmps->pcheck_box[11])),TRUE);
  gtk_widget_show (tmps->pcheck_box[11]);
  g_signal_connect (G_OBJECT (tmps->pcheck_box[11]), "toggled", G_CALLBACK (change_pcheckbox), "b");

  gtk_widget_show (table);
 
}

//88settings_stuff_preference8888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888

